/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AgentVersionControlProfile', 'model/AgentVersionControlProfiles'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/AgentVersionControlProfile'), require('../model/AgentVersionControlProfiles'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.AgentVersionControlProfilesApi = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.AgentVersionControlProfile, root.Deepsecurity.AgentVersionControlProfiles);
  }
}(this, function(ApiClient, AgentVersionControlProfile, AgentVersionControlProfiles) {
  'use strict';

  /**
   * AgentVersionControlProfiles service.
   * @module api/AgentVersionControlProfilesApi
   * @version 12.5.855
   */

  /**
   * Constructs a new AgentVersionControlProfilesApi. 
   * @alias module:api/AgentVersionControlProfilesApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Describe an agent version control profile
     * Describe an Agent Version Control Profile by ID.
     * @param {Number} agentVersionControlProfileID The ID number of the agent version control profile to describe.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/AgentVersionControlProfile} and HTTP response
     */
    this.describeAgentVersionControlProfileWithHttpInfo = function(agentVersionControlProfileID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'agentVersionControlProfileID' is set
      if (agentVersionControlProfileID === undefined || agentVersionControlProfileID === null) {
        throw new Error("Missing the required parameter 'agentVersionControlProfileID' when calling describeAgentVersionControlProfile");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling describeAgentVersionControlProfile");
      }


      var pathParams = {
        'agentVersionControlProfileID': agentVersionControlProfileID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = AgentVersionControlProfile;

      return this.apiClient.callApi(
        '/agentversioncontrolprofiles/{agentVersionControlProfileID}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Describe an agent version control profile
     * Describe an Agent Version Control Profile by ID.
     * @param {Number} agentVersionControlProfileID The ID number of the agent version control profile to describe.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/AgentVersionControlProfile}
     */
    this.describeAgentVersionControlProfile = function(agentVersionControlProfileID, apiVersion) {
      return this.describeAgentVersionControlProfileWithHttpInfo(agentVersionControlProfileID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List agent version control profiles
     * Lists all agent version control profiles.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/AgentVersionControlProfiles} and HTTP response
     */
    this.listAgentVersionControlProfilesWithHttpInfo = function(apiVersion) {
      var postBody = null;

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling listAgentVersionControlProfiles");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = AgentVersionControlProfiles;

      return this.apiClient.callApi(
        '/agentversioncontrolprofiles', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List agent version control profiles
     * Lists all agent version control profiles.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/AgentVersionControlProfiles}
     */
    this.listAgentVersionControlProfiles = function(apiVersion) {
      return this.listAgentVersionControlProfilesWithHttpInfo(apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
