/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/EventBasedTask', 'model/EventBasedTasks', 'model/SearchFilter'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/EventBasedTask'), require('../model/EventBasedTasks'), require('../model/SearchFilter'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.EventBasedTasksApi = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.EventBasedTask, root.Deepsecurity.EventBasedTasks, root.Deepsecurity.SearchFilter);
  }
}(this, function(ApiClient, EventBasedTask, EventBasedTasks, SearchFilter) {
  'use strict';

  /**
   * EventBasedTasks service.
   * @module api/EventBasedTasksApi
   * @version 12.5.855
   */

  /**
   * Constructs a new EventBasedTasksApi. 
   * @alias module:api/EventBasedTasksApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create an Event Based Task
     * Create a new event based task.
     * @param {module:model/EventBasedTask} eventBasedTask The settings of the new event based task.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/EventBasedTask} and HTTP response
     */
    this.createEventBasedTaskWithHttpInfo = function(eventBasedTask, apiVersion) {
      var postBody = eventBasedTask;

      // verify the required parameter 'eventBasedTask' is set
      if (eventBasedTask === undefined || eventBasedTask === null) {
        throw new Error("Missing the required parameter 'eventBasedTask' when calling createEventBasedTask");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling createEventBasedTask");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = EventBasedTask;

      return this.apiClient.callApi(
        '/eventbasedtasks', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create an Event Based Task
     * Create a new event based task.
     * @param {module:model/EventBasedTask} eventBasedTask The settings of the new event based task.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/EventBasedTask}
     */
    this.createEventBasedTask = function(eventBasedTask, apiVersion) {
      return this.createEventBasedTaskWithHttpInfo(eventBasedTask, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Delete an Event Based Task
     * Delete an event based task by ID.
     * @param {Number} eventBasedTaskID The ID number of the event based task to delete.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing HTTP response
     */
    this.deleteEventBasedTaskWithHttpInfo = function(eventBasedTaskID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'eventBasedTaskID' is set
      if (eventBasedTaskID === undefined || eventBasedTaskID === null) {
        throw new Error("Missing the required parameter 'eventBasedTaskID' when calling deleteEventBasedTask");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling deleteEventBasedTask");
      }


      var pathParams = {
        'eventBasedTaskID': eventBasedTaskID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/eventbasedtasks/{eventBasedTaskID}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Delete an Event Based Task
     * Delete an event based task by ID.
     * @param {Number} eventBasedTaskID The ID number of the event based task to delete.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}
     */
    this.deleteEventBasedTask = function(eventBasedTaskID, apiVersion) {
      return this.deleteEventBasedTaskWithHttpInfo(eventBasedTaskID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Describe an Event Based Task
     * Describe an event based task by ID.
     * @param {Number} eventBasedTaskID The ID number of the event based task to describe.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/EventBasedTask} and HTTP response
     */
    this.describeEventBasedTaskWithHttpInfo = function(eventBasedTaskID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'eventBasedTaskID' is set
      if (eventBasedTaskID === undefined || eventBasedTaskID === null) {
        throw new Error("Missing the required parameter 'eventBasedTaskID' when calling describeEventBasedTask");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling describeEventBasedTask");
      }


      var pathParams = {
        'eventBasedTaskID': eventBasedTaskID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = EventBasedTask;

      return this.apiClient.callApi(
        '/eventbasedtasks/{eventBasedTaskID}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Describe an Event Based Task
     * Describe an event based task by ID.
     * @param {Number} eventBasedTaskID The ID number of the event based task to describe.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/EventBasedTask}
     */
    this.describeEventBasedTask = function(eventBasedTaskID, apiVersion) {
      return this.describeEventBasedTaskWithHttpInfo(eventBasedTaskID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List Event Based Tasks
     * Lists all event based tasks.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/EventBasedTasks} and HTTP response
     */
    this.listEventBasedTasksWithHttpInfo = function(apiVersion) {
      var postBody = null;

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling listEventBasedTasks");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = EventBasedTasks;

      return this.apiClient.callApi(
        '/eventbasedtasks', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List Event Based Tasks
     * Lists all event based tasks.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/EventBasedTasks}
     */
    this.listEventBasedTasks = function(apiVersion) {
      return this.listEventBasedTasksWithHttpInfo(apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Modify an Event Based Task
     * Modify an event based task by ID. Any unset elements will be left unchanged.
     * @param {Number} eventBasedTaskID The ID number of the event based task to modify.
     * @param {module:model/EventBasedTask} eventBasedTask The settings of the event based task to modify.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/EventBasedTask} and HTTP response
     */
    this.modifyEventBasedTaskWithHttpInfo = function(eventBasedTaskID, eventBasedTask, apiVersion) {
      var postBody = eventBasedTask;

      // verify the required parameter 'eventBasedTaskID' is set
      if (eventBasedTaskID === undefined || eventBasedTaskID === null) {
        throw new Error("Missing the required parameter 'eventBasedTaskID' when calling modifyEventBasedTask");
      }

      // verify the required parameter 'eventBasedTask' is set
      if (eventBasedTask === undefined || eventBasedTask === null) {
        throw new Error("Missing the required parameter 'eventBasedTask' when calling modifyEventBasedTask");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling modifyEventBasedTask");
      }


      var pathParams = {
        'eventBasedTaskID': eventBasedTaskID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = EventBasedTask;

      return this.apiClient.callApi(
        '/eventbasedtasks/{eventBasedTaskID}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Modify an Event Based Task
     * Modify an event based task by ID. Any unset elements will be left unchanged.
     * @param {Number} eventBasedTaskID The ID number of the event based task to modify.
     * @param {module:model/EventBasedTask} eventBasedTask The settings of the event based task to modify.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/EventBasedTask}
     */
    this.modifyEventBasedTask = function(eventBasedTaskID, eventBasedTask, apiVersion) {
      return this.modifyEventBasedTaskWithHttpInfo(eventBasedTaskID, eventBasedTask, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Search Event Based Tasks
     * Search for event based tasks using optional filters.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {module:model/SearchFilter} opts.searchFilter A collection of options used to filter the search results.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/EventBasedTasks} and HTTP response
     */
    this.searchEventBasedTasksWithHttpInfo = function(apiVersion, opts) {
      opts = opts || {};
      var postBody = opts['searchFilter'];

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling searchEventBasedTasks");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = EventBasedTasks;

      return this.apiClient.callApi(
        '/eventbasedtasks/search', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Search Event Based Tasks
     * Search for event based tasks using optional filters.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {module:model/SearchFilter} opts.searchFilter A collection of options used to filter the search results.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/EventBasedTasks}
     */
    this.searchEventBasedTasks = function(apiVersion, opts) {
      return this.searchEventBasedTasksWithHttpInfo(apiVersion, opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
