/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Action'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/Action'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.GCPConnectorActionsApi = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.Action);
  }
}(this, function(ApiClient, Action) {
  'use strict';

  /**
   * GCPConnectorActions service.
   * @module api/GCPConnectorActionsApi
   * @version 12.5.855
   */

  /**
   * Constructs a new GCPConnectorActionsApi. 
   * @alias module:api/GCPConnectorActionsApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create a connector action
     * Create a connector action by connector ID.
     * @param {Number} gcpConnectorID The ID number of the GCP Connector.
     * @param {module:model/Action} gcpConnectorAction The property of the new GCP Connector action.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/Action} and HTTP response
     */
    this.createGCPConnectorActionWithHttpInfo = function(gcpConnectorID, gcpConnectorAction, apiVersion) {
      var postBody = gcpConnectorAction;

      // verify the required parameter 'gcpConnectorID' is set
      if (gcpConnectorID === undefined || gcpConnectorID === null) {
        throw new Error("Missing the required parameter 'gcpConnectorID' when calling createGCPConnectorAction");
      }

      // verify the required parameter 'gcpConnectorAction' is set
      if (gcpConnectorAction === undefined || gcpConnectorAction === null) {
        throw new Error("Missing the required parameter 'gcpConnectorAction' when calling createGCPConnectorAction");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling createGCPConnectorAction");
      }


      var pathParams = {
        'gcpConnectorID': gcpConnectorID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = Action;

      return this.apiClient.callApi(
        '/gcpconnectors/{gcpConnectorID}/actions', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create a connector action
     * Create a connector action by connector ID.
     * @param {Number} gcpConnectorID The ID number of the GCP Connector.
     * @param {module:model/Action} gcpConnectorAction The property of the new GCP Connector action.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/Action}
     */
    this.createGCPConnectorAction = function(gcpConnectorID, gcpConnectorAction, apiVersion) {
      return this.createGCPConnectorActionWithHttpInfo(gcpConnectorID, gcpConnectorAction, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Describe a connector action
     * Describe a connector action by connector ID and action ID.
     * @param {Number} gcpConnectorID The ID number of the GCP Connector.
     * @param {Number} actionID The ID number of the GCP Connector action.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/Action} and HTTP response
     */
    this.describeGCPConnectorActionWithHttpInfo = function(gcpConnectorID, actionID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'gcpConnectorID' is set
      if (gcpConnectorID === undefined || gcpConnectorID === null) {
        throw new Error("Missing the required parameter 'gcpConnectorID' when calling describeGCPConnectorAction");
      }

      // verify the required parameter 'actionID' is set
      if (actionID === undefined || actionID === null) {
        throw new Error("Missing the required parameter 'actionID' when calling describeGCPConnectorAction");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling describeGCPConnectorAction");
      }


      var pathParams = {
        'gcpConnectorID': gcpConnectorID,
        'actionID': actionID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = Action;

      return this.apiClient.callApi(
        '/gcpconnectors/{gcpConnectorID}/actions/{actionID}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Describe a connector action
     * Describe a connector action by connector ID and action ID.
     * @param {Number} gcpConnectorID The ID number of the GCP Connector.
     * @param {Number} actionID The ID number of the GCP Connector action.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/Action}
     */
    this.describeGCPConnectorAction = function(gcpConnectorID, actionID, apiVersion) {
      return this.describeGCPConnectorActionWithHttpInfo(gcpConnectorID, actionID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
