/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/GCPConnector', 'model/GCPConnectors', 'model/SearchFilter'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/GCPConnector'), require('../model/GCPConnectors'), require('../model/SearchFilter'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.GCPConnectorsApi = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.GCPConnector, root.Deepsecurity.GCPConnectors, root.Deepsecurity.SearchFilter);
  }
}(this, function(ApiClient, GCPConnector, GCPConnectors, SearchFilter) {
  'use strict';

  /**
   * GCPConnectors service.
   * @module api/GCPConnectorsApi
   * @version 12.5.855
   */

  /**
   * Constructs a new GCPConnectorsApi. 
   * @alias module:api/GCPConnectorsApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create a GCP Connector
     * Create a new GCP Connector.
     * @param {module:model/GCPConnector} gcpConnector The settings of the new GCP connector.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/GCPConnector} and HTTP response
     */
    this.createGCPConnectorWithHttpInfo = function(gcpConnector, apiVersion) {
      var postBody = gcpConnector;

      // verify the required parameter 'gcpConnector' is set
      if (gcpConnector === undefined || gcpConnector === null) {
        throw new Error("Missing the required parameter 'gcpConnector' when calling createGCPConnector");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling createGCPConnector");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = GCPConnector;

      return this.apiClient.callApi(
        '/gcpconnectors', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create a GCP Connector
     * Create a new GCP Connector.
     * @param {module:model/GCPConnector} gcpConnector The settings of the new GCP connector.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/GCPConnector}
     */
    this.createGCPConnector = function(gcpConnector, apiVersion) {
      return this.createGCPConnectorWithHttpInfo(gcpConnector, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Delete a GCP Connector
     * Delete a GCP connector by ID.
     * @param {Number} gcpConnectorID ID number of the GCP Connector to be deleted.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing HTTP response
     */
    this.deleteGCPConnectorWithHttpInfo = function(gcpConnectorID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'gcpConnectorID' is set
      if (gcpConnectorID === undefined || gcpConnectorID === null) {
        throw new Error("Missing the required parameter 'gcpConnectorID' when calling deleteGCPConnector");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling deleteGCPConnector");
      }


      var pathParams = {
        'gcpConnectorID': gcpConnectorID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/gcpconnectors/{gcpConnectorID}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Delete a GCP Connector
     * Delete a GCP connector by ID.
     * @param {Number} gcpConnectorID ID number of the GCP Connector to be deleted.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}
     */
    this.deleteGCPConnector = function(gcpConnectorID, apiVersion) {
      return this.deleteGCPConnectorWithHttpInfo(gcpConnectorID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Describe a GCP Connector
     * Describe a GCP connector by ID.
     * @param {Number} gcpConnectorID ID number of the GCP connector to describe.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/GCPConnector} and HTTP response
     */
    this.describeGCPConnectorWithHttpInfo = function(gcpConnectorID, apiVersion) {
      var postBody = null;

      // verify the required parameter 'gcpConnectorID' is set
      if (gcpConnectorID === undefined || gcpConnectorID === null) {
        throw new Error("Missing the required parameter 'gcpConnectorID' when calling describeGCPConnector");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling describeGCPConnector");
      }


      var pathParams = {
        'gcpConnectorID': gcpConnectorID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = GCPConnector;

      return this.apiClient.callApi(
        '/gcpconnectors/{gcpConnectorID}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Describe a GCP Connector
     * Describe a GCP connector by ID.
     * @param {Number} gcpConnectorID ID number of the GCP connector to describe.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/GCPConnector}
     */
    this.describeGCPConnector = function(gcpConnectorID, apiVersion) {
      return this.describeGCPConnectorWithHttpInfo(gcpConnectorID, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List GCP Connectors
     * List all GCP connectors.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/GCPConnectors} and HTTP response
     */
    this.listGCPConnectorsWithHttpInfo = function(apiVersion) {
      var postBody = null;

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling listGCPConnectors");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = GCPConnectors;

      return this.apiClient.callApi(
        '/gcpconnectors', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List GCP Connectors
     * List all GCP connectors.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/GCPConnectors}
     */
    this.listGCPConnectors = function(apiVersion) {
      return this.listGCPConnectorsWithHttpInfo(apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Modify a GCP Connector
     * Modify a GCP connector by ID.
     * @param {Number} gcpConnectorID ID number of the GCP Connector to modify.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {module:model/GCPConnector} opts.gcpConnector The settings of the GCP connector to modify.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/GCPConnector} and HTTP response
     */
    this.modifyGCPConnectorWithHttpInfo = function(gcpConnectorID, apiVersion, opts) {
      opts = opts || {};
      var postBody = opts['gcpConnector'];

      // verify the required parameter 'gcpConnectorID' is set
      if (gcpConnectorID === undefined || gcpConnectorID === null) {
        throw new Error("Missing the required parameter 'gcpConnectorID' when calling modifyGCPConnector");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling modifyGCPConnector");
      }


      var pathParams = {
        'gcpConnectorID': gcpConnectorID
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = GCPConnector;

      return this.apiClient.callApi(
        '/gcpconnectors/{gcpConnectorID}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Modify a GCP Connector
     * Modify a GCP connector by ID.
     * @param {Number} gcpConnectorID ID number of the GCP Connector to modify.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {module:model/GCPConnector} opts.gcpConnector The settings of the GCP connector to modify.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/GCPConnector}
     */
    this.modifyGCPConnector = function(gcpConnectorID, apiVersion, opts) {
      return this.modifyGCPConnectorWithHttpInfo(gcpConnectorID, apiVersion, opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Search GCP Connectors
     * Search for GCP connectors using optional filters.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {module:model/SearchFilter} opts.searchFilter A collection of options used to filter the search results.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/GCPConnectors} and HTTP response
     */
    this.searchGCPConnectorsWithHttpInfo = function(apiVersion, opts) {
      opts = opts || {};
      var postBody = opts['searchFilter'];

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling searchGCPConnectors");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = GCPConnectors;

      return this.apiClient.callApi(
        '/gcpconnectors/search', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Search GCP Connectors
     * Search for GCP connectors using optional filters.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {module:model/SearchFilter} opts.searchFilter A collection of options used to filter the search results.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/GCPConnectors}
     */
    this.searchGCPConnectors = function(apiVersion, opts) {
      return this.searchGCPConnectorsWithHttpInfo(apiVersion, opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
