/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/IntegrityMonitoringRule', 'model/IntegrityMonitoringRules'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/IntegrityMonitoringRule'), require('../model/IntegrityMonitoringRules'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.PolicyIntegrityMonitoringRuleDetailsApi = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.IntegrityMonitoringRule, root.Deepsecurity.IntegrityMonitoringRules);
  }
}(this, function(ApiClient, IntegrityMonitoringRule, IntegrityMonitoringRules) {
  'use strict';

  /**
   * PolicyIntegrityMonitoringRuleDetails service.
   * @module api/PolicyIntegrityMonitoringRuleDetailsApi
   * @version 12.5.855
   */

  /**
   * Constructs a new PolicyIntegrityMonitoringRuleDetailsApi. 
   * @alias module:api/PolicyIntegrityMonitoringRuleDetailsApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Describe an integrity monitoring rule
     * Describe an integrity monitoring rule including policy-level overrides.
     * @param {Number} policyID The ID number of the policy.
     * @param {Number} integrityMonitoringRuleID The ID number of the integrity monitoring rule.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {Boolean} opts.overrides Show only overrides defined for the current policy.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/IntegrityMonitoringRule} and HTTP response
     */
    this.describeIntegrityMonitoringRuleOnPolicyWithHttpInfo = function(policyID, integrityMonitoringRuleID, apiVersion, opts) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'policyID' is set
      if (policyID === undefined || policyID === null) {
        throw new Error("Missing the required parameter 'policyID' when calling describeIntegrityMonitoringRuleOnPolicy");
      }

      // verify the required parameter 'integrityMonitoringRuleID' is set
      if (integrityMonitoringRuleID === undefined || integrityMonitoringRuleID === null) {
        throw new Error("Missing the required parameter 'integrityMonitoringRuleID' when calling describeIntegrityMonitoringRuleOnPolicy");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling describeIntegrityMonitoringRuleOnPolicy");
      }


      var pathParams = {
        'policyID': policyID,
        'integrityMonitoringRuleID': integrityMonitoringRuleID
      };
      var queryParams = {
        'overrides': opts['overrides'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = IntegrityMonitoringRule;

      return this.apiClient.callApi(
        '/policies/{policyID}/integritymonitoring/rules/{integrityMonitoringRuleID}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Describe an integrity monitoring rule
     * Describe an integrity monitoring rule including policy-level overrides.
     * @param {Number} policyID The ID number of the policy.
     * @param {Number} integrityMonitoringRuleID The ID number of the integrity monitoring rule.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {Boolean} opts.overrides Show only overrides defined for the current policy.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/IntegrityMonitoringRule}
     */
    this.describeIntegrityMonitoringRuleOnPolicy = function(policyID, integrityMonitoringRuleID, apiVersion, opts) {
      return this.describeIntegrityMonitoringRuleOnPolicyWithHttpInfo(policyID, integrityMonitoringRuleID, apiVersion, opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List integrity monitoring rules
     * Lists all integrity monitoring rules assigned to a policy.
     * @param {Number} policyID The ID number of the policy.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {Boolean} opts.overrides Show only rules assigned to the current policy.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/IntegrityMonitoringRules} and HTTP response
     */
    this.listIntegrityMonitoringRulesOnPolicyWithHttpInfo = function(policyID, apiVersion, opts) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'policyID' is set
      if (policyID === undefined || policyID === null) {
        throw new Error("Missing the required parameter 'policyID' when calling listIntegrityMonitoringRulesOnPolicy");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling listIntegrityMonitoringRulesOnPolicy");
      }


      var pathParams = {
        'policyID': policyID
      };
      var queryParams = {
        'overrides': opts['overrides'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = IntegrityMonitoringRules;

      return this.apiClient.callApi(
        '/policies/{policyID}/integritymonitoring/rules', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List integrity monitoring rules
     * Lists all integrity monitoring rules assigned to a policy.
     * @param {Number} policyID The ID number of the policy.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {Boolean} opts.overrides Show only rules assigned to the current policy.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/IntegrityMonitoringRules}
     */
    this.listIntegrityMonitoringRulesOnPolicy = function(policyID, apiVersion, opts) {
      return this.listIntegrityMonitoringRulesOnPolicyWithHttpInfo(policyID, apiVersion, opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Modify an integrity monitoring rule
     * Modify an integrity monitoring rule assigned to a policy. Any unset elements will be left unchanged.
     * @param {Number} policyID The ID number of the policy.
     * @param {Number} integrityMonitoringRuleID The ID number of the integrity monitoring rule to modify.
     * @param {module:model/IntegrityMonitoringRule} integrityMonitoringRule The settings of the integrity monitoring rule to modify.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {Boolean} opts.overrides Show only overrides defined for the current policy.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/IntegrityMonitoringRule} and HTTP response
     */
    this.modifyIntegrityMonitoringRuleOnPolicyWithHttpInfo = function(policyID, integrityMonitoringRuleID, integrityMonitoringRule, apiVersion, opts) {
      opts = opts || {};
      var postBody = integrityMonitoringRule;

      // verify the required parameter 'policyID' is set
      if (policyID === undefined || policyID === null) {
        throw new Error("Missing the required parameter 'policyID' when calling modifyIntegrityMonitoringRuleOnPolicy");
      }

      // verify the required parameter 'integrityMonitoringRuleID' is set
      if (integrityMonitoringRuleID === undefined || integrityMonitoringRuleID === null) {
        throw new Error("Missing the required parameter 'integrityMonitoringRuleID' when calling modifyIntegrityMonitoringRuleOnPolicy");
      }

      // verify the required parameter 'integrityMonitoringRule' is set
      if (integrityMonitoringRule === undefined || integrityMonitoringRule === null) {
        throw new Error("Missing the required parameter 'integrityMonitoringRule' when calling modifyIntegrityMonitoringRuleOnPolicy");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling modifyIntegrityMonitoringRuleOnPolicy");
      }


      var pathParams = {
        'policyID': policyID,
        'integrityMonitoringRuleID': integrityMonitoringRuleID
      };
      var queryParams = {
        'overrides': opts['overrides'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = IntegrityMonitoringRule;

      return this.apiClient.callApi(
        '/policies/{policyID}/integritymonitoring/rules/{integrityMonitoringRuleID}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Modify an integrity monitoring rule
     * Modify an integrity monitoring rule assigned to a policy. Any unset elements will be left unchanged.
     * @param {Number} policyID The ID number of the policy.
     * @param {Number} integrityMonitoringRuleID The ID number of the integrity monitoring rule to modify.
     * @param {module:model/IntegrityMonitoringRule} integrityMonitoringRule The settings of the integrity monitoring rule to modify.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {Boolean} opts.overrides Show only overrides defined for the current policy.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/IntegrityMonitoringRule}
     */
    this.modifyIntegrityMonitoringRuleOnPolicy = function(policyID, integrityMonitoringRuleID, integrityMonitoringRule, apiVersion, opts) {
      return this.modifyIntegrityMonitoringRuleOnPolicyWithHttpInfo(policyID, integrityMonitoringRuleID, integrityMonitoringRule, apiVersion, opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Reset integrity monitoring rule overrides
     * Remove all overrides for an integrity monitoring rule from a policy.
     * @param {Number} policyID The ID number of the policy.
     * @param {Number} integrityMonitoringRuleID The ID number of the integrity monitoring rule to reset.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {Boolean} opts.overrides Show only overrides defined for the current policy.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/IntegrityMonitoringRule} and HTTP response
     */
    this.resetIntegrityMonitoringRuleOnPolicyWithHttpInfo = function(policyID, integrityMonitoringRuleID, apiVersion, opts) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'policyID' is set
      if (policyID === undefined || policyID === null) {
        throw new Error("Missing the required parameter 'policyID' when calling resetIntegrityMonitoringRuleOnPolicy");
      }

      // verify the required parameter 'integrityMonitoringRuleID' is set
      if (integrityMonitoringRuleID === undefined || integrityMonitoringRuleID === null) {
        throw new Error("Missing the required parameter 'integrityMonitoringRuleID' when calling resetIntegrityMonitoringRuleOnPolicy");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling resetIntegrityMonitoringRuleOnPolicy");
      }


      var pathParams = {
        'policyID': policyID,
        'integrityMonitoringRuleID': integrityMonitoringRuleID
      };
      var queryParams = {
        'overrides': opts['overrides'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = IntegrityMonitoringRule;

      return this.apiClient.callApi(
        '/policies/{policyID}/integritymonitoring/rules/{integrityMonitoringRuleID}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Reset integrity monitoring rule overrides
     * Remove all overrides for an integrity monitoring rule from a policy.
     * @param {Number} policyID The ID number of the policy.
     * @param {Number} integrityMonitoringRuleID The ID number of the integrity monitoring rule to reset.
     * @param {String} apiVersion The version of the api being called.
     * @param {Object} opts Optional parameters
     * @param {Boolean} opts.overrides Show only overrides defined for the current policy.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/IntegrityMonitoringRule}
     */
    this.resetIntegrityMonitoringRuleOnPolicy = function(policyID, integrityMonitoringRuleID, apiVersion, opts) {
      return this.resetIntegrityMonitoringRuleOnPolicyWithHttpInfo(policyID, integrityMonitoringRuleID, apiVersion, opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
