/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/SnsConfiguration', 'model/Snsstatus'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/SnsConfiguration'), require('../model/Snsstatus'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.SNSApi = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.SnsConfiguration, root.Deepsecurity.Snsstatus);
  }
}(this, function(ApiClient, SnsConfiguration, Snsstatus) {
  'use strict';

  /**
   * SNS service.
   * @module api/SNSApi
   * @version 12.5.855
   */

  /**
   * Constructs a new SNSApi. 
   * @alias module:api/SNSApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Describe an SNS configuration used for forwarding events
     * Describe an SNS forwarding configuration.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/SnsConfiguration} and HTTP response
     */
    this.describeSNSConfigurationWithHttpInfo = function(apiVersion) {
      var postBody = null;

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling describeSNSConfiguration");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = SnsConfiguration;

      return this.apiClient.callApi(
        '/snsconfiguration', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Describe an SNS configuration used for forwarding events
     * Describe an SNS forwarding configuration.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/SnsConfiguration}
     */
    this.describeSNSConfiguration = function(apiVersion) {
      return this.describeSNSConfigurationWithHttpInfo(apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Update SNS status
     * Update SNS status.
     * @param {module:model/Snsstatus} sNSStatus SNSStatus.java.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/Snsstatus} and HTTP response
     */
    this.updateSNSStatusWithHttpInfo = function(sNSStatus, apiVersion) {
      var postBody = sNSStatus;

      // verify the required parameter 'sNSStatus' is set
      if (sNSStatus === undefined || sNSStatus === null) {
        throw new Error("Missing the required parameter 'sNSStatus' when calling updateSNSStatus");
      }

      // verify the required parameter 'apiVersion' is set
      if (apiVersion === undefined || apiVersion === null) {
        throw new Error("Missing the required parameter 'apiVersion' when calling updateSNSStatus");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'api-version': apiVersion
      };
      var formParams = {
      };

      var authNames = ['DefaultAuthentication'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = Snsstatus;

      return this.apiClient.callApi(
        '/snsstatus', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Update SNS status
     * Update SNS status.
     * @param {module:model/Snsstatus} sNSStatus SNSStatus.java.
     * @param {String} apiVersion The version of the api being called.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/Snsstatus}
     */
    this.updateSNSStatus = function(sNSStatus, apiVersion) {
      return this.updateSNSStatusWithHttpInfo(sNSStatus, apiVersion)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
