/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.AWSRegion = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The AWSRegion model module.
   * @module model/AWSRegion
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>AWSRegion</code>.
   * A region in AWS that instances and workspaces can be synchronized to.
   * @alias module:model/AWSRegion
   * @class
   */
  var exports = function() {
    var _this = this;




  };

  /**
   * Constructs a <code>AWSRegion</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/AWSRegion} obj Optional instance to populate.
   * @return {module:model/AWSRegion} The populated <code>AWSRegion</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('region')) {
        obj['region'] = ApiClient.convertToType(data['region'], 'String');
      }
      if (data.hasOwnProperty('computersSynced')) {
        obj['computersSynced'] = ApiClient.convertToType(data['computersSynced'], 'Number');
      }
      if (data.hasOwnProperty('workspacesSynced')) {
        obj['workspacesSynced'] = ApiClient.convertToType(data['workspacesSynced'], 'Number');
      }
    }
    return obj;
  }

  /**
   * The Amazon region name.
   * @member {String} region
   */
  exports.prototype['region'] = undefined;
  /**
   * The number of instances in the region during the last sync.
   * @member {Number} computersSynced
   */
  exports.prototype['computersSynced'] = undefined;
  /**
   * The number of workspaces in the region during the last sync.
   * @member {Number} workspacesSynced
   */
  exports.prototype['workspacesSynced'] = undefined;



  return exports;
}));



