/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.AgentDeploymentScript = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The AgentDeploymentScript model module.
   * @module model/AgentDeploymentScript
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>AgentDeploymentScript</code>.
   * Agent deployment script.
   * @alias module:model/AgentDeploymentScript
   * @class
   */
  var exports = function() {
    var _this = this;











  };

  /**
   * Constructs a <code>AgentDeploymentScript</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/AgentDeploymentScript} obj Optional instance to populate.
   * @return {module:model/AgentDeploymentScript} The populated <code>AgentDeploymentScript</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('platform')) {
        obj['platform'] = ApiClient.convertToType(data['platform'], 'String');
      }
      if (data.hasOwnProperty('validateCertificateRequired')) {
        obj['validateCertificateRequired'] = ApiClient.convertToType(data['validateCertificateRequired'], 'Boolean');
      }
      if (data.hasOwnProperty('validateDigitalSignatureRequired')) {
        obj['validateDigitalSignatureRequired'] = ApiClient.convertToType(data['validateDigitalSignatureRequired'], 'Boolean');
      }
      if (data.hasOwnProperty('activationRequired')) {
        obj['activationRequired'] = ApiClient.convertToType(data['activationRequired'], 'Boolean');
      }
      if (data.hasOwnProperty('dsmProxyID')) {
        obj['dsmProxyID'] = ApiClient.convertToType(data['dsmProxyID'], 'Number');
      }
      if (data.hasOwnProperty('relayProxyID')) {
        obj['relayProxyID'] = ApiClient.convertToType(data['relayProxyID'], 'Number');
      }
      if (data.hasOwnProperty('policyID')) {
        obj['policyID'] = ApiClient.convertToType(data['policyID'], 'Number');
      }
      if (data.hasOwnProperty('relayGroupID')) {
        obj['relayGroupID'] = ApiClient.convertToType(data['relayGroupID'], 'Number');
      }
      if (data.hasOwnProperty('computerGroupID')) {
        obj['computerGroupID'] = ApiClient.convertToType(data['computerGroupID'], 'Number');
      }
      if (data.hasOwnProperty('scriptBody')) {
        obj['scriptBody'] = ApiClient.convertToType(data['scriptBody'], 'String');
      }
    }
    return obj;
  }

  /**
   * Platform type for agent deployment.
   * @member {module:model/AgentDeploymentScript.PlatformEnum} platform
   */
  exports.prototype['platform'] = undefined;
  /**
   * Validate if Deep Security Manager is using a valid TLS certificate from a trusted certificate authority (CA) when downloading the agent software.
   * @member {Boolean} validateCertificateRequired
   */
  exports.prototype['validateCertificateRequired'] = undefined;
  /**
   * Validate digital signature of Deep Security Agent installer.
   * @member {Boolean} validateDigitalSignatureRequired
   */
  exports.prototype['validateDigitalSignatureRequired'] = undefined;
  /**
   * Activate the agent at startup.
   * @member {Boolean} activationRequired
   */
  exports.prototype['activationRequired'] = undefined;
  /**
   * ID of the proxy server for contacting Deep Security Manager.
   * @member {Number} dsmProxyID
   */
  exports.prototype['dsmProxyID'] = undefined;
  /**
   * ID of the proxy server for contacting Relay(s).
   * @member {Number} relayProxyID
   */
  exports.prototype['relayProxyID'] = undefined;
  /**
   * ID of the policy assigned to the computer.
   * @member {Number} policyID
   */
  exports.prototype['policyID'] = undefined;
  /**
   * ID of the relay group to which the computer belongs.
   * @member {Number} relayGroupID
   */
  exports.prototype['relayGroupID'] = undefined;
  /**
   * ID of the computer group to which the computer belongs.
   * @member {Number} computerGroupID
   */
  exports.prototype['computerGroupID'] = undefined;
  /**
   * Agent deployment script.
   * @member {String} scriptBody
   */
  exports.prototype['scriptBody'] = undefined;


  /**
   * Allowed values for the <code>platform</code> property.
   * @enum {String}
   * @readonly
   */
  exports.PlatformEnum = {
    /**
     * value: "linux"
     * @const
     */
    "linux": "linux",
    /**
     * value: "windows"
     * @const
     */
    "windows": "windows",
    /**
     * value: "solaris"
     * @const
     */
    "solaris": "solaris",
    /**
     * value: "aix"
     * @const
     */
    "aix": "aix"  };


  return exports;
}));



