/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AvailableVersion'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./AvailableVersion'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.AgentVersionControl = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.AvailableVersion);
  }
}(this, function(ApiClient, AvailableVersion) {
  'use strict';




  /**
   * The AgentVersionControl model module.
   * @module model/AgentVersionControl
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>AgentVersionControl</code>.
   * Agent version control details.
   * @alias module:model/AgentVersionControl
   * @class
   */
  var exports = function() {
    var _this = this;









  };

  /**
   * Constructs a <code>AgentVersionControl</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/AgentVersionControl} obj Optional instance to populate.
   * @return {module:model/AgentVersionControl} The populated <code>AgentVersionControl</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('os')) {
        obj['os'] = ApiClient.convertToType(data['os'], 'String');
      }
      if (data.hasOwnProperty('distro')) {
        obj['distro'] = ApiClient.convertToType(data['distro'], 'String');
      }
      if (data.hasOwnProperty('platform')) {
        obj['platform'] = ApiClient.convertToType(data['platform'], 'String');
      }
      if (data.hasOwnProperty('architecture')) {
        obj['architecture'] = ApiClient.convertToType(data['architecture'], 'String');
      }
      if (data.hasOwnProperty('type')) {
        obj['type'] = ApiClient.convertToType(data['type'], 'String');
      }
      if (data.hasOwnProperty('version')) {
        obj['version'] = ApiClient.convertToType(data['version'], 'String');
      }
      if (data.hasOwnProperty('availableVersions')) {
        obj['availableVersions'] = ApiClient.convertToType(data['availableVersions'], [AvailableVersion]);
      }
      if (data.hasOwnProperty('ID')) {
        obj['ID'] = ApiClient.convertToType(data['ID'], 'Number');
      }
    }
    return obj;
  }

  /**
   * OS of the agent version control. Searchable as Choice.
   * @member {module:model/AgentVersionControl.OsEnum} os
   */
  exports.prototype['os'] = undefined;
  /**
   * Distro of the agent version control. Searchable as Choice.
   * @member {module:model/AgentVersionControl.DistroEnum} distro
   */
  exports.prototype['distro'] = undefined;
  /**
   * Platform of the agent version control. Searchable as Choice.
   * @member {module:model/AgentVersionControl.PlatformEnum} platform
   */
  exports.prototype['platform'] = undefined;
  /**
   * Architecture of the agent version control. Searchable as Choice.
   * @member {module:model/AgentVersionControl.ArchitectureEnum} architecture
   */
  exports.prototype['architecture'] = undefined;
  /**
   * Type of the agent version control. Searchable as Choice.
   * @member {module:model/AgentVersionControl.TypeEnum} type
   */
  exports.prototype['type'] = undefined;
  /**
   * Version of the agent version control. Searchable as String.
   * @member {String} version
   */
  exports.prototype['version'] = undefined;
  /**
   * List of available versions for the platform.
   * @member {Array.<module:model/AvailableVersion>} availableVersions
   */
  exports.prototype['availableVersions'] = undefined;
  /**
   * ID of the agent version control. Searchable as ID.
   * @member {Number} ID
   */
  exports.prototype['ID'] = undefined;


  /**
   * Allowed values for the <code>os</code> property.
   * @enum {String}
   * @readonly
   */
  exports.OsEnum = {
    /**
     * value: "Windows"
     * @const
     */
    "Windows": "Windows",
    /**
     * value: "Linux"
     * @const
     */
    "Linux": "Linux",
    /**
     * value: "Unix"
     * @const
     */
    "Unix": "Unix"  };

  /**
   * Allowed values for the <code>distro</code> property.
   * @enum {String}
   * @readonly
   */
  exports.DistroEnum = {
    /**
     * value: "Red Hat"
     * @const
     */
    "Red Hat": "Red Hat",
    /**
     * value: "CentOS"
     * @const
     */
    "CentOS": "CentOS",
    /**
     * value: "SUSE"
     * @const
     */
    "SUSE": "SUSE",
    /**
     * value: "Ubuntu"
     * @const
     */
    "Ubuntu": "Ubuntu",
    /**
     * value: "Debian"
     * @const
     */
    "Debian": "Debian",
    /**
     * value: "Oracle Linux"
     * @const
     */
    "Oracle Linux": "Oracle Linux",
    /**
     * value: "Amazon Linux"
     * @const
     */
    "Amazon Linux": "Amazon Linux",
    /**
     * value: "CloudLinux"
     * @const
     */
    "CloudLinux": "CloudLinux",
    /**
     * value: "Solaris"
     * @const
     */
    "Solaris": "Solaris",
    /**
     * value: "AIX"
     * @const
     */
    "AIX": "AIX"  };

  /**
   * Allowed values for the <code>platform</code> property.
   * @enum {String}
   * @readonly
   */
  exports.PlatformEnum = {
    /**
     * value: "Microsoft Windows 2000 Server"
     * @const
     */
    "Microsoft Windows 2000 Server": "Microsoft Windows 2000 Server",
    /**
     * value: "Microsoft Windows Server 2003"
     * @const
     */
    "Microsoft Windows Server 2003": "Microsoft Windows Server 2003",
    /**
     * value: "Microsoft Windows Server 2003 R2"
     * @const
     */
    "Microsoft Windows Server 2003 R2": "Microsoft Windows Server 2003 R2",
    /**
     * value: "Microsoft Windows Server 2008"
     * @const
     */
    "Microsoft Windows Server 2008": "Microsoft Windows Server 2008",
    /**
     * value: "Microsoft Windows Server 2008 R2"
     * @const
     */
    "Microsoft Windows Server 2008 R2": "Microsoft Windows Server 2008 R2",
    /**
     * value: "Microsoft Windows Server 2012"
     * @const
     */
    "Microsoft Windows Server 2012": "Microsoft Windows Server 2012",
    /**
     * value: "Microsoft Windows Server 2012 R2"
     * @const
     */
    "Microsoft Windows Server 2012 R2": "Microsoft Windows Server 2012 R2",
    /**
     * value: "Microsoft Windows Server 2016"
     * @const
     */
    "Microsoft Windows Server 2016": "Microsoft Windows Server 2016",
    /**
     * value: "Microsoft Windows Server 2019"
     * @const
     */
    "Microsoft Windows Server 2019": "Microsoft Windows Server 2019",
    /**
     * value: "Microsoft Windows 2000 Professional"
     * @const
     */
    "Microsoft Windows 2000 Professional": "Microsoft Windows 2000 Professional",
    /**
     * value: "Microsoft Windows XP"
     * @const
     */
    "Microsoft Windows XP": "Microsoft Windows XP",
    /**
     * value: "Microsoft Windows 7"
     * @const
     */
    "Microsoft Windows 7": "Microsoft Windows 7",
    /**
     * value: "Microsoft Windows 8"
     * @const
     */
    "Microsoft Windows 8": "Microsoft Windows 8",
    /**
     * value: "Microsoft Windows 8.1"
     * @const
     */
    "Microsoft Windows 8.1": "Microsoft Windows 8.1",
    /**
     * value: "Microsoft Windows 10"
     * @const
     */
    "Microsoft Windows 10": "Microsoft Windows 10",
    /**
     * value: "Solaris 10 U4 to U6"
     * @const
     */
    "Solaris 10 U4 to U6": "Solaris 10 U4 to U6",
    /**
     * value: "Solaris 10 U7 to U11"
     * @const
     */
    "Solaris 10 U7 to U11": "Solaris 10 U7 to U11",
    /**
     * value: "Solaris 11.0 to 11.3"
     * @const
     */
    "Solaris 11.0 to 11.3": "Solaris 11.0 to 11.3",
    /**
     * value: "Solaris 11.4"
     * @const
     */
    "Solaris 11.4": "Solaris 11.4",
    /**
     * value: "AIX 5.3"
     * @const
     */
    "AIX 5.3": "AIX 5.3",
    /**
     * value: "AIX 6.1"
     * @const
     */
    "AIX 6.1": "AIX 6.1",
    /**
     * value: "AIX 7.1"
     * @const
     */
    "AIX 7.1": "AIX 7.1",
    /**
     * value: "AIX 7.2"
     * @const
     */
    "AIX 7.2": "AIX 7.2",
    /**
     * value: "Red Hat Enterprise 5"
     * @const
     */
    "Red Hat Enterprise 5": "Red Hat Enterprise 5",
    /**
     * value: "Red Hat Enterprise 6"
     * @const
     */
    "Red Hat Enterprise 6": "Red Hat Enterprise 6",
    /**
     * value: "Red Hat Enterprise 7"
     * @const
     */
    "Red Hat Enterprise 7": "Red Hat Enterprise 7",
    /**
     * value: "Red Hat Enterprise 8"
     * @const
     */
    "Red Hat Enterprise 8": "Red Hat Enterprise 8",
    /**
     * value: "Ubuntu Linux 10"
     * @const
     */
    "Ubuntu Linux 10": "Ubuntu Linux 10",
    /**
     * value: "Ubuntu Linux 12"
     * @const
     */
    "Ubuntu Linux 12": "Ubuntu Linux 12",
    /**
     * value: "Ubuntu Linux 14"
     * @const
     */
    "Ubuntu Linux 14": "Ubuntu Linux 14",
    /**
     * value: "Ubuntu Linux 16"
     * @const
     */
    "Ubuntu Linux 16": "Ubuntu Linux 16",
    /**
     * value: "Ubuntu Linux 18"
     * @const
     */
    "Ubuntu Linux 18": "Ubuntu Linux 18",
    /**
     * value: "Ubuntu Linux 20"
     * @const
     */
    "Ubuntu Linux 20": "Ubuntu Linux 20",
    /**
     * value: "CentOS 5"
     * @const
     */
    "CentOS 5": "CentOS 5",
    /**
     * value: "CentOS 6"
     * @const
     */
    "CentOS 6": "CentOS 6",
    /**
     * value: "CentOS 7"
     * @const
     */
    "CentOS 7": "CentOS 7",
    /**
     * value: "CentOS 8"
     * @const
     */
    "CentOS 8": "CentOS 8",
    /**
     * value: "Debian 6"
     * @const
     */
    "Debian 6": "Debian 6",
    /**
     * value: "Debian 7"
     * @const
     */
    "Debian 7": "Debian 7",
    /**
     * value: "Debian 8"
     * @const
     */
    "Debian 8": "Debian 8",
    /**
     * value: "Debian 9"
     * @const
     */
    "Debian 9": "Debian 9",
    /**
     * value: "Debian 10"
     * @const
     */
    "Debian 10": "Debian 10",
    /**
     * value: "Amazon Linux"
     * @const
     */
    "Amazon Linux": "Amazon Linux",
    /**
     * value: "Amazon Linux 2"
     * @const
     */
    "Amazon Linux 2": "Amazon Linux 2",
    /**
     * value: "Oracle Linux Release 5"
     * @const
     */
    "Oracle Linux Release 5": "Oracle Linux Release 5",
    /**
     * value: "Oracle Linux Release 6"
     * @const
     */
    "Oracle Linux Release 6": "Oracle Linux Release 6",
    /**
     * value: "Oracle Linux Release 7"
     * @const
     */
    "Oracle Linux Release 7": "Oracle Linux Release 7",
    /**
     * value: "Oracle Linux Release 8"
     * @const
     */
    "Oracle Linux Release 8": "Oracle Linux Release 8",
    /**
     * value: "SUSE Enterprise Server 10"
     * @const
     */
    "SUSE Enterprise Server 10": "SUSE Enterprise Server 10",
    /**
     * value: "SUSE Enterprise Server 11"
     * @const
     */
    "SUSE Enterprise Server 11": "SUSE Enterprise Server 11",
    /**
     * value: "SUSE Enterprise Server 12"
     * @const
     */
    "SUSE Enterprise Server 12": "SUSE Enterprise Server 12",
    /**
     * value: "SUSE Enterprise Server 15"
     * @const
     */
    "SUSE Enterprise Server 15": "SUSE Enterprise Server 15",
    /**
     * value: "CloudLinux 5"
     * @const
     */
    "CloudLinux 5": "CloudLinux 5",
    /**
     * value: "CloudLinux 6"
     * @const
     */
    "CloudLinux 6": "CloudLinux 6",
    /**
     * value: "CloudLinux 7"
     * @const
     */
    "CloudLinux 7": "CloudLinux 7",
    /**
     * value: "CloudLinux 8"
     * @const
     */
    "CloudLinux 8": "CloudLinux 8"  };

  /**
   * Allowed values for the <code>architecture</code> property.
   * @enum {String}
   * @readonly
   */
  exports.ArchitectureEnum = {
    /**
     * value: "32-bit"
     * @const
     */
    "32-bit": "32-bit",
    /**
     * value: "64-bit"
     * @const
     */
    "64-bit": "64-bit",
    /**
     * value: "sparc"
     * @const
     */
    "sparc": "sparc",
    /**
     * value: "powerpc"
     * @const
     */
    "powerpc": "powerpc"  };

  /**
   * Allowed values for the <code>type</code> property.
   * @enum {String}
   * @readonly
   */
  exports.TypeEnum = {
    /**
     * value: "latest"
     * @const
     */
    "latest": "latest",
    /**
     * value: "latest-lts"
     * @const
     */
    "latest-lts": "latest-lts",
    /**
     * value: "specified"
     * @const
     */
    "specified": "specified",
    /**
     * value: "unknown"
     * @const
     */
    "unknown": "unknown"  };


  return exports;
}));



