/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.ApiUsageMetric = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The ApiUsageMetric model module.
   * @module model/ApiUsageMetric
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>ApiUsageMetric</code>.
   * API Usage Metrics are useful to view data on which API endpoints are used and how.
   * @alias module:model/ApiUsageMetric
   * @class
   */
  var exports = function() {
    var _this = this;












  };

  /**
   * Constructs a <code>ApiUsageMetric</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ApiUsageMetric} obj Optional instance to populate.
   * @return {module:model/ApiUsageMetric} The populated <code>ApiUsageMetric</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('apiType')) {
        obj['apiType'] = ApiClient.convertToType(data['apiType'], 'String');
      }
      if (data.hasOwnProperty('action')) {
        obj['action'] = ApiClient.convertToType(data['action'], 'String');
      }
      if (data.hasOwnProperty('method')) {
        obj['method'] = ApiClient.convertToType(data['method'], 'String');
      }
      if (data.hasOwnProperty('date')) {
        obj['date'] = ApiClient.convertToType(data['date'], 'Number');
      }
      if (data.hasOwnProperty('tenantGUID')) {
        obj['tenantGUID'] = ApiClient.convertToType(data['tenantGUID'], 'String');
      }
      if (data.hasOwnProperty('duration')) {
        obj['duration'] = ApiClient.convertToType(data['duration'], 'Number');
      }
      if (data.hasOwnProperty('statusCode')) {
        obj['statusCode'] = ApiClient.convertToType(data['statusCode'], 'Number');
      }
      if (data.hasOwnProperty('authenticationMethod')) {
        obj['authenticationMethod'] = ApiClient.convertToType(data['authenticationMethod'], 'String');
      }
      if (data.hasOwnProperty('expandParameter')) {
        obj['expandParameter'] = ApiClient.convertToType(data['expandParameter'], 'String');
      }
      if (data.hasOwnProperty('responseItemCount')) {
        obj['responseItemCount'] = ApiClient.convertToType(data['responseItemCount'], 'Number');
      }
      if (data.hasOwnProperty('ID')) {
        obj['ID'] = ApiClient.convertToType(data['ID'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Type of API called (\"REST\" or \"SOAP\"). Searchable as String.
   * @member {String} apiType
   */
  exports.prototype['apiType'] = undefined;
  /**
   * Http action (\"GET\", \"PUT\", \"POST\" or \"DELETE\"). Searchable as String.
   * @member {String} action
   */
  exports.prototype['action'] = undefined;
  /**
   * Method or API Endpoint called. Searchable as String.
   * @member {String} method
   */
  exports.prototype['method'] = undefined;
  /**
   * Date of API call in milliseconds since epoch. Searchable as Date.
   * @member {Number} date
   */
  exports.prototype['date'] = undefined;
  /**
   * GUID of the tenant who called the API. Searchable as String.
   * @member {String} tenantGUID
   */
  exports.prototype['tenantGUID'] = undefined;
  /**
   * Duration of the API call from request to response in milliseconds. Searchable as Numeric.
   * @member {Number} duration
   */
  exports.prototype['duration'] = undefined;
  /**
   * Http status code returned by the API. Searchable as Numeric.
   * @member {Number} statusCode
   */
  exports.prototype['statusCode'] = undefined;
  /**
   * Method used to authenticate the API call (\"sID\", \"API-Key\", or empty string). Searchable as String.
   * @member {String} authenticationMethod
   */
  exports.prototype['authenticationMethod'] = undefined;
  /**
   * \"expand\" parameter passed to /computers endpoint. Searchable as String.
   * @member {String} expandParameter
   */
  exports.prototype['expandParameter'] = undefined;
  /**
   * Number of items returned to the client from a list/search operation. Searchable as Numeric.
   * @member {Number} responseItemCount
   */
  exports.prototype['responseItemCount'] = undefined;
  /**
   * ID of the APIUsageMetric. Searchable as ID.
   * @member {Number} ID
   */
  exports.prototype['ID'] = undefined;



  return exports;
}));



