/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.ApplicationControlGlobalRule = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The ApplicationControlGlobalRule model module.
   * @module model/ApplicationControlGlobalRule
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>ApplicationControlGlobalRule</code>.
   * Rule details.
   * @alias module:model/ApplicationControlGlobalRule
   * @class
   */
  var exports = function() {
    var _this = this;







  };

  /**
   * Constructs a <code>ApplicationControlGlobalRule</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ApplicationControlGlobalRule} obj Optional instance to populate.
   * @return {module:model/ApplicationControlGlobalRule} The populated <code>ApplicationControlGlobalRule</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('sha256')) {
        obj['sha256'] = ApiClient.convertToType(data['sha256'], 'String');
      }
      if (data.hasOwnProperty('description')) {
        obj['description'] = ApiClient.convertToType(data['description'], 'String');
      }
      if (data.hasOwnProperty('action')) {
        obj['action'] = ApiClient.convertToType(data['action'], 'String');
      }
      if (data.hasOwnProperty('lastUpdatedAdministrator')) {
        obj['lastUpdatedAdministrator'] = ApiClient.convertToType(data['lastUpdatedAdministrator'], 'Number');
      }
      if (data.hasOwnProperty('lastUpdated')) {
        obj['lastUpdated'] = ApiClient.convertToType(data['lastUpdated'], 'Number');
      }
      if (data.hasOwnProperty('ID')) {
        obj['ID'] = ApiClient.convertToType(data['ID'], 'Number');
      }
    }
    return obj;
  }

  /**
   * SHA-256 hash of the executable named in the rule. Searchable as String.
   * @member {String} sha256
   */
  exports.prototype['sha256'] = undefined;
  /**
   * Description of the rule. Searchable as String.
   * @member {String} description
   */
  exports.prototype['description'] = undefined;
  /**
   * Action to take when a user attempts to launch the executable named in the rule. Searchable as Choice.
   * @member {module:model/ApplicationControlGlobalRule.ActionEnum} action
   */
  exports.prototype['action'] = undefined;
  /**
   * ID of the last administrator to update the rule. Searchable as Numeric.
   * @member {Number} lastUpdatedAdministrator
   */
  exports.prototype['lastUpdatedAdministrator'] = undefined;
  /**
   * Timestamp of the last rule modification, in milliseconds since epoch. Searchable as Date.
   * @member {Number} lastUpdated
   */
  exports.prototype['lastUpdated'] = undefined;
  /**
   * ID of the application control rule. Searchable as ID.
   * @member {Number} ID
   */
  exports.prototype['ID'] = undefined;


  /**
   * Allowed values for the <code>action</code> property.
   * @enum {String}
   * @readonly
   */
  exports.ActionEnum = {
    /**
     * value: "block"
     * @const
     */
    "block": "block"  };


  return exports;
}));



