/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/DriftRights', 'model/RuleRights', 'model/RulesetRights', 'model/SoftwareInventoryRights'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./DriftRights'), require('./RuleRights'), require('./RulesetRights'), require('./SoftwareInventoryRights'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.ApplicationControlRights = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.DriftRights, root.Deepsecurity.RuleRights, root.Deepsecurity.RulesetRights, root.Deepsecurity.SoftwareInventoryRights);
  }
}(this, function(ApiClient, DriftRights, RuleRights, RulesetRights, SoftwareInventoryRights) {
  'use strict';




  /**
   * The ApplicationControlRights model module.
   * @module model/ApplicationControlRights
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>ApplicationControlRights</code>.
   * Application control rights details.
   * @alias module:model/ApplicationControlRights
   * @class
   */
  var exports = function() {
    var _this = this;





  };

  /**
   * Constructs a <code>ApplicationControlRights</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ApplicationControlRights} obj Optional instance to populate.
   * @return {module:model/ApplicationControlRights} The populated <code>ApplicationControlRights</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('driftRights')) {
        obj['driftRights'] = DriftRights.constructFromObject(data['driftRights']);
      }
      if (data.hasOwnProperty('rulesetRights')) {
        obj['rulesetRights'] = RulesetRights.constructFromObject(data['rulesetRights']);
      }
      if (data.hasOwnProperty('ruleRights')) {
        obj['ruleRights'] = RuleRights.constructFromObject(data['ruleRights']);
      }
      if (data.hasOwnProperty('softwareInventoryRights')) {
        obj['softwareInventoryRights'] = SoftwareInventoryRights.constructFromObject(data['softwareInventoryRights']);
      }
    }
    return obj;
  }

  /**
   * Rights related to drift.
   * @member {module:model/DriftRights} driftRights
   */
  exports.prototype['driftRights'] = undefined;
  /**
   * Rights related to rulesets.
   * @member {module:model/RulesetRights} rulesetRights
   */
  exports.prototype['rulesetRights'] = undefined;
  /**
   * Rights related to rules.
   * @member {module:model/RuleRights} ruleRights
   */
  exports.prototype['ruleRights'] = undefined;
  /**
   * Rights related to software inventory.
   * @member {module:model/SoftwareInventoryRights} softwareInventoryRights
   */
  exports.prototype['softwareInventoryRights'] = undefined;



  return exports;
}));



