/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.CertificateDetails = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The CertificateDetails model module.
   * @module model/CertificateDetails
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>CertificateDetails</code>.
   * Certificate details
   * @alias module:model/CertificateDetails
   * @class
   */
  var exports = function() {
    var _this = this;








  };

  /**
   * Constructs a <code>CertificateDetails</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CertificateDetails} obj Optional instance to populate.
   * @return {module:model/CertificateDetails} The populated <code>CertificateDetails</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('issuerDN')) {
        obj['issuerDN'] = ApiClient.convertToType(data['issuerDN'], 'String');
      }
      if (data.hasOwnProperty('subjectDN')) {
        obj['subjectDN'] = ApiClient.convertToType(data['subjectDN'], 'String');
      }
      if (data.hasOwnProperty('notBefore')) {
        obj['notBefore'] = ApiClient.convertToType(data['notBefore'], 'Number');
      }
      if (data.hasOwnProperty('notAfter')) {
        obj['notAfter'] = ApiClient.convertToType(data['notAfter'], 'Number');
      }
      if (data.hasOwnProperty('serialNumber')) {
        obj['serialNumber'] = ApiClient.convertToType(data['serialNumber'], 'String');
      }
      if (data.hasOwnProperty('sha1Fingerprint')) {
        obj['sha1Fingerprint'] = ApiClient.convertToType(data['sha1Fingerprint'], 'String');
      }
      if (data.hasOwnProperty('sha256Fingerprint')) {
        obj['sha256Fingerprint'] = ApiClient.convertToType(data['sha256Fingerprint'], 'String');
      }
    }
    return obj;
  }

  /**
   * The certificate issuer.
   * @member {String} issuerDN
   */
  exports.prototype['issuerDN'] = undefined;
  /**
   * The certificate subject (owner).
   * @member {String} subjectDN
   */
  exports.prototype['subjectDN'] = undefined;
  /**
   * The date on which the certificate validity period begins.
   * @member {Number} notBefore
   */
  exports.prototype['notBefore'] = undefined;
  /**
   * The date on which the certificate validity period ends.
   * @member {Number} notAfter
   */
  exports.prototype['notAfter'] = undefined;
  /**
   * A number that uniquely identifies the certificate and is issued by the certification authority.
   * @member {String} serialNumber
   */
  exports.prototype['serialNumber'] = undefined;
  /**
   * The sha1 fingerprint of the certificate.
   * @member {String} sha1Fingerprint
   */
  exports.prototype['sha1Fingerprint'] = undefined;
  /**
   * The sha256 fingerprint of the certificate.
   * @member {String} sha256Fingerprint
   */
  exports.prototype['sha256Fingerprint'] = undefined;



  return exports;
}));



