/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ComputerFilter'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./ComputerFilter'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.CheckForSecurityUpdatesTaskParameters = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.ComputerFilter);
  }
}(this, function(ApiClient, ComputerFilter) {
  'use strict';




  /**
   * The CheckForSecurityUpdatesTaskParameters model module.
   * @module model/CheckForSecurityUpdatesTaskParameters
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>CheckForSecurityUpdatesTaskParameters</code>.
   * Controls the behavior of a scheduled task of type check-for-security-updates.
   * @alias module:model/CheckForSecurityUpdatesTaskParameters
   * @class
   */
  var exports = function() {
    var _this = this;



  };

  /**
   * Constructs a <code>CheckForSecurityUpdatesTaskParameters</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CheckForSecurityUpdatesTaskParameters} obj Optional instance to populate.
   * @return {module:model/CheckForSecurityUpdatesTaskParameters} The populated <code>CheckForSecurityUpdatesTaskParameters</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('computerFilter')) {
        obj['computerFilter'] = ComputerFilter.constructFromObject(data['computerFilter']);
      }
      if (data.hasOwnProperty('timeout')) {
        obj['timeout'] = ApiClient.convertToType(data['timeout'], 'String');
      }
    }
    return obj;
  }

  /**
   * Controls which computer(s) to update.
   * @member {module:model/ComputerFilter} computerFilter
   */
  exports.prototype['computerFilter'] = undefined;
  /**
   * Time after the scheduled start time that security updates will not be started.
   * @member {module:model/CheckForSecurityUpdatesTaskParameters.TimeoutEnum} timeout
   */
  exports.prototype['timeout'] = undefined;


  /**
   * Allowed values for the <code>timeout</code> property.
   * @enum {String}
   * @readonly
   */
  exports.TimeoutEnum = {
    /**
     * value: "never"
     * @const
     */
    "never": "never",
    /**
     * value: "one-hour"
     * @const
     */
    "one-hour": "one-hour",
    /**
     * value: "two-hours"
     * @const
     */
    "two-hours": "two-hours",
    /**
     * value: "four-hours"
     * @const
     */
    "four-hours": "four-hours",
    /**
     * value: "eight-hours"
     * @const
     */
    "eight-hours": "eight-hours"  };


  return exports;
}));



