/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.ComputerFilter = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The ComputerFilter model module.
   * @module model/ComputerFilter
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>ComputerFilter</code>.
   * Details of a computer filter. A computer filter identifies the computers that certain types of scheduled tasks act on.
   * @alias module:model/ComputerFilter
   * @class
   */
  var exports = function() {
    var _this = this;






  };

  /**
   * Constructs a <code>ComputerFilter</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ComputerFilter} obj Optional instance to populate.
   * @return {module:model/ComputerFilter} The populated <code>ComputerFilter</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('type')) {
        obj['type'] = ApiClient.convertToType(data['type'], 'String');
      }
      if (data.hasOwnProperty('computerID')) {
        obj['computerID'] = ApiClient.convertToType(data['computerID'], 'Number');
      }
      if (data.hasOwnProperty('computerGroupID')) {
        obj['computerGroupID'] = ApiClient.convertToType(data['computerGroupID'], 'Number');
      }
      if (data.hasOwnProperty('policyID')) {
        obj['policyID'] = ApiClient.convertToType(data['policyID'], 'Number');
      }
      if (data.hasOwnProperty('smartFolderID')) {
        obj['smartFolderID'] = ApiClient.convertToType(data['smartFolderID'], 'Number');
      }
    }
    return obj;
  }

  /**
   * The type of computer filter.
   * @member {module:model/ComputerFilter.TypeEnum} type
   */
  exports.prototype['type'] = undefined;
  /**
   * Computer ID for filter type: computer.
   * @member {Number} computerID
   */
  exports.prototype['computerID'] = undefined;
  /**
   * Computer Group ID for filter type: computers-in-group or computers-in-group-or-subgroup.
   * @member {Number} computerGroupID
   */
  exports.prototype['computerGroupID'] = undefined;
  /**
   * Policy ID for filter type: computers-using-policy or computers-using-policy-or-subpolicy.
   * @member {Number} policyID
   */
  exports.prototype['policyID'] = undefined;
  /**
   * Smart Folder ID for filter type: computers-in-smart-folder.
   * @member {Number} smartFolderID
   */
  exports.prototype['smartFolderID'] = undefined;


  /**
   * Allowed values for the <code>type</code> property.
   * @enum {String}
   * @readonly
   */
  exports.TypeEnum = {
    /**
     * value: "computer"
     * @const
     */
    "computer": "computer",
    /**
     * value: "all-computers"
     * @const
     */
    "all-computers": "all-computers",
    /**
     * value: "computers-in-group"
     * @const
     */
    "computers-in-group": "computers-in-group",
    /**
     * value: "computers-in-group-or-subgroup"
     * @const
     */
    "computers-in-group-or-subgroup": "computers-in-group-or-subgroup",
    /**
     * value: "computers-using-policy"
     * @const
     */
    "computers-using-policy": "computers-using-policy",
    /**
     * value: "computers-using-policy-or-subpolicy"
     * @const
     */
    "computers-using-policy-or-subpolicy": "computers-using-policy-or-subpolicy",
    /**
     * value: "computers-in-smart-folder"
     * @const
     */
    "computers-in-smart-folder": "computers-in-smart-folder"  };


  return exports;
}));



