/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/SettingValue'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./SettingValue'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.DefaultPolicySettings = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.SettingValue);
  }
}(this, function(ApiClient, SettingValue) {
  'use strict';




  /**
   * The DefaultPolicySettings model module.
   * @module model/DefaultPolicySettings
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>DefaultPolicySettings</code>.
   * @alias module:model/DefaultPolicySettings
   * @class
   */
  var exports = function() {
    var _this = this;





































































































































































































































  };

  /**
   * Constructs a <code>DefaultPolicySettings</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/DefaultPolicySettings} obj Optional instance to populate.
   * @return {module:model/DefaultPolicySettings} The populated <code>DefaultPolicySettings</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('logInspectionSettingSeverityClippingAgentEventSendSyslogLevelMin')) {
        obj['logInspectionSettingSeverityClippingAgentEventSendSyslogLevelMin'] = SettingValue.constructFromObject(data['logInspectionSettingSeverityClippingAgentEventSendSyslogLevelMin']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionConnectionsCleanupMax')) {
        obj['firewallSettingEngineOptionConnectionsCleanupMax'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionConnectionsCleanupMax']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionVerifyTcpChecksumEnabled')) {
        obj['firewallSettingEngineOptionVerifyTcpChecksumEnabled'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionVerifyTcpChecksumEnabled']);
      }
      if (data.hasOwnProperty('antiMalwareSettingScanCacheOnDemandConfigId')) {
        obj['antiMalwareSettingScanCacheOnDemandConfigId'] = SettingValue.constructFromObject(data['antiMalwareSettingScanCacheOnDemandConfigId']);
      }
      if (data.hasOwnProperty('applicationControlSettingSharedRulesetId')) {
        obj['applicationControlSettingSharedRulesetId'] = SettingValue.constructFromObject(data['applicationControlSettingSharedRulesetId']);
      }
      if (data.hasOwnProperty('applicationControlSettingState')) {
        obj['applicationControlSettingState'] = SettingValue.constructFromObject(data['applicationControlSettingState']);
      }
      if (data.hasOwnProperty('webReputationSettingSmartProtectionServerConnectionLostWarningEnabled')) {
        obj['webReputationSettingSmartProtectionServerConnectionLostWarningEnabled'] = SettingValue.constructFromObject(data['webReputationSettingSmartProtectionServerConnectionLostWarningEnabled']);
      }
      if (data.hasOwnProperty('applicationControlSettingExecutionEnforcementLevel')) {
        obj['applicationControlSettingExecutionEnforcementLevel'] = SettingValue.constructFromObject(data['applicationControlSettingExecutionEnforcementLevel']);
      }
      if (data.hasOwnProperty('webReputationSettingBlockedUrlDomains')) {
        obj['webReputationSettingBlockedUrlDomains'] = SettingValue.constructFromObject(data['webReputationSettingBlockedUrlDomains']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionSynSentTimeout')) {
        obj['firewallSettingEngineOptionSynSentTimeout'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionSynSentTimeout']);
      }
      if (data.hasOwnProperty('platformSettingAgentSelfProtectionPassword')) {
        obj['platformSettingAgentSelfProtectionPassword'] = SettingValue.constructFromObject(data['platformSettingAgentSelfProtectionPassword']);
      }
      if (data.hasOwnProperty('firewallSettingReconnaissanceBlockTcpXmasAttackDuration')) {
        obj['firewallSettingReconnaissanceBlockTcpXmasAttackDuration'] = SettingValue.constructFromObject(data['firewallSettingReconnaissanceBlockTcpXmasAttackDuration']);
      }
      if (data.hasOwnProperty('intrusionPreventionSettingVirtualAndContainerNetworkScanEnabled')) {
        obj['intrusionPreventionSettingVirtualAndContainerNetworkScanEnabled'] = SettingValue.constructFromObject(data['intrusionPreventionSettingVirtualAndContainerNetworkScanEnabled']);
      }
      if (data.hasOwnProperty('logInspectionSettingSyslogConfigId')) {
        obj['logInspectionSettingSyslogConfigId'] = SettingValue.constructFromObject(data['logInspectionSettingSyslogConfigId']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionDebugModeEnabled')) {
        obj['firewallSettingEngineOptionDebugModeEnabled'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionDebugModeEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingVirtualAndContainerNetworkScanEnabled')) {
        obj['firewallSettingVirtualAndContainerNetworkScanEnabled'] = SettingValue.constructFromObject(data['firewallSettingVirtualAndContainerNetworkScanEnabled']);
      }
      if (data.hasOwnProperty('antiMalwareSettingFileHashSha256Enabled')) {
        obj['antiMalwareSettingFileHashSha256Enabled'] = SettingValue.constructFromObject(data['antiMalwareSettingFileHashSha256Enabled']);
      }
      if (data.hasOwnProperty('firewallSettingReconnaissanceNotifyFingerprintProbeEnabled')) {
        obj['firewallSettingReconnaissanceNotifyFingerprintProbeEnabled'] = SettingValue.constructFromObject(data['firewallSettingReconnaissanceNotifyFingerprintProbeEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingEventLogFileRetainNum')) {
        obj['firewallSettingEventLogFileRetainNum'] = SettingValue.constructFromObject(data['firewallSettingEventLogFileRetainNum']);
      }
      if (data.hasOwnProperty('firewallSettingAntiEvasionCheckTcpPawsZero')) {
        obj['firewallSettingAntiEvasionCheckTcpPawsZero'] = SettingValue.constructFromObject(data['firewallSettingAntiEvasionCheckTcpPawsZero']);
      }
      if (data.hasOwnProperty('antiMalwareSettingConnectedThreatDefenseUseControlManagerSuspiciousObjectListEnabled')) {
        obj['antiMalwareSettingConnectedThreatDefenseUseControlManagerSuspiciousObjectListEnabled'] = SettingValue.constructFromObject(data['antiMalwareSettingConnectedThreatDefenseUseControlManagerSuspiciousObjectListEnabled']);
      }
      if (data.hasOwnProperty('intrusionPreventionSettingEngineOptionFragmentedIpKeepMax')) {
        obj['intrusionPreventionSettingEngineOptionFragmentedIpKeepMax'] = SettingValue.constructFromObject(data['intrusionPreventionSettingEngineOptionFragmentedIpKeepMax']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionDrop6To4BogonsAddressesEnabled')) {
        obj['firewallSettingEngineOptionDrop6To4BogonsAddressesEnabled'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionDrop6To4BogonsAddressesEnabled']);
      }
      if (data.hasOwnProperty('logInspectionSettingSeverityClippingAgentEventStoreLevelMin')) {
        obj['logInspectionSettingSeverityClippingAgentEventStoreLevelMin'] = SettingValue.constructFromObject(data['logInspectionSettingSeverityClippingAgentEventStoreLevelMin']);
      }
      if (data.hasOwnProperty('platformSettingScanCacheConcurrencyMax')) {
        obj['platformSettingScanCacheConcurrencyMax'] = SettingValue.constructFromObject(data['platformSettingScanCacheConcurrencyMax']);
      }
      if (data.hasOwnProperty('antiMalwareSettingSyslogConfigId')) {
        obj['antiMalwareSettingSyslogConfigId'] = SettingValue.constructFromObject(data['antiMalwareSettingSyslogConfigId']);
      }
      if (data.hasOwnProperty('firewallSettingAntiEvasionTcpPawsWindowPolicy')) {
        obj['firewallSettingAntiEvasionTcpPawsWindowPolicy'] = SettingValue.constructFromObject(data['firewallSettingAntiEvasionTcpPawsWindowPolicy']);
      }
      if (data.hasOwnProperty('firewallSettingReconnaissanceDetectTcpXmasAttackEnabled')) {
        obj['firewallSettingReconnaissanceDetectTcpXmasAttackEnabled'] = SettingValue.constructFromObject(data['firewallSettingReconnaissanceDetectTcpXmasAttackEnabled']);
      }
      if (data.hasOwnProperty('applicationControlSettingRulesetMode')) {
        obj['applicationControlSettingRulesetMode'] = SettingValue.constructFromObject(data['applicationControlSettingRulesetMode']);
      }
      if (data.hasOwnProperty('antiMalwareSettingSmartProtectionGlobalServerUseProxyEnabled')) {
        obj['antiMalwareSettingSmartProtectionGlobalServerUseProxyEnabled'] = SettingValue.constructFromObject(data['antiMalwareSettingSmartProtectionGlobalServerUseProxyEnabled']);
      }
      if (data.hasOwnProperty('webReputationSettingSmartProtectionLocalServerAllowOffDomainGlobal')) {
        obj['webReputationSettingSmartProtectionLocalServerAllowOffDomainGlobal'] = SettingValue.constructFromObject(data['webReputationSettingSmartProtectionLocalServerAllowOffDomainGlobal']);
      }
      if (data.hasOwnProperty('integrityMonitoringSettingCombinedModeProtectionSource')) {
        obj['integrityMonitoringSettingCombinedModeProtectionSource'] = SettingValue.constructFromObject(data['integrityMonitoringSettingCombinedModeProtectionSource']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionCloseWaitTimeout')) {
        obj['firewallSettingEngineOptionCloseWaitTimeout'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionCloseWaitTimeout']);
      }
      if (data.hasOwnProperty('platformSettingScanOpenPortListId')) {
        obj['platformSettingScanOpenPortListId'] = SettingValue.constructFromObject(data['platformSettingScanOpenPortListId']);
      }
      if (data.hasOwnProperty('platformSettingAgentSelfProtectionPasswordEnabled')) {
        obj['platformSettingAgentSelfProtectionPasswordEnabled'] = SettingValue.constructFromObject(data['platformSettingAgentSelfProtectionPasswordEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionAckTimeout')) {
        obj['firewallSettingEngineOptionAckTimeout'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionAckTimeout']);
      }
      if (data.hasOwnProperty('firewallSettingEventLogFileCachedEntriesStaleTime')) {
        obj['firewallSettingEventLogFileCachedEntriesStaleTime'] = SettingValue.constructFromObject(data['firewallSettingEventLogFileCachedEntriesStaleTime']);
      }
      if (data.hasOwnProperty('firewallSettingCombinedModeProtectionSource')) {
        obj['firewallSettingCombinedModeProtectionSource'] = SettingValue.constructFromObject(data['firewallSettingCombinedModeProtectionSource']);
      }
      if (data.hasOwnProperty('platformSettingAgentEventsSendInterval')) {
        obj['platformSettingAgentEventsSendInterval'] = SettingValue.constructFromObject(data['platformSettingAgentEventsSendInterval']);
      }
      if (data.hasOwnProperty('platformSettingInactiveAgentCleanupOverrideEnabled')) {
        obj['platformSettingInactiveAgentCleanupOverrideEnabled'] = SettingValue.constructFromObject(data['platformSettingInactiveAgentCleanupOverrideEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingFailureResponseEngineSystem')) {
        obj['firewallSettingFailureResponseEngineSystem'] = SettingValue.constructFromObject(data['firewallSettingFailureResponseEngineSystem']);
      }
      if (data.hasOwnProperty('platformSettingRelayState')) {
        obj['platformSettingRelayState'] = SettingValue.constructFromObject(data['platformSettingRelayState']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionDropEvasiveRetransmitEnabled')) {
        obj['firewallSettingEngineOptionDropEvasiveRetransmitEnabled'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionDropEvasiveRetransmitEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingState')) {
        obj['firewallSettingState'] = SettingValue.constructFromObject(data['firewallSettingState']);
      }
      if (data.hasOwnProperty('activityMonitoringSettingIndicatorEnabled')) {
        obj['activityMonitoringSettingIndicatorEnabled'] = SettingValue.constructFromObject(data['activityMonitoringSettingIndicatorEnabled']);
      }
      if (data.hasOwnProperty('intrusionPreventionSettingEngineOptionFragmentedIpTimeout')) {
        obj['intrusionPreventionSettingEngineOptionFragmentedIpTimeout'] = SettingValue.constructFromObject(data['intrusionPreventionSettingEngineOptionFragmentedIpTimeout']);
      }
      if (data.hasOwnProperty('firewallSettingAntiEvasionCheckTcpZeroFlags')) {
        obj['firewallSettingAntiEvasionCheckTcpZeroFlags'] = SettingValue.constructFromObject(data['firewallSettingAntiEvasionCheckTcpZeroFlags']);
      }
      if (data.hasOwnProperty('webReputationSettingSmartProtectionGlobalServerUseProxyEnabled')) {
        obj['webReputationSettingSmartProtectionGlobalServerUseProxyEnabled'] = SettingValue.constructFromObject(data['webReputationSettingSmartProtectionGlobalServerUseProxyEnabled']);
      }
      if (data.hasOwnProperty('intrusionPreventionSettingNsxSecurityTaggingPreventModeLevel')) {
        obj['intrusionPreventionSettingNsxSecurityTaggingPreventModeLevel'] = SettingValue.constructFromObject(data['intrusionPreventionSettingNsxSecurityTaggingPreventModeLevel']);
      }
      if (data.hasOwnProperty('firewallSettingReconnaissanceNotifyTcpXmasAttackEnabled')) {
        obj['firewallSettingReconnaissanceNotifyTcpXmasAttackEnabled'] = SettingValue.constructFromObject(data['firewallSettingReconnaissanceNotifyTcpXmasAttackEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionUdpTimeout')) {
        obj['firewallSettingEngineOptionUdpTimeout'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionUdpTimeout']);
      }
      if (data.hasOwnProperty('webReputationSettingSmartProtectionLocalServerEnabled')) {
        obj['webReputationSettingSmartProtectionLocalServerEnabled'] = SettingValue.constructFromObject(data['webReputationSettingSmartProtectionLocalServerEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionTcpMssLimit')) {
        obj['firewallSettingEngineOptionTcpMssLimit'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionTcpMssLimit']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionColdStartTimeout')) {
        obj['firewallSettingEngineOptionColdStartTimeout'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionColdStartTimeout']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionEstablishedTimeout')) {
        obj['firewallSettingEngineOptionEstablishedTimeout'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionEstablishedTimeout']);
      }
      if (data.hasOwnProperty('antiMalwareSettingIdentifiedFilesSpaceMaxMbytes')) {
        obj['antiMalwareSettingIdentifiedFilesSpaceMaxMbytes'] = SettingValue.constructFromObject(data['antiMalwareSettingIdentifiedFilesSpaceMaxMbytes']);
      }
      if (data.hasOwnProperty('webReputationSettingState')) {
        obj['webReputationSettingState'] = SettingValue.constructFromObject(data['webReputationSettingState']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionAllowNullIpEnabled')) {
        obj['firewallSettingEngineOptionAllowNullIpEnabled'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionAllowNullIpEnabled']);
      }
      if (data.hasOwnProperty('platformSettingNotificationsSuppressPopupsEnabled')) {
        obj['platformSettingNotificationsSuppressPopupsEnabled'] = SettingValue.constructFromObject(data['platformSettingNotificationsSuppressPopupsEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingAntiEvasionCheckTcpRstFinFlags')) {
        obj['firewallSettingAntiEvasionCheckTcpRstFinFlags'] = SettingValue.constructFromObject(data['firewallSettingAntiEvasionCheckTcpRstFinFlags']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionDisconnectTimeout')) {
        obj['firewallSettingEngineOptionDisconnectTimeout'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionDisconnectTimeout']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionCloseTimeout')) {
        obj['firewallSettingEngineOptionCloseTimeout'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionCloseTimeout']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionTunnelDepthMaxExceededAction')) {
        obj['firewallSettingEngineOptionTunnelDepthMaxExceededAction'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionTunnelDepthMaxExceededAction']);
      }
      if (data.hasOwnProperty('firewallSettingReconnaissanceDetectTcpNullScanEnabled')) {
        obj['firewallSettingReconnaissanceDetectTcpNullScanEnabled'] = SettingValue.constructFromObject(data['firewallSettingReconnaissanceDetectTcpNullScanEnabled']);
      }
      if (data.hasOwnProperty('platformSettingSmartProtectionAntiMalwareGlobalServerProxyId')) {
        obj['platformSettingSmartProtectionAntiMalwareGlobalServerProxyId'] = SettingValue.constructFromObject(data['platformSettingSmartProtectionAntiMalwareGlobalServerProxyId']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionFilterIpv4Tunnels')) {
        obj['firewallSettingEngineOptionFilterIpv4Tunnels'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionFilterIpv4Tunnels']);
      }
      if (data.hasOwnProperty('webReputationSettingSmartProtectionLocalServerUrls')) {
        obj['webReputationSettingSmartProtectionLocalServerUrls'] = SettingValue.constructFromObject(data['webReputationSettingSmartProtectionLocalServerUrls']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionLogOnePacketPeriod')) {
        obj['firewallSettingEngineOptionLogOnePacketPeriod'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionLogOnePacketPeriod']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionFilterIpv6Tunnels')) {
        obj['firewallSettingEngineOptionFilterIpv6Tunnels'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionFilterIpv6Tunnels']);
      }
      if (data.hasOwnProperty('firewallSettingAntiEvasionCheckTcpCongestionFlags')) {
        obj['firewallSettingAntiEvasionCheckTcpCongestionFlags'] = SettingValue.constructFromObject(data['firewallSettingAntiEvasionCheckTcpCongestionFlags']);
      }
      if (data.hasOwnProperty('platformSettingHeartbeatMissedAlertThreshold')) {
        obj['platformSettingHeartbeatMissedAlertThreshold'] = SettingValue.constructFromObject(data['platformSettingHeartbeatMissedAlertThreshold']);
      }
      if (data.hasOwnProperty('intrusionPreventionSettingEngineOptionsEnabled')) {
        obj['intrusionPreventionSettingEngineOptionsEnabled'] = SettingValue.constructFromObject(data['intrusionPreventionSettingEngineOptionsEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionConnectionsNumUdpMax')) {
        obj['firewallSettingEngineOptionConnectionsNumUdpMax'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionConnectionsNumUdpMax']);
      }
      if (data.hasOwnProperty('integrityMonitoringSettingAutoApplyRecommendationsEnabled')) {
        obj['integrityMonitoringSettingAutoApplyRecommendationsEnabled'] = SettingValue.constructFromObject(data['integrityMonitoringSettingAutoApplyRecommendationsEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionTunnelDepthMax')) {
        obj['firewallSettingEngineOptionTunnelDepthMax'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionTunnelDepthMax']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionDropUnknownSslProtocolEnabled')) {
        obj['firewallSettingEngineOptionDropUnknownSslProtocolEnabled'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionDropUnknownSslProtocolEnabled']);
      }
      if (data.hasOwnProperty('antiMalwareSettingNsxSecurityTaggingValue')) {
        obj['antiMalwareSettingNsxSecurityTaggingValue'] = SettingValue.constructFromObject(data['antiMalwareSettingNsxSecurityTaggingValue']);
      }
      if (data.hasOwnProperty('intrusionPreventionSettingLogDataRuleFirstMatchEnabled')) {
        obj['intrusionPreventionSettingLogDataRuleFirstMatchEnabled'] = SettingValue.constructFromObject(data['intrusionPreventionSettingLogDataRuleFirstMatchEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionLoggingPolicy')) {
        obj['firewallSettingEngineOptionLoggingPolicy'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionLoggingPolicy']);
      }
      if (data.hasOwnProperty('platformSettingTroubleshootingLoggingLevel')) {
        obj['platformSettingTroubleshootingLoggingLevel'] = SettingValue.constructFromObject(data['platformSettingTroubleshootingLoggingLevel']);
      }
      if (data.hasOwnProperty('antiMalwareSettingVirtualApplianceOnDemandScanCacheEntriesMax')) {
        obj['antiMalwareSettingVirtualApplianceOnDemandScanCacheEntriesMax'] = SettingValue.constructFromObject(data['antiMalwareSettingVirtualApplianceOnDemandScanCacheEntriesMax']);
      }
      if (data.hasOwnProperty('webReputationSettingCombinedModeProtectionSource')) {
        obj['webReputationSettingCombinedModeProtectionSource'] = SettingValue.constructFromObject(data['webReputationSettingCombinedModeProtectionSource']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionClosingTimeout')) {
        obj['firewallSettingEngineOptionClosingTimeout'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionClosingTimeout']);
      }
      if (data.hasOwnProperty('antiMalwareSettingState')) {
        obj['antiMalwareSettingState'] = SettingValue.constructFromObject(data['antiMalwareSettingState']);
      }
      if (data.hasOwnProperty('firewallSettingAntiEvasionCheckPaws')) {
        obj['firewallSettingAntiEvasionCheckPaws'] = SettingValue.constructFromObject(data['firewallSettingAntiEvasionCheckPaws']);
      }
      if (data.hasOwnProperty('intrusionPreventionSettingAutoApplyRecommendationsEnabled')) {
        obj['intrusionPreventionSettingAutoApplyRecommendationsEnabled'] = SettingValue.constructFromObject(data['intrusionPreventionSettingAutoApplyRecommendationsEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingReconnaissanceDetectFingerprintProbeEnabled')) {
        obj['firewallSettingReconnaissanceDetectFingerprintProbeEnabled'] = SettingValue.constructFromObject(data['firewallSettingReconnaissanceDetectFingerprintProbeEnabled']);
      }
      if (data.hasOwnProperty('antiMalwareSettingNsxSecurityTaggingRemoveOnCleanScanEnabled')) {
        obj['antiMalwareSettingNsxSecurityTaggingRemoveOnCleanScanEnabled'] = SettingValue.constructFromObject(data['antiMalwareSettingNsxSecurityTaggingRemoveOnCleanScanEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionLogPacketLengthMax')) {
        obj['firewallSettingEngineOptionLogPacketLengthMax'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionLogPacketLengthMax']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionDropTeredoAnomaliesEnabled')) {
        obj['firewallSettingEngineOptionDropTeredoAnomaliesEnabled'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionDropTeredoAnomaliesEnabled']);
      }
      if (data.hasOwnProperty('webReputationSettingSecurityLevel')) {
        obj['webReputationSettingSecurityLevel'] = SettingValue.constructFromObject(data['webReputationSettingSecurityLevel']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionDropIpv6SiteLocalAddressesEnabled')) {
        obj['firewallSettingEngineOptionDropIpv6SiteLocalAddressesEnabled'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionDropIpv6SiteLocalAddressesEnabled']);
      }
      if (data.hasOwnProperty('logInspectionSettingState')) {
        obj['logInspectionSettingState'] = SettingValue.constructFromObject(data['logInspectionSettingState']);
      }
      if (data.hasOwnProperty('activityMonitoringSettingActivityEnabled')) {
        obj['activityMonitoringSettingActivityEnabled'] = SettingValue.constructFromObject(data['activityMonitoringSettingActivityEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionStrictTerodoPortCheckEnabled')) {
        obj['firewallSettingEngineOptionStrictTerodoPortCheckEnabled'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionStrictTerodoPortCheckEnabled']);
      }
      if (data.hasOwnProperty('webReputationSettingBlockedUrlKeywords')) {
        obj['webReputationSettingBlockedUrlKeywords'] = SettingValue.constructFromObject(data['webReputationSettingBlockedUrlKeywords']);
      }
      if (data.hasOwnProperty('webReputationSettingSyslogConfigId')) {
        obj['webReputationSettingSyslogConfigId'] = SettingValue.constructFromObject(data['webReputationSettingSyslogConfigId']);
      }
      if (data.hasOwnProperty('firewallSettingFailureResponsePacketSanityCheck')) {
        obj['firewallSettingFailureResponsePacketSanityCheck'] = SettingValue.constructFromObject(data['firewallSettingFailureResponsePacketSanityCheck']);
      }
      if (data.hasOwnProperty('firewallSettingNetworkEngineMode')) {
        obj['firewallSettingNetworkEngineMode'] = SettingValue.constructFromObject(data['firewallSettingNetworkEngineMode']);
      }
      if (data.hasOwnProperty('firewallSettingEventLogFileSizeMax')) {
        obj['firewallSettingEventLogFileSizeMax'] = SettingValue.constructFromObject(data['firewallSettingEventLogFileSizeMax']);
      }
      if (data.hasOwnProperty('antiMalwareSettingMalwareScanMultithreadedProcessingEnabled')) {
        obj['antiMalwareSettingMalwareScanMultithreadedProcessingEnabled'] = SettingValue.constructFromObject(data['antiMalwareSettingMalwareScanMultithreadedProcessingEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingReconnaissanceDetectTcpSynFinScanEnabled')) {
        obj['firewallSettingReconnaissanceDetectTcpSynFinScanEnabled'] = SettingValue.constructFromObject(data['firewallSettingReconnaissanceDetectTcpSynFinScanEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionDropIpZeroPayloadEnabled')) {
        obj['firewallSettingEngineOptionDropIpZeroPayloadEnabled'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionDropIpZeroPayloadEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionBlockIpv6Agent8AndEarlierEnabled')) {
        obj['firewallSettingEngineOptionBlockIpv6Agent8AndEarlierEnabled'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionBlockIpv6Agent8AndEarlierEnabled']);
      }
      if (data.hasOwnProperty('intrusionPreventionSettingEngineOptionFragmentedIpPacketSendIcmpEnabled')) {
        obj['intrusionPreventionSettingEngineOptionFragmentedIpPacketSendIcmpEnabled'] = SettingValue.constructFromObject(data['intrusionPreventionSettingEngineOptionFragmentedIpPacketSendIcmpEnabled']);
      }
      if (data.hasOwnProperty('antiMalwareSettingPredictiveMachineLearningExceptions')) {
        obj['antiMalwareSettingPredictiveMachineLearningExceptions'] = SettingValue.constructFromObject(data['antiMalwareSettingPredictiveMachineLearningExceptions']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionLogEventsPerSecondMax')) {
        obj['firewallSettingEngineOptionLogEventsPerSecondMax'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionLogEventsPerSecondMax']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionSslSessionTime')) {
        obj['firewallSettingEngineOptionSslSessionTime'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionSslSessionTime']);
      }
      if (data.hasOwnProperty('antiMalwareSettingBehaviorMonitoringScanExclusionList')) {
        obj['antiMalwareSettingBehaviorMonitoringScanExclusionList'] = SettingValue.constructFromObject(data['antiMalwareSettingBehaviorMonitoringScanExclusionList']);
      }
      if (data.hasOwnProperty('antiMalwareSettingSmartProtectionGlobalServerEnabled')) {
        obj['antiMalwareSettingSmartProtectionGlobalServerEnabled'] = SettingValue.constructFromObject(data['antiMalwareSettingSmartProtectionGlobalServerEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionLogOnePacketWithinPeriodEnabled')) {
        obj['firewallSettingEngineOptionLogOnePacketWithinPeriodEnabled'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionLogOnePacketWithinPeriodEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionGenerateConnectionEventsIcmpEnabled')) {
        obj['firewallSettingEngineOptionGenerateConnectionEventsIcmpEnabled'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionGenerateConnectionEventsIcmpEnabled']);
      }
      if (data.hasOwnProperty('platformSettingHeartbeatInactiveVmOfflineAlertEnabled')) {
        obj['platformSettingHeartbeatInactiveVmOfflineAlertEnabled'] = SettingValue.constructFromObject(data['platformSettingHeartbeatInactiveVmOfflineAlertEnabled']);
      }
      if (data.hasOwnProperty('webReputationSettingSmartProtectionWebReputationGlobalServerProxyId')) {
        obj['webReputationSettingSmartProtectionWebReputationGlobalServerProxyId'] = SettingValue.constructFromObject(data['webReputationSettingSmartProtectionWebReputationGlobalServerProxyId']);
      }
      if (data.hasOwnProperty('antiMalwareSettingNsxSecurityTaggingEnabled')) {
        obj['antiMalwareSettingNsxSecurityTaggingEnabled'] = SettingValue.constructFromObject(data['antiMalwareSettingNsxSecurityTaggingEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingAntiEvasionCheckFragmentedPackets')) {
        obj['firewallSettingAntiEvasionCheckFragmentedPackets'] = SettingValue.constructFromObject(data['firewallSettingAntiEvasionCheckFragmentedPackets']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionConnectionsNumIcmpMax')) {
        obj['firewallSettingEngineOptionConnectionsNumIcmpMax'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionConnectionsNumIcmpMax']);
      }
      if (data.hasOwnProperty('firewallSettingAntiEvasionCheckTcpSplitHandshake')) {
        obj['firewallSettingAntiEvasionCheckTcpSplitHandshake'] = SettingValue.constructFromObject(data['firewallSettingAntiEvasionCheckTcpSplitHandshake']);
      }
      if (data.hasOwnProperty('antiMalwareSettingCombinedModeProtectionSource')) {
        obj['antiMalwareSettingCombinedModeProtectionSource'] = SettingValue.constructFromObject(data['antiMalwareSettingCombinedModeProtectionSource']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionEventNodesMax')) {
        obj['firewallSettingEngineOptionEventNodesMax'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionEventNodesMax']);
      }
      if (data.hasOwnProperty('webReputationSettingMonitorPortListId')) {
        obj['webReputationSettingMonitorPortListId'] = SettingValue.constructFromObject(data['webReputationSettingMonitorPortListId']);
      }
      if (data.hasOwnProperty('sapSettingState')) {
        obj['sapSettingState'] = SettingValue.constructFromObject(data['sapSettingState']);
      }
      if (data.hasOwnProperty('applicationControlSettingSyslogConfigId')) {
        obj['applicationControlSettingSyslogConfigId'] = SettingValue.constructFromObject(data['applicationControlSettingSyslogConfigId']);
      }
      if (data.hasOwnProperty('firewallSettingAntiEvasionCheckOutNoConnection')) {
        obj['firewallSettingAntiEvasionCheckOutNoConnection'] = SettingValue.constructFromObject(data['firewallSettingAntiEvasionCheckOutNoConnection']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionBlockIpv6Agent9AndLaterEnabled')) {
        obj['firewallSettingEngineOptionBlockIpv6Agent9AndLaterEnabled'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionBlockIpv6Agent9AndLaterEnabled']);
      }
      if (data.hasOwnProperty('integrityMonitoringSettingVirtualApplianceOptimizationScanCacheEntriesMax')) {
        obj['integrityMonitoringSettingVirtualApplianceOptimizationScanCacheEntriesMax'] = SettingValue.constructFromObject(data['integrityMonitoringSettingVirtualApplianceOptimizationScanCacheEntriesMax']);
      }
      if (data.hasOwnProperty('firewallSettingReconnaissanceNotifyTcpNullScanEnabled')) {
        obj['firewallSettingReconnaissanceNotifyTcpNullScanEnabled'] = SettingValue.constructFromObject(data['firewallSettingReconnaissanceNotifyTcpNullScanEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionIgnoreStatusCode1')) {
        obj['firewallSettingEngineOptionIgnoreStatusCode1'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionIgnoreStatusCode1']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionIgnoreStatusCode0')) {
        obj['firewallSettingEngineOptionIgnoreStatusCode0'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionIgnoreStatusCode0']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionIgnoreStatusCode2')) {
        obj['firewallSettingEngineOptionIgnoreStatusCode2'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionIgnoreStatusCode2']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionSslSessionSize')) {
        obj['firewallSettingEngineOptionSslSessionSize'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionSslSessionSize']);
      }
      if (data.hasOwnProperty('antiMalwareSettingScanCacheRealTimeConfigId')) {
        obj['antiMalwareSettingScanCacheRealTimeConfigId'] = SettingValue.constructFromObject(data['antiMalwareSettingScanCacheRealTimeConfigId']);
      }
      if (data.hasOwnProperty('platformSettingRecommendationOngoingScansInterval')) {
        obj['platformSettingRecommendationOngoingScansInterval'] = SettingValue.constructFromObject(data['platformSettingRecommendationOngoingScansInterval']);
      }
      if (data.hasOwnProperty('platformSettingSmartProtectionGlobalServerUseProxyEnabled')) {
        obj['platformSettingSmartProtectionGlobalServerUseProxyEnabled'] = SettingValue.constructFromObject(data['platformSettingSmartProtectionGlobalServerUseProxyEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingInterfaceLimitOneActiveEnabled')) {
        obj['firewallSettingInterfaceLimitOneActiveEnabled'] = SettingValue.constructFromObject(data['firewallSettingInterfaceLimitOneActiveEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingAntiEvasionCheckTcpChecksum')) {
        obj['firewallSettingAntiEvasionCheckTcpChecksum'] = SettingValue.constructFromObject(data['firewallSettingAntiEvasionCheckTcpChecksum']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionDropIpv6ExtType0Enabled')) {
        obj['firewallSettingEngineOptionDropIpv6ExtType0Enabled'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionDropIpv6ExtType0Enabled']);
      }
      if (data.hasOwnProperty('antiMalwareSettingScanFileSizeMaxMbytes')) {
        obj['antiMalwareSettingScanFileSizeMaxMbytes'] = SettingValue.constructFromObject(data['antiMalwareSettingScanFileSizeMaxMbytes']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionGenerateConnectionEventsTcpEnabled')) {
        obj['firewallSettingEngineOptionGenerateConnectionEventsTcpEnabled'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionGenerateConnectionEventsTcpEnabled']);
      }
      if (data.hasOwnProperty('antiMalwareSettingFileHashSizeMaxMbytes')) {
        obj['antiMalwareSettingFileHashSizeMaxMbytes'] = SettingValue.constructFromObject(data['antiMalwareSettingFileHashSizeMaxMbytes']);
      }
      if (data.hasOwnProperty('firewallSettingEventLogFileCachedEntriesLifeTime')) {
        obj['firewallSettingEventLogFileCachedEntriesLifeTime'] = SettingValue.constructFromObject(data['firewallSettingEventLogFileCachedEntriesLifeTime']);
      }
      if (data.hasOwnProperty('platformSettingSmartProtectionGlobalServerProxyId')) {
        obj['platformSettingSmartProtectionGlobalServerProxyId'] = SettingValue.constructFromObject(data['platformSettingSmartProtectionGlobalServerProxyId']);
      }
      if (data.hasOwnProperty('logInspectionSettingAutoApplyRecommendationsEnabled')) {
        obj['logInspectionSettingAutoApplyRecommendationsEnabled'] = SettingValue.constructFromObject(data['logInspectionSettingAutoApplyRecommendationsEnabled']);
      }
      if (data.hasOwnProperty('antiMalwareSettingConnectedThreatDefenseSuspiciousFileDdanSubmissionEnabled')) {
        obj['antiMalwareSettingConnectedThreatDefenseSuspiciousFileDdanSubmissionEnabled'] = SettingValue.constructFromObject(data['antiMalwareSettingConnectedThreatDefenseSuspiciousFileDdanSubmissionEnabled']);
      }
      if (data.hasOwnProperty('webReputationSettingBlockingPageLink')) {
        obj['webReputationSettingBlockingPageLink'] = SettingValue.constructFromObject(data['webReputationSettingBlockingPageLink']);
      }
      if (data.hasOwnProperty('firewallSettingSyslogConfigId')) {
        obj['firewallSettingSyslogConfigId'] = SettingValue.constructFromObject(data['firewallSettingSyslogConfigId']);
      }
      if (data.hasOwnProperty('platformSettingAgentCommunicationsDirection')) {
        obj['platformSettingAgentCommunicationsDirection'] = SettingValue.constructFromObject(data['platformSettingAgentCommunicationsDirection']);
      }
      if (data.hasOwnProperty('integrityMonitoringSettingScanCacheConfigId')) {
        obj['integrityMonitoringSettingScanCacheConfigId'] = SettingValue.constructFromObject(data['integrityMonitoringSettingScanCacheConfigId']);
      }
      if (data.hasOwnProperty('antiMalwareSettingDocumentExploitProtectionRuleExceptions')) {
        obj['antiMalwareSettingDocumentExploitProtectionRuleExceptions'] = SettingValue.constructFromObject(data['antiMalwareSettingDocumentExploitProtectionRuleExceptions']);
      }
      if (data.hasOwnProperty('firewallSettingAntiEvasionCheckTcpSynWithData')) {
        obj['firewallSettingAntiEvasionCheckTcpSynWithData'] = SettingValue.constructFromObject(data['firewallSettingAntiEvasionCheckTcpSynWithData']);
      }
      if (data.hasOwnProperty('antiMalwareSettingFileHashEnabled')) {
        obj['antiMalwareSettingFileHashEnabled'] = SettingValue.constructFromObject(data['antiMalwareSettingFileHashEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingReconnaissanceBlockFingerprintProbeDuration')) {
        obj['firewallSettingReconnaissanceBlockFingerprintProbeDuration'] = SettingValue.constructFromObject(data['firewallSettingReconnaissanceBlockFingerprintProbeDuration']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionDropIpv6BogonsAddressesEnabled')) {
        obj['firewallSettingEngineOptionDropIpv6BogonsAddressesEnabled'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionDropIpv6BogonsAddressesEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionBootStartTimeout')) {
        obj['firewallSettingEngineOptionBootStartTimeout'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionBootStartTimeout']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionConnectionsNumTcpMax')) {
        obj['firewallSettingEngineOptionConnectionsNumTcpMax'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionConnectionsNumTcpMax']);
      }
      if (data.hasOwnProperty('firewallSettingAntiEvasionSecurityPosture')) {
        obj['firewallSettingAntiEvasionSecurityPosture'] = SettingValue.constructFromObject(data['firewallSettingAntiEvasionSecurityPosture']);
      }
      if (data.hasOwnProperty('firewallSettingInterfacePatterns')) {
        obj['firewallSettingInterfacePatterns'] = SettingValue.constructFromObject(data['firewallSettingInterfacePatterns']);
      }
      if (data.hasOwnProperty('firewallSettingInterfaceIsolationEnabled')) {
        obj['firewallSettingInterfaceIsolationEnabled'] = SettingValue.constructFromObject(data['firewallSettingInterfaceIsolationEnabled']);
      }
      if (data.hasOwnProperty('antiMalwareSettingVirtualApplianceRealTimeScanCacheEntriesMax')) {
        obj['antiMalwareSettingVirtualApplianceRealTimeScanCacheEntriesMax'] = SettingValue.constructFromObject(data['antiMalwareSettingVirtualApplianceRealTimeScanCacheEntriesMax']);
      }
      if (data.hasOwnProperty('firewallSettingEventsOutOfAllowedPolicyEnabled')) {
        obj['firewallSettingEventsOutOfAllowedPolicyEnabled'] = SettingValue.constructFromObject(data['firewallSettingEventsOutOfAllowedPolicyEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingAntiEvasionCheckEvasiveRetransmit')) {
        obj['firewallSettingAntiEvasionCheckEvasiveRetransmit'] = SettingValue.constructFromObject(data['firewallSettingAntiEvasionCheckEvasiveRetransmit']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionIcmpTimeout')) {
        obj['firewallSettingEngineOptionIcmpTimeout'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionIcmpTimeout']);
      }
      if (data.hasOwnProperty('integrityMonitoringSettingSyslogConfigId')) {
        obj['integrityMonitoringSettingSyslogConfigId'] = SettingValue.constructFromObject(data['integrityMonitoringSettingSyslogConfigId']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionConnectionCleanupTimeout')) {
        obj['firewallSettingEngineOptionConnectionCleanupTimeout'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionConnectionCleanupTimeout']);
      }
      if (data.hasOwnProperty('antiMalwareSettingSmartProtectionLocalServerAllowOffDomainGlobal')) {
        obj['antiMalwareSettingSmartProtectionLocalServerAllowOffDomainGlobal'] = SettingValue.constructFromObject(data['antiMalwareSettingSmartProtectionLocalServerAllowOffDomainGlobal']);
      }
      if (data.hasOwnProperty('firewallSettingReconnaissanceNotifyTcpSynFinScanEnabled')) {
        obj['firewallSettingReconnaissanceNotifyTcpSynFinScanEnabled'] = SettingValue.constructFromObject(data['firewallSettingReconnaissanceNotifyTcpSynFinScanEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionErrorTimeout')) {
        obj['firewallSettingEngineOptionErrorTimeout'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionErrorTimeout']);
      }
      if (data.hasOwnProperty('integrityMonitoringSettingState')) {
        obj['integrityMonitoringSettingState'] = SettingValue.constructFromObject(data['integrityMonitoringSettingState']);
      }
      if (data.hasOwnProperty('webReputationSettingAllowedUrls')) {
        obj['webReputationSettingAllowedUrls'] = SettingValue.constructFromObject(data['webReputationSettingAllowedUrls']);
      }
      if (data.hasOwnProperty('firewallSettingReconnaissanceNotifyNetworkOrPortScanEnabled')) {
        obj['firewallSettingReconnaissanceNotifyNetworkOrPortScanEnabled'] = SettingValue.constructFromObject(data['firewallSettingReconnaissanceNotifyNetworkOrPortScanEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionFinWait1Timeout')) {
        obj['firewallSettingEngineOptionFinWait1Timeout'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionFinWait1Timeout']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionGenerateConnectionEventsUdpEnabled')) {
        obj['firewallSettingEngineOptionGenerateConnectionEventsUdpEnabled'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionGenerateConnectionEventsUdpEnabled']);
      }
      if (data.hasOwnProperty('activityMonitoringSettingSyslogConfigId')) {
        obj['activityMonitoringSettingSyslogConfigId'] = SettingValue.constructFromObject(data['activityMonitoringSettingSyslogConfigId']);
      }
      if (data.hasOwnProperty('firewallSettingAntiEvasionCheckTcpSynRstFlags')) {
        obj['firewallSettingAntiEvasionCheckTcpSynRstFlags'] = SettingValue.constructFromObject(data['firewallSettingAntiEvasionCheckTcpSynRstFlags']);
      }
      if (data.hasOwnProperty('antiMalwareSettingSpywareApprovedList')) {
        obj['antiMalwareSettingSpywareApprovedList'] = SettingValue.constructFromObject(data['antiMalwareSettingSpywareApprovedList']);
      }
      if (data.hasOwnProperty('activityMonitoringSettingState')) {
        obj['activityMonitoringSettingState'] = SettingValue.constructFromObject(data['activityMonitoringSettingState']);
      }
      if (data.hasOwnProperty('firewallSettingAntiEvasionCheckTcpUrgentFlags')) {
        obj['firewallSettingAntiEvasionCheckTcpUrgentFlags'] = SettingValue.constructFromObject(data['firewallSettingAntiEvasionCheckTcpUrgentFlags']);
      }
      if (data.hasOwnProperty('intrusionPreventionSettingNsxSecurityTaggingDetectModeLevel')) {
        obj['intrusionPreventionSettingNsxSecurityTaggingDetectModeLevel'] = SettingValue.constructFromObject(data['intrusionPreventionSettingNsxSecurityTaggingDetectModeLevel']);
      }
      if (data.hasOwnProperty('intrusionPreventionSettingEngineOptionFragmentedIpUnconcernedMacAddressBypassEnabled')) {
        obj['intrusionPreventionSettingEngineOptionFragmentedIpUnconcernedMacAddressBypassEnabled'] = SettingValue.constructFromObject(data['intrusionPreventionSettingEngineOptionFragmentedIpUnconcernedMacAddressBypassEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionLogAllPacketDataEnabled')) {
        obj['firewallSettingEngineOptionLogAllPacketDataEnabled'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionLogAllPacketDataEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingAntiEvasionCheckTcpSynFinFlags')) {
        obj['firewallSettingAntiEvasionCheckTcpSynFinFlags'] = SettingValue.constructFromObject(data['firewallSettingAntiEvasionCheckTcpSynFinFlags']);
      }
      if (data.hasOwnProperty('platformSettingHeartbeatInterval')) {
        obj['platformSettingHeartbeatInterval'] = SettingValue.constructFromObject(data['platformSettingHeartbeatInterval']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionFragmentSizeMin')) {
        obj['firewallSettingEngineOptionFragmentSizeMin'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionFragmentSizeMin']);
      }
      if (data.hasOwnProperty('antiMalwareSettingSmartProtectionServerConnectionLostWarningEnabled')) {
        obj['antiMalwareSettingSmartProtectionServerConnectionLostWarningEnabled'] = SettingValue.constructFromObject(data['antiMalwareSettingSmartProtectionServerConnectionLostWarningEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingReconnaissanceBlockNetworkOrPortScanDuration')) {
        obj['firewallSettingReconnaissanceBlockNetworkOrPortScanDuration'] = SettingValue.constructFromObject(data['firewallSettingReconnaissanceBlockNetworkOrPortScanDuration']);
      }
      if (data.hasOwnProperty('integrityMonitoringSettingContentHashAlgorithm')) {
        obj['integrityMonitoringSettingContentHashAlgorithm'] = SettingValue.constructFromObject(data['integrityMonitoringSettingContentHashAlgorithm']);
      }
      if (data.hasOwnProperty('antiMalwareSettingSmartScanState')) {
        obj['antiMalwareSettingSmartScanState'] = SettingValue.constructFromObject(data['antiMalwareSettingSmartScanState']);
      }
      if (data.hasOwnProperty('firewallSettingConfigPackageExceedsAlertMaxEnabled')) {
        obj['firewallSettingConfigPackageExceedsAlertMaxEnabled'] = SettingValue.constructFromObject(data['firewallSettingConfigPackageExceedsAlertMaxEnabled']);
      }
      if (data.hasOwnProperty('platformSettingEnvironmentVariableOverrides')) {
        obj['platformSettingEnvironmentVariableOverrides'] = SettingValue.constructFromObject(data['platformSettingEnvironmentVariableOverrides']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionFragmentOffsetMin')) {
        obj['firewallSettingEngineOptionFragmentOffsetMin'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionFragmentOffsetMin']);
      }
      if (data.hasOwnProperty('antiMalwareSettingSmartProtectionLocalServerUrls')) {
        obj['antiMalwareSettingSmartProtectionLocalServerUrls'] = SettingValue.constructFromObject(data['antiMalwareSettingSmartProtectionLocalServerUrls']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionSynRcvdTimeout')) {
        obj['firewallSettingEngineOptionSynRcvdTimeout'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionSynRcvdTimeout']);
      }
      if (data.hasOwnProperty('firewallSettingEventLogFileCachedEntriesNum')) {
        obj['firewallSettingEventLogFileCachedEntriesNum'] = SettingValue.constructFromObject(data['firewallSettingEventLogFileCachedEntriesNum']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionForceAllowIcmpType3Code4')) {
        obj['firewallSettingEngineOptionForceAllowIcmpType3Code4'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionForceAllowIcmpType3Code4']);
      }
      if (data.hasOwnProperty('firewallSettingReconnaissanceBlockTcpNullScanDuration')) {
        obj['firewallSettingReconnaissanceBlockTcpNullScanDuration'] = SettingValue.constructFromObject(data['firewallSettingReconnaissanceBlockTcpNullScanDuration']);
      }
      if (data.hasOwnProperty('platformSettingSmartProtectionGlobalServerEnabled')) {
        obj['platformSettingSmartProtectionGlobalServerEnabled'] = SettingValue.constructFromObject(data['platformSettingSmartProtectionGlobalServerEnabled']);
      }
      if (data.hasOwnProperty('integrityMonitoringSettingRealtimeEnabled')) {
        obj['integrityMonitoringSettingRealtimeEnabled'] = SettingValue.constructFromObject(data['integrityMonitoringSettingRealtimeEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionLastAckTimeout')) {
        obj['firewallSettingEngineOptionLastAckTimeout'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionLastAckTimeout']);
      }
      if (data.hasOwnProperty('firewallSettingReconnaissanceExcludeIpListId')) {
        obj['firewallSettingReconnaissanceExcludeIpListId'] = SettingValue.constructFromObject(data['firewallSettingReconnaissanceExcludeIpListId']);
      }
      if (data.hasOwnProperty('platformSettingAgentSelfProtectionEnabled')) {
        obj['platformSettingAgentSelfProtectionEnabled'] = SettingValue.constructFromObject(data['platformSettingAgentSelfProtectionEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionDropIpv6ReservedAddressesEnabled')) {
        obj['firewallSettingEngineOptionDropIpv6ReservedAddressesEnabled'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionDropIpv6ReservedAddressesEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingAntiEvasionCheckFinNoConnection')) {
        obj['firewallSettingAntiEvasionCheckFinNoConnection'] = SettingValue.constructFromObject(data['firewallSettingAntiEvasionCheckFinNoConnection']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionDebugPacketNumMax')) {
        obj['firewallSettingEngineOptionDebugPacketNumMax'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionDebugPacketNumMax']);
      }
      if (data.hasOwnProperty('intrusionPreventionSettingState')) {
        obj['intrusionPreventionSettingState'] = SettingValue.constructFromObject(data['intrusionPreventionSettingState']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionBypassCiscoWaasConnectionsEnabled')) {
        obj['firewallSettingEngineOptionBypassCiscoWaasConnectionsEnabled'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionBypassCiscoWaasConnectionsEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingReconnaissanceEnabled')) {
        obj['firewallSettingReconnaissanceEnabled'] = SettingValue.constructFromObject(data['firewallSettingReconnaissanceEnabled']);
      }
      if (data.hasOwnProperty('platformSettingHeartbeatLocalTimeShiftAlertThreshold')) {
        obj['platformSettingHeartbeatLocalTimeShiftAlertThreshold'] = SettingValue.constructFromObject(data['platformSettingHeartbeatLocalTimeShiftAlertThreshold']);
      }
      if (data.hasOwnProperty('antiMalwareSettingFileHashMd5Enabled')) {
        obj['antiMalwareSettingFileHashMd5Enabled'] = SettingValue.constructFromObject(data['antiMalwareSettingFileHashMd5Enabled']);
      }
      if (data.hasOwnProperty('firewallSettingReconnaissanceDetectNetworkOrPortScanEnabled')) {
        obj['firewallSettingReconnaissanceDetectNetworkOrPortScanEnabled'] = SettingValue.constructFromObject(data['firewallSettingReconnaissanceDetectNetworkOrPortScanEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionSilentTcpConnectionDropEnabled')) {
        obj['firewallSettingEngineOptionSilentTcpConnectionDropEnabled'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionSilentTcpConnectionDropEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionBlockSameSrcDstIpEnabled')) {
        obj['firewallSettingEngineOptionBlockSameSrcDstIpEnabled'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionBlockSameSrcDstIpEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionForceAllowDhcpDns')) {
        obj['firewallSettingEngineOptionForceAllowDhcpDns'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionForceAllowDhcpDns']);
      }
      if (data.hasOwnProperty('firewallSettingReconnaissanceIncludeIpListId')) {
        obj['firewallSettingReconnaissanceIncludeIpListId'] = SettingValue.constructFromObject(data['firewallSettingReconnaissanceIncludeIpListId']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionsEnabled')) {
        obj['firewallSettingEngineOptionsEnabled'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionsEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingReconnaissanceBlockTcpSynFinScanDuration')) {
        obj['firewallSettingReconnaissanceBlockTcpSynFinScanDuration'] = SettingValue.constructFromObject(data['firewallSettingReconnaissanceBlockTcpSynFinScanDuration']);
      }
      if (data.hasOwnProperty('webReputationSettingSecurityBlockUntestedPagesEnabled')) {
        obj['webReputationSettingSecurityBlockUntestedPagesEnabled'] = SettingValue.constructFromObject(data['webReputationSettingSecurityBlockUntestedPagesEnabled']);
      }
      if (data.hasOwnProperty('webReputationSettingAllowedUrlDomains')) {
        obj['webReputationSettingAllowedUrlDomains'] = SettingValue.constructFromObject(data['webReputationSettingAllowedUrlDomains']);
      }
      if (data.hasOwnProperty('firewallSettingEventLogFileIgnoreSourceIpListId')) {
        obj['firewallSettingEventLogFileIgnoreSourceIpListId'] = SettingValue.constructFromObject(data['firewallSettingEventLogFileIgnoreSourceIpListId']);
      }
      if (data.hasOwnProperty('firewallSettingEngineOptionDropIpv6FragmentsLowerThanMinMtuEnabled')) {
        obj['firewallSettingEngineOptionDropIpv6FragmentsLowerThanMinMtuEnabled'] = SettingValue.constructFromObject(data['firewallSettingEngineOptionDropIpv6FragmentsLowerThanMinMtuEnabled']);
      }
      if (data.hasOwnProperty('platformSettingAutoAssignNewIntrusionPreventionRulesEnabled')) {
        obj['platformSettingAutoAssignNewIntrusionPreventionRulesEnabled'] = SettingValue.constructFromObject(data['platformSettingAutoAssignNewIntrusionPreventionRulesEnabled']);
      }
      if (data.hasOwnProperty('firewallSettingAntiEvasionCheckRstNoConnection')) {
        obj['firewallSettingAntiEvasionCheckRstNoConnection'] = SettingValue.constructFromObject(data['firewallSettingAntiEvasionCheckRstNoConnection']);
      }
      if (data.hasOwnProperty('webReputationSettingBlockedUrls')) {
        obj['webReputationSettingBlockedUrls'] = SettingValue.constructFromObject(data['webReputationSettingBlockedUrls']);
      }
      if (data.hasOwnProperty('platformSettingCombinedModeNetworkGroupProtectionSource')) {
        obj['platformSettingCombinedModeNetworkGroupProtectionSource'] = SettingValue.constructFromObject(data['platformSettingCombinedModeNetworkGroupProtectionSource']);
      }
      if (data.hasOwnProperty('webReputationSettingAlertingEnabled')) {
        obj['webReputationSettingAlertingEnabled'] = SettingValue.constructFromObject(data['webReputationSettingAlertingEnabled']);
      }
      if (data.hasOwnProperty('antiMalwareSettingNsxSecurityTaggingOnRemediationFailureEnabled')) {
        obj['antiMalwareSettingNsxSecurityTaggingOnRemediationFailureEnabled'] = SettingValue.constructFromObject(data['antiMalwareSettingNsxSecurityTaggingOnRemediationFailureEnabled']);
      }
      if (data.hasOwnProperty('integrityMonitoringSettingCpuUsageLevel')) {
        obj['integrityMonitoringSettingCpuUsageLevel'] = SettingValue.constructFromObject(data['integrityMonitoringSettingCpuUsageLevel']);
      }
      if (data.hasOwnProperty('platformSettingAutoUpdateAntiMalwareEngineEnabled')) {
        obj['platformSettingAutoUpdateAntiMalwareEngineEnabled'] = SettingValue.constructFromObject(data['platformSettingAutoUpdateAntiMalwareEngineEnabled']);
      }
      if (data.hasOwnProperty('intrusionPreventionSettingCombinedModeProtectionSource')) {
        obj['intrusionPreventionSettingCombinedModeProtectionSource'] = SettingValue.constructFromObject(data['intrusionPreventionSettingCombinedModeProtectionSource']);
      }
    }
    return obj;
  }

  /**
   * Send Agent/Appliance events to syslog when they equal or exceed the following severity level
   * @member {module:model/SettingValue} logInspectionSettingSeverityClippingAgentEventSendSyslogLevelMin
   */
  exports.prototype['logInspectionSettingSeverityClippingAgentEventSendSyslogLevelMin'] = undefined;
  /**
   * Maximum Connections per Cleanup
   * @member {module:model/SettingValue} firewallSettingEngineOptionConnectionsCleanupMax
   */
  exports.prototype['firewallSettingEngineOptionConnectionsCleanupMax'] = undefined;
  /**
   * Verify TCP Checksum
   * @member {module:model/SettingValue} firewallSettingEngineOptionVerifyTcpChecksumEnabled
   */
  exports.prototype['firewallSettingEngineOptionVerifyTcpChecksumEnabled'] = undefined;
  /**
   * Anti-Malware On Demand Scan Cache Configuration
   * @member {module:model/SettingValue} antiMalwareSettingScanCacheOnDemandConfigId
   */
  exports.prototype['antiMalwareSettingScanCacheOnDemandConfigId'] = undefined;
  /**
   * Shared Application Control Ruleset
   * @member {module:model/SettingValue} applicationControlSettingSharedRulesetId
   */
  exports.prototype['applicationControlSettingSharedRulesetId'] = undefined;
  /**
   * Application Control State
   * @member {module:model/SettingValue} applicationControlSettingState
   */
  exports.prototype['applicationControlSettingState'] = undefined;
  /**
   * Warn if connection to Smart Protection Server is lost
   * @member {module:model/SettingValue} webReputationSettingSmartProtectionServerConnectionLostWarningEnabled
   */
  exports.prototype['webReputationSettingSmartProtectionServerConnectionLostWarningEnabled'] = undefined;
  /**
   * Enforcement:
   * @member {module:model/SettingValue} applicationControlSettingExecutionEnforcementLevel
   */
  exports.prototype['applicationControlSettingExecutionEnforcementLevel'] = undefined;
  /**
   * Blocked Domain URLs
   * @member {module:model/SettingValue} webReputationSettingBlockedUrlDomains
   */
  exports.prototype['webReputationSettingBlockedUrlDomains'] = undefined;
  /**
   * SYN_SENT Timeout
   * @member {module:model/SettingValue} firewallSettingEngineOptionSynSentTimeout
   */
  exports.prototype['firewallSettingEngineOptionSynSentTimeout'] = undefined;
  /**
   * Password
   * @member {module:model/SettingValue} platformSettingAgentSelfProtectionPassword
   */
  exports.prototype['platformSettingAgentSelfProtectionPassword'] = undefined;
  /**
   * TCP Xmas Scan - Block Traffic
   * @member {module:model/SettingValue} firewallSettingReconnaissanceBlockTcpXmasAttackDuration
   */
  exports.prototype['firewallSettingReconnaissanceBlockTcpXmasAttackDuration'] = undefined;
  /**
   * Scan container network traffic
   * @member {module:model/SettingValue} intrusionPreventionSettingVirtualAndContainerNetworkScanEnabled
   */
  exports.prototype['intrusionPreventionSettingVirtualAndContainerNetworkScanEnabled'] = undefined;
  /**
   * Log Inspection Syslog Configuration
   * @member {module:model/SettingValue} logInspectionSettingSyslogConfigId
   */
  exports.prototype['logInspectionSettingSyslogConfigId'] = undefined;
  /**
   * Enable Debug Mode
   * @member {module:model/SettingValue} firewallSettingEngineOptionDebugModeEnabled
   */
  exports.prototype['firewallSettingEngineOptionDebugModeEnabled'] = undefined;
  /**
   * Scan container network traffic
   * @member {module:model/SettingValue} firewallSettingVirtualAndContainerNetworkScanEnabled
   */
  exports.prototype['firewallSettingVirtualAndContainerNetworkScanEnabled'] = undefined;
  /**
   * SHA256
   * @member {module:model/SettingValue} antiMalwareSettingFileHashSha256Enabled
   */
  exports.prototype['antiMalwareSettingFileHashSha256Enabled'] = undefined;
  /**
   * Computer OS Fingerprint Probe - Notify DSM Immediately
   * @member {module:model/SettingValue} firewallSettingReconnaissanceNotifyFingerprintProbeEnabled
   */
  exports.prototype['firewallSettingReconnaissanceNotifyFingerprintProbeEnabled'] = undefined;
  /**
   * Number of event log files to retain (on Agent/Appliance)
   * @member {module:model/SettingValue} firewallSettingEventLogFileRetainNum
   */
  exports.prototype['firewallSettingEventLogFileRetainNum'] = undefined;
  /**
   * Timestamp PAWS Zero Allowed
   * @member {module:model/SettingValue} firewallSettingAntiEvasionCheckTcpPawsZero
   */
  exports.prototype['firewallSettingAntiEvasionCheckTcpPawsZero'] = undefined;
  /**
   * Use Apex Central's Suspicious Object List
   * @member {module:model/SettingValue} antiMalwareSettingConnectedThreatDefenseUseControlManagerSuspiciousObjectListEnabled
   */
  exports.prototype['antiMalwareSettingConnectedThreatDefenseUseControlManagerSuspiciousObjectListEnabled'] = undefined;
  /**
   * Maximum number of fragmented IP packets to keep
   * @member {module:model/SettingValue} intrusionPreventionSettingEngineOptionFragmentedIpKeepMax
   */
  exports.prototype['intrusionPreventionSettingEngineOptionFragmentedIpKeepMax'] = undefined;
  /**
   * Drop 6to4 Bogon Addresses
   * @member {module:model/SettingValue} firewallSettingEngineOptionDrop6To4BogonsAddressesEnabled
   */
  exports.prototype['firewallSettingEngineOptionDrop6To4BogonsAddressesEnabled'] = undefined;
  /**
   * Store events at the Agent/Appliance for later retrieval by DSM when they equal or exceed the following severity level
   * @member {module:model/SettingValue} logInspectionSettingSeverityClippingAgentEventStoreLevelMin
   */
  exports.prototype['logInspectionSettingSeverityClippingAgentEventStoreLevelMin'] = undefined;
  /**
   * Max Concurrent Scans
   * @member {module:model/SettingValue} platformSettingScanCacheConcurrencyMax
   */
  exports.prototype['platformSettingScanCacheConcurrencyMax'] = undefined;
  /**
   * Anti-Malware Syslog Configuration
   * @member {module:model/SettingValue} antiMalwareSettingSyslogConfigId
   */
  exports.prototype['antiMalwareSettingSyslogConfigId'] = undefined;
  /**
   * TCP Timestamp PAWS Window
   * @member {module:model/SettingValue} firewallSettingAntiEvasionTcpPawsWindowPolicy
   */
  exports.prototype['firewallSettingAntiEvasionTcpPawsWindowPolicy'] = undefined;
  /**
   * TCP Xmas Scan - Enabled
   * @member {module:model/SettingValue} firewallSettingReconnaissanceDetectTcpXmasAttackEnabled
   */
  exports.prototype['firewallSettingReconnaissanceDetectTcpXmasAttackEnabled'] = undefined;
  /**
   * Ruleset mode:
   * @member {module:model/SettingValue} applicationControlSettingRulesetMode
   */
  exports.prototype['applicationControlSettingRulesetMode'] = undefined;
  /**
   * Use Proxy when accessing Smart Protection Service for Smart Scan
   * @member {module:model/SettingValue} antiMalwareSettingSmartProtectionGlobalServerUseProxyEnabled
   */
  exports.prototype['antiMalwareSettingSmartProtectionGlobalServerUseProxyEnabled'] = undefined;
  /**
   * When off domain, connect to global Smart Protection Service. (Windows only)
   * @member {module:model/SettingValue} webReputationSettingSmartProtectionLocalServerAllowOffDomainGlobal
   */
  exports.prototype['webReputationSettingSmartProtectionLocalServerAllowOffDomainGlobal'] = undefined;
  /**
   * Integrity Monitoring
   * @member {module:model/SettingValue} integrityMonitoringSettingCombinedModeProtectionSource
   */
  exports.prototype['integrityMonitoringSettingCombinedModeProtectionSource'] = undefined;
  /**
   * CLOSE_WAIT Timeout
   * @member {module:model/SettingValue} firewallSettingEngineOptionCloseWaitTimeout
   */
  exports.prototype['firewallSettingEngineOptionCloseWaitTimeout'] = undefined;
  /**
   * Ports to scan
   * @member {module:model/SettingValue} platformSettingScanOpenPortListId
   */
  exports.prototype['platformSettingScanOpenPortListId'] = undefined;
  /**
   * Local override requires password
   * @member {module:model/SettingValue} platformSettingAgentSelfProtectionPasswordEnabled
   */
  exports.prototype['platformSettingAgentSelfProtectionPasswordEnabled'] = undefined;
  /**
   * ACK Storm Timeout
   * @member {module:model/SettingValue} firewallSettingEngineOptionAckTimeout
   */
  exports.prototype['firewallSettingEngineOptionAckTimeout'] = undefined;
  /**
   * Cache Stale time
   * @member {module:model/SettingValue} firewallSettingEventLogFileCachedEntriesStaleTime
   */
  exports.prototype['firewallSettingEventLogFileCachedEntriesStaleTime'] = undefined;
  /**
   * Firewall
   * @member {module:model/SettingValue} firewallSettingCombinedModeProtectionSource
   */
  exports.prototype['firewallSettingCombinedModeProtectionSource'] = undefined;
  /**
   * Period between sending of events
   * @member {module:model/SettingValue} platformSettingAgentEventsSendInterval
   */
  exports.prototype['platformSettingAgentEventsSendInterval'] = undefined;
  /**
   * Prevent this computer from being deleted if Inactive Agent Cleanup is enabled:
   * @member {module:model/SettingValue} platformSettingInactiveAgentCleanupOverrideEnabled
   */
  exports.prototype['platformSettingInactiveAgentCleanupOverrideEnabled'] = undefined;
  /**
   * Network Engine System Failure
   * @member {module:model/SettingValue} firewallSettingFailureResponseEngineSystem
   */
  exports.prototype['firewallSettingFailureResponseEngineSystem'] = undefined;
  /**
   * Relay State
   * @member {module:model/SettingValue} platformSettingRelayState
   */
  exports.prototype['platformSettingRelayState'] = undefined;
  /**
   * Drop Evasive Retransmit
   * @member {module:model/SettingValue} firewallSettingEngineOptionDropEvasiveRetransmitEnabled
   */
  exports.prototype['firewallSettingEngineOptionDropEvasiveRetransmitEnabled'] = undefined;
  /**
   * Firewall State
   * @member {module:model/SettingValue} firewallSettingState
   */
  exports.prototype['firewallSettingState'] = undefined;
  /**
   * Sensor Indicator Enabled
   * @member {module:model/SettingValue} activityMonitoringSettingIndicatorEnabled
   */
  exports.prototype['activityMonitoringSettingIndicatorEnabled'] = undefined;
  /**
   * Fragment Timeout
   * @member {module:model/SettingValue} intrusionPreventionSettingEngineOptionFragmentedIpTimeout
   */
  exports.prototype['intrusionPreventionSettingEngineOptionFragmentedIpTimeout'] = undefined;
  /**
   * TCP Zero Flags
   * @member {module:model/SettingValue} firewallSettingAntiEvasionCheckTcpZeroFlags
   */
  exports.prototype['firewallSettingAntiEvasionCheckTcpZeroFlags'] = undefined;
  /**
   * Use Proxy when accessing Smart Protection Service for Web Reputation
   * @member {module:model/SettingValue} webReputationSettingSmartProtectionGlobalServerUseProxyEnabled
   */
  exports.prototype['webReputationSettingSmartProtectionGlobalServerUseProxyEnabled'] = undefined;
  /**
   * Prevent Mode
   * @member {module:model/SettingValue} intrusionPreventionSettingNsxSecurityTaggingPreventModeLevel
   */
  exports.prototype['intrusionPreventionSettingNsxSecurityTaggingPreventModeLevel'] = undefined;
  /**
   * TCP Xmas Scan - Notify DSM Immediately
   * @member {module:model/SettingValue} firewallSettingReconnaissanceNotifyTcpXmasAttackEnabled
   */
  exports.prototype['firewallSettingReconnaissanceNotifyTcpXmasAttackEnabled'] = undefined;
  /**
   * UDP Timeout
   * @member {module:model/SettingValue} firewallSettingEngineOptionUdpTimeout
   */
  exports.prototype['firewallSettingEngineOptionUdpTimeout'] = undefined;
  /**
   * Use Local Smart Protection Server for Web Reputation Service
   * @member {module:model/SettingValue} webReputationSettingSmartProtectionLocalServerEnabled
   */
  exports.prototype['webReputationSettingSmartProtectionLocalServerEnabled'] = undefined;
  /**
   * TCP MSS Limit
   * @member {module:model/SettingValue} firewallSettingEngineOptionTcpMssLimit
   */
  exports.prototype['firewallSettingEngineOptionTcpMssLimit'] = undefined;
  /**
   * Cold Start Timeout
   * @member {module:model/SettingValue} firewallSettingEngineOptionColdStartTimeout
   */
  exports.prototype['firewallSettingEngineOptionColdStartTimeout'] = undefined;
  /**
   * ESTABLISHED Timeout
   * @member {module:model/SettingValue} firewallSettingEngineOptionEstablishedTimeout
   */
  exports.prototype['firewallSettingEngineOptionEstablishedTimeout'] = undefined;
  /**
   * Maximum disk space used to store identified files
   * @member {module:model/SettingValue} antiMalwareSettingIdentifiedFilesSpaceMaxMbytes
   */
  exports.prototype['antiMalwareSettingIdentifiedFilesSpaceMaxMbytes'] = undefined;
  /**
   * Web Reputation State
   * @member {module:model/SettingValue} webReputationSettingState
   */
  exports.prototype['webReputationSettingState'] = undefined;
  /**
   * Allow Null IP
   * @member {module:model/SettingValue} firewallSettingEngineOptionAllowNullIpEnabled
   */
  exports.prototype['firewallSettingEngineOptionAllowNullIpEnabled'] = undefined;
  /**
   * Suppress all pop-up notifications on host
   * @member {module:model/SettingValue} platformSettingNotificationsSuppressPopupsEnabled
   */
  exports.prototype['platformSettingNotificationsSuppressPopupsEnabled'] = undefined;
  /**
   * TCP Rst Fin Flags
   * @member {module:model/SettingValue} firewallSettingAntiEvasionCheckTcpRstFinFlags
   */
  exports.prototype['firewallSettingAntiEvasionCheckTcpRstFinFlags'] = undefined;
  /**
   * DISCONNECT Timeout
   * @member {module:model/SettingValue} firewallSettingEngineOptionDisconnectTimeout
   */
  exports.prototype['firewallSettingEngineOptionDisconnectTimeout'] = undefined;
  /**
   * CLOSED Timeout
   * @member {module:model/SettingValue} firewallSettingEngineOptionCloseTimeout
   */
  exports.prototype['firewallSettingEngineOptionCloseTimeout'] = undefined;
  /**
   * Action if Maximum Tunnel Depth Exceeded
   * @member {module:model/SettingValue} firewallSettingEngineOptionTunnelDepthMaxExceededAction
   */
  exports.prototype['firewallSettingEngineOptionTunnelDepthMaxExceededAction'] = undefined;
  /**
   * TCP Null Scan - Enabled
   * @member {module:model/SettingValue} firewallSettingReconnaissanceDetectTcpNullScanEnabled
   */
  exports.prototype['firewallSettingReconnaissanceDetectTcpNullScanEnabled'] = undefined;
  /**
   * Use Proxy when accessing Smart Protection Service for Smart Scan
   * @member {module:model/SettingValue} platformSettingSmartProtectionAntiMalwareGlobalServerProxyId
   */
  exports.prototype['platformSettingSmartProtectionAntiMalwareGlobalServerProxyId'] = undefined;
  /**
   * Filter IPv4 Tunnels
   * @member {module:model/SettingValue} firewallSettingEngineOptionFilterIpv4Tunnels
   */
  exports.prototype['firewallSettingEngineOptionFilterIpv4Tunnels'] = undefined;
  /**
   * Local Smart Protection Servers for Web Reputation
   * @member {module:model/SettingValue} webReputationSettingSmartProtectionLocalServerUrls
   */
  exports.prototype['webReputationSettingSmartProtectionLocalServerUrls'] = undefined;
  /**
   * Period for Log only one packet within period
   * @member {module:model/SettingValue} firewallSettingEngineOptionLogOnePacketPeriod
   */
  exports.prototype['firewallSettingEngineOptionLogOnePacketPeriod'] = undefined;
  /**
   * Filter IPv6 Tunnels
   * @member {module:model/SettingValue} firewallSettingEngineOptionFilterIpv6Tunnels
   */
  exports.prototype['firewallSettingEngineOptionFilterIpv6Tunnels'] = undefined;
  /**
   * TCP Congestion Flags
   * @member {module:model/SettingValue} firewallSettingAntiEvasionCheckTcpCongestionFlags
   */
  exports.prototype['firewallSettingAntiEvasionCheckTcpCongestionFlags'] = undefined;
  /**
   * Number of Heartbeats that can be missed before an alert is raised
   * @member {module:model/SettingValue} platformSettingHeartbeatMissedAlertThreshold
   */
  exports.prototype['platformSettingHeartbeatMissedAlertThreshold'] = undefined;
  /**
   * Use custom driver settings
   * @member {module:model/SettingValue} intrusionPreventionSettingEngineOptionsEnabled
   */
  exports.prototype['intrusionPreventionSettingEngineOptionsEnabled'] = undefined;
  /**
   * Maximum UDP Connections
   * @member {module:model/SettingValue} firewallSettingEngineOptionConnectionsNumUdpMax
   */
  exports.prototype['firewallSettingEngineOptionConnectionsNumUdpMax'] = undefined;
  /**
   * Automatically assign/unassign recommended Integrity Monitoring Rules to Computer during Recommendation Scans
   * @member {module:model/SettingValue} integrityMonitoringSettingAutoApplyRecommendationsEnabled
   */
  exports.prototype['integrityMonitoringSettingAutoApplyRecommendationsEnabled'] = undefined;
  /**
   * Maximum Tunnel Depth
   * @member {module:model/SettingValue} firewallSettingEngineOptionTunnelDepthMax
   */
  exports.prototype['firewallSettingEngineOptionTunnelDepthMax'] = undefined;
  /**
   * Drop Unknown SSL Protocol
   * @member {module:model/SettingValue} firewallSettingEngineOptionDropUnknownSslProtocolEnabled
   */
  exports.prototype['firewallSettingEngineOptionDropUnknownSslProtocolEnabled'] = undefined;
  /**
   * Anti-Malware NSX Security Tag
   * @member {module:model/SettingValue} antiMalwareSettingNsxSecurityTaggingValue
   */
  exports.prototype['antiMalwareSettingNsxSecurityTaggingValue'] = undefined;
  /**
   * Allow Intrusion Prevention Rules to capture data for first hit of each rule (in period)
   * @member {module:model/SettingValue} intrusionPreventionSettingLogDataRuleFirstMatchEnabled
   */
  exports.prototype['intrusionPreventionSettingLogDataRuleFirstMatchEnabled'] = undefined;
  /**
   * Advanced Logging Policy
   * @member {module:model/SettingValue} firewallSettingEngineOptionLoggingPolicy
   */
  exports.prototype['firewallSettingEngineOptionLoggingPolicy'] = undefined;
  /**
   * Logging Level
   * @member {module:model/SettingValue} platformSettingTroubleshootingLoggingLevel
   */
  exports.prototype['platformSettingTroubleshootingLoggingLevel'] = undefined;
  /**
   * Max On-Demand Malware Scan Cache Entries
   * @member {module:model/SettingValue} antiMalwareSettingVirtualApplianceOnDemandScanCacheEntriesMax
   */
  exports.prototype['antiMalwareSettingVirtualApplianceOnDemandScanCacheEntriesMax'] = undefined;
  /**
   * Web Reputation
   * @member {module:model/SettingValue} webReputationSettingCombinedModeProtectionSource
   */
  exports.prototype['webReputationSettingCombinedModeProtectionSource'] = undefined;
  /**
   * CLOSING Timeout
   * @member {module:model/SettingValue} firewallSettingEngineOptionClosingTimeout
   */
  exports.prototype['firewallSettingEngineOptionClosingTimeout'] = undefined;
  /**
   * Anti-Malware State
   * @member {module:model/SettingValue} antiMalwareSettingState
   */
  exports.prototype['antiMalwareSettingState'] = undefined;
  /**
   * Invalid TCP Timestamps
   * @member {module:model/SettingValue} firewallSettingAntiEvasionCheckPaws
   */
  exports.prototype['firewallSettingAntiEvasionCheckPaws'] = undefined;
  /**
   * Automatically implement Recommendations
   * @member {module:model/SettingValue} intrusionPreventionSettingAutoApplyRecommendationsEnabled
   */
  exports.prototype['intrusionPreventionSettingAutoApplyRecommendationsEnabled'] = undefined;
  /**
   * Computer OS Fingerprint Probe - Enabled
   * @member {module:model/SettingValue} firewallSettingReconnaissanceDetectFingerprintProbeEnabled
   */
  exports.prototype['firewallSettingReconnaissanceDetectFingerprintProbeEnabled'] = undefined;
  /**
   * Anti-Malware NSX Remove Tag
   * @member {module:model/SettingValue} antiMalwareSettingNsxSecurityTaggingRemoveOnCleanScanEnabled
   */
  exports.prototype['antiMalwareSettingNsxSecurityTaggingRemoveOnCleanScanEnabled'] = undefined;
  /**
   * Maximum data size to store when packet data is captured
   * @member {module:model/SettingValue} firewallSettingEngineOptionLogPacketLengthMax
   */
  exports.prototype['firewallSettingEngineOptionLogPacketLengthMax'] = undefined;
  /**
   * Drop Teredo Anomalies
   * @member {module:model/SettingValue} firewallSettingEngineOptionDropTeredoAnomaliesEnabled
   */
  exports.prototype['firewallSettingEngineOptionDropTeredoAnomaliesEnabled'] = undefined;
  /**
   * Security Level
   * @member {module:model/SettingValue} webReputationSettingSecurityLevel
   */
  exports.prototype['webReputationSettingSecurityLevel'] = undefined;
  /**
   * Drop IPv6 Site Local Addresses
   * @member {module:model/SettingValue} firewallSettingEngineOptionDropIpv6SiteLocalAddressesEnabled
   */
  exports.prototype['firewallSettingEngineOptionDropIpv6SiteLocalAddressesEnabled'] = undefined;
  /**
   * Log Inspection State
   * @member {module:model/SettingValue} logInspectionSettingState
   */
  exports.prototype['logInspectionSettingState'] = undefined;
  /**
   * Sensor Activity Enabled
   * @member {module:model/SettingValue} activityMonitoringSettingActivityEnabled
   */
  exports.prototype['activityMonitoringSettingActivityEnabled'] = undefined;
  /**
   * Strict Teredo Port Check
   * @member {module:model/SettingValue} firewallSettingEngineOptionStrictTerodoPortCheckEnabled
   */
  exports.prototype['firewallSettingEngineOptionStrictTerodoPortCheckEnabled'] = undefined;
  /**
   * Blocked Keywords
   * @member {module:model/SettingValue} webReputationSettingBlockedUrlKeywords
   */
  exports.prototype['webReputationSettingBlockedUrlKeywords'] = undefined;
  /**
   * Web Reputation Syslog Configuration
   * @member {module:model/SettingValue} webReputationSettingSyslogConfigId
   */
  exports.prototype['webReputationSettingSyslogConfigId'] = undefined;
  /**
   * Network Packet Sanity Check Failure
   * @member {module:model/SettingValue} firewallSettingFailureResponsePacketSanityCheck
   */
  exports.prototype['firewallSettingFailureResponsePacketSanityCheck'] = undefined;
  /**
   * Network Engine Mode
   * @member {module:model/SettingValue} firewallSettingNetworkEngineMode
   */
  exports.prototype['firewallSettingNetworkEngineMode'] = undefined;
  /**
   * Maximum size of the event log files (on Agent/Appliance)
   * @member {module:model/SettingValue} firewallSettingEventLogFileSizeMax
   */
  exports.prototype['firewallSettingEventLogFileSizeMax'] = undefined;
  /**
   * Use multithreaded processing for Malware scans (if available)
   * @member {module:model/SettingValue} antiMalwareSettingMalwareScanMultithreadedProcessingEnabled
   */
  exports.prototype['antiMalwareSettingMalwareScanMultithreadedProcessingEnabled'] = undefined;
  /**
   * TCP SYNFIN Scan - Enabled
   * @member {module:model/SettingValue} firewallSettingReconnaissanceDetectTcpSynFinScanEnabled
   */
  exports.prototype['firewallSettingReconnaissanceDetectTcpSynFinScanEnabled'] = undefined;
  /**
   * Drop IP Packet with Zero Payload
   * @member {module:model/SettingValue} firewallSettingEngineOptionDropIpZeroPayloadEnabled
   */
  exports.prototype['firewallSettingEngineOptionDropIpZeroPayloadEnabled'] = undefined;
  /**
   * Advanced - Block IPv6 on Agents and Appliances versions 8 and earlier
   * @member {module:model/SettingValue} firewallSettingEngineOptionBlockIpv6Agent8AndEarlierEnabled
   */
  exports.prototype['firewallSettingEngineOptionBlockIpv6Agent8AndEarlierEnabled'] = undefined;
  /**
   * Send ICMP to indicate fragmented packet timeout exceeded
   * @member {module:model/SettingValue} intrusionPreventionSettingEngineOptionFragmentedIpPacketSendIcmpEnabled
   */
  exports.prototype['intrusionPreventionSettingEngineOptionFragmentedIpPacketSendIcmpEnabled'] = undefined;
  /**
   * Predictive Machine Learning Exclusion List
   * @member {module:model/SettingValue} antiMalwareSettingPredictiveMachineLearningExceptions
   */
  exports.prototype['antiMalwareSettingPredictiveMachineLearningExceptions'] = undefined;
  /**
   * Maximum Events Per Second
   * @member {module:model/SettingValue} firewallSettingEngineOptionLogEventsPerSecondMax
   */
  exports.prototype['firewallSettingEngineOptionLogEventsPerSecondMax'] = undefined;
  /**
   * SSL Session Time
   * @member {module:model/SettingValue} firewallSettingEngineOptionSslSessionTime
   */
  exports.prototype['firewallSettingEngineOptionSslSessionTime'] = undefined;
  /**
   * Scan Exclusions for Suspicious Activity/Unauthorized Change
   * @member {module:model/SettingValue} antiMalwareSettingBehaviorMonitoringScanExclusionList
   */
  exports.prototype['antiMalwareSettingBehaviorMonitoringScanExclusionList'] = undefined;
  /**
   * Use Global Smart Protection Service for Smart Scan
   * @member {module:model/SettingValue} antiMalwareSettingSmartProtectionGlobalServerEnabled
   */
  exports.prototype['antiMalwareSettingSmartProtectionGlobalServerEnabled'] = undefined;
  /**
   * Log only one packet within period
   * @member {module:model/SettingValue} firewallSettingEngineOptionLogOnePacketWithinPeriodEnabled
   */
  exports.prototype['firewallSettingEngineOptionLogOnePacketWithinPeriodEnabled'] = undefined;
  /**
   * Generate Connection Events for ICMP
   * @member {module:model/SettingValue} firewallSettingEngineOptionGenerateConnectionEventsIcmpEnabled
   */
  exports.prototype['firewallSettingEngineOptionGenerateConnectionEventsIcmpEnabled'] = undefined;
  /**
   * Raise Offline Errors For Inactive Virtual Machines
   * @member {module:model/SettingValue} platformSettingHeartbeatInactiveVmOfflineAlertEnabled
   */
  exports.prototype['platformSettingHeartbeatInactiveVmOfflineAlertEnabled'] = undefined;
  /**
   * Use Proxy when accessing Smart Protection Service for Web Reputation
   * @member {module:model/SettingValue} webReputationSettingSmartProtectionWebReputationGlobalServerProxyId
   */
  exports.prototype['webReputationSettingSmartProtectionWebReputationGlobalServerProxyId'] = undefined;
  /**
   * Anti-Malware NSX Security Tagging State
   * @member {module:model/SettingValue} antiMalwareSettingNsxSecurityTaggingEnabled
   */
  exports.prototype['antiMalwareSettingNsxSecurityTaggingEnabled'] = undefined;
  /**
   * Fragmented Packets
   * @member {module:model/SettingValue} firewallSettingAntiEvasionCheckFragmentedPackets
   */
  exports.prototype['firewallSettingAntiEvasionCheckFragmentedPackets'] = undefined;
  /**
   * Maximum ICMP Connections
   * @member {module:model/SettingValue} firewallSettingEngineOptionConnectionsNumIcmpMax
   */
  exports.prototype['firewallSettingEngineOptionConnectionsNumIcmpMax'] = undefined;
  /**
   * TCP Split Handshake
   * @member {module:model/SettingValue} firewallSettingAntiEvasionCheckTcpSplitHandshake
   */
  exports.prototype['firewallSettingAntiEvasionCheckTcpSplitHandshake'] = undefined;
  /**
   * Anti-Malware
   * @member {module:model/SettingValue} antiMalwareSettingCombinedModeProtectionSource
   */
  exports.prototype['antiMalwareSettingCombinedModeProtectionSource'] = undefined;
  /**
   * Number of Event Nodes
   * @member {module:model/SettingValue} firewallSettingEngineOptionEventNodesMax
   */
  exports.prototype['firewallSettingEngineOptionEventNodesMax'] = undefined;
  /**
   * Ports to monitor
   * @member {module:model/SettingValue} webReputationSettingMonitorPortListId
   */
  exports.prototype['webReputationSettingMonitorPortListId'] = undefined;
  /**
   * Configuration
   * @member {module:model/SettingValue} sapSettingState
   */
  exports.prototype['sapSettingState'] = undefined;
  /**
   * Application Control Syslog Configuration
   * @member {module:model/SettingValue} applicationControlSettingSyslogConfigId
   */
  exports.prototype['applicationControlSettingSyslogConfigId'] = undefined;
  /**
   * Outgoing packet out of connection
   * @member {module:model/SettingValue} firewallSettingAntiEvasionCheckOutNoConnection
   */
  exports.prototype['firewallSettingAntiEvasionCheckOutNoConnection'] = undefined;
  /**
   * Advanced - Block IPv6 on Agents and Appliances verions 9 and later
   * @member {module:model/SettingValue} firewallSettingEngineOptionBlockIpv6Agent9AndLaterEnabled
   */
  exports.prototype['firewallSettingEngineOptionBlockIpv6Agent9AndLaterEnabled'] = undefined;
  /**
   * Max Integrity Monitoring Scan Cache Entries
   * @member {module:model/SettingValue} integrityMonitoringSettingVirtualApplianceOptimizationScanCacheEntriesMax
   */
  exports.prototype['integrityMonitoringSettingVirtualApplianceOptimizationScanCacheEntriesMax'] = undefined;
  /**
   * TCP Null Scan - Notify DSM Immediately
   * @member {module:model/SettingValue} firewallSettingReconnaissanceNotifyTcpNullScanEnabled
   */
  exports.prototype['firewallSettingReconnaissanceNotifyTcpNullScanEnabled'] = undefined;
  /**
   * Ignore Status Code
   * @member {module:model/SettingValue} firewallSettingEngineOptionIgnoreStatusCode1
   */
  exports.prototype['firewallSettingEngineOptionIgnoreStatusCode1'] = undefined;
  /**
   * Ignore Status Code
   * @member {module:model/SettingValue} firewallSettingEngineOptionIgnoreStatusCode0
   */
  exports.prototype['firewallSettingEngineOptionIgnoreStatusCode0'] = undefined;
  /**
   * Ignore Status Code
   * @member {module:model/SettingValue} firewallSettingEngineOptionIgnoreStatusCode2
   */
  exports.prototype['firewallSettingEngineOptionIgnoreStatusCode2'] = undefined;
  /**
   * SSL Session Size
   * @member {module:model/SettingValue} firewallSettingEngineOptionSslSessionSize
   */
  exports.prototype['firewallSettingEngineOptionSslSessionSize'] = undefined;
  /**
   * Anti-Malware Real-Time Scan Cache Configuration
   * @member {module:model/SettingValue} antiMalwareSettingScanCacheRealTimeConfigId
   */
  exports.prototype['antiMalwareSettingScanCacheRealTimeConfigId'] = undefined;
  /**
   * Ongoing Scan Interval
   * @member {module:model/SettingValue} platformSettingRecommendationOngoingScansInterval
   */
  exports.prototype['platformSettingRecommendationOngoingScansInterval'] = undefined;
  /**
   * Use Proxy when accessing Global Service for Census
   * @member {module:model/SettingValue} platformSettingSmartProtectionGlobalServerUseProxyEnabled
   */
  exports.prototype['platformSettingSmartProtectionGlobalServerUseProxyEnabled'] = undefined;
  /**
   * Limit to one active interface
   * @member {module:model/SettingValue} firewallSettingInterfaceLimitOneActiveEnabled
   */
  exports.prototype['firewallSettingInterfaceLimitOneActiveEnabled'] = undefined;
  /**
   * TCP Checksum
   * @member {module:model/SettingValue} firewallSettingAntiEvasionCheckTcpChecksum
   */
  exports.prototype['firewallSettingAntiEvasionCheckTcpChecksum'] = undefined;
  /**
   * Drop IPv6 Extension Type 0
   * @member {module:model/SettingValue} firewallSettingEngineOptionDropIpv6ExtType0Enabled
   */
  exports.prototype['firewallSettingEngineOptionDropIpv6ExtType0Enabled'] = undefined;
  /**
   * Maximum file size to scan
   * @member {module:model/SettingValue} antiMalwareSettingScanFileSizeMaxMbytes
   */
  exports.prototype['antiMalwareSettingScanFileSizeMaxMbytes'] = undefined;
  /**
   * Generate Connection Events for TCP
   * @member {module:model/SettingValue} firewallSettingEngineOptionGenerateConnectionEventsTcpEnabled
   */
  exports.prototype['firewallSettingEngineOptionGenerateConnectionEventsTcpEnabled'] = undefined;
  /**
   * Skip hash values calculation if file size is large than (64MB~512MB)
   * @member {module:model/SettingValue} antiMalwareSettingFileHashSizeMaxMbytes
   */
  exports.prototype['antiMalwareSettingFileHashSizeMaxMbytes'] = undefined;
  /**
   * Cache Lifetime
   * @member {module:model/SettingValue} firewallSettingEventLogFileCachedEntriesLifeTime
   */
  exports.prototype['firewallSettingEventLogFileCachedEntriesLifeTime'] = undefined;
  /**
   * Use Proxy when accessing Global Service for Census
   * @member {module:model/SettingValue} platformSettingSmartProtectionGlobalServerProxyId
   */
  exports.prototype['platformSettingSmartProtectionGlobalServerProxyId'] = undefined;
  /**
   * Automatically assign/unassign recommended Log Inspection Rules to Computer during Recommendation Scans
   * @member {module:model/SettingValue} logInspectionSettingAutoApplyRecommendationsEnabled
   */
  exports.prototype['logInspectionSettingAutoApplyRecommendationsEnabled'] = undefined;
  /**
   * Submit files identified as suspicious by Document Exploit Protection scanning to Deep Discovery Analyzer
   * @member {module:model/SettingValue} antiMalwareSettingConnectedThreatDefenseSuspiciousFileDdanSubmissionEnabled
   */
  exports.prototype['antiMalwareSettingConnectedThreatDefenseSuspiciousFileDdanSubmissionEnabled'] = undefined;
  /**
   * Blocked Page Link
   * @member {module:model/SettingValue} webReputationSettingBlockingPageLink
   */
  exports.prototype['webReputationSettingBlockingPageLink'] = undefined;
  /**
   * Firewall and Intrusion Prevention Syslog Configuration
   * @member {module:model/SettingValue} firewallSettingSyslogConfigId
   */
  exports.prototype['firewallSettingSyslogConfigId'] = undefined;
  /**
   * Direction of Deep Security Manager to Agent/Appliance communication
   * @member {module:model/SettingValue} platformSettingAgentCommunicationsDirection
   */
  exports.prototype['platformSettingAgentCommunicationsDirection'] = undefined;
  /**
   * Integrity Scan Cache Configuration:
   * @member {module:model/SettingValue} integrityMonitoringSettingScanCacheConfigId
   */
  exports.prototype['integrityMonitoringSettingScanCacheConfigId'] = undefined;
  /**
   * Allowed Advanced Threat Detection Rules
   * @member {module:model/SettingValue} antiMalwareSettingDocumentExploitProtectionRuleExceptions
   */
  exports.prototype['antiMalwareSettingDocumentExploitProtectionRuleExceptions'] = undefined;
  /**
   * TCP Syn with Data
   * @member {module:model/SettingValue} firewallSettingAntiEvasionCheckTcpSynWithData
   */
  exports.prototype['firewallSettingAntiEvasionCheckTcpSynWithData'] = undefined;
  /**
   * Calculate Hash values of all anti-malware events (at least SHA1 by default)
   * @member {module:model/SettingValue} antiMalwareSettingFileHashEnabled
   */
  exports.prototype['antiMalwareSettingFileHashEnabled'] = undefined;
  /**
   * Computer OS Fingerprint Probe - Block Traffic
   * @member {module:model/SettingValue} firewallSettingReconnaissanceBlockFingerprintProbeDuration
   */
  exports.prototype['firewallSettingReconnaissanceBlockFingerprintProbeDuration'] = undefined;
  /**
   * Drop IPv6 Bogon Addresses
   * @member {module:model/SettingValue} firewallSettingEngineOptionDropIpv6BogonsAddressesEnabled
   */
  exports.prototype['firewallSettingEngineOptionDropIpv6BogonsAddressesEnabled'] = undefined;
  /**
   * Boot Start Timeout
   * @member {module:model/SettingValue} firewallSettingEngineOptionBootStartTimeout
   */
  exports.prototype['firewallSettingEngineOptionBootStartTimeout'] = undefined;
  /**
   * Maximum TCP Connections
   * @member {module:model/SettingValue} firewallSettingEngineOptionConnectionsNumTcpMax
   */
  exports.prototype['firewallSettingEngineOptionConnectionsNumTcpMax'] = undefined;
  /**
   * Anti-Evasion Posture
   * @member {module:model/SettingValue} firewallSettingAntiEvasionSecurityPosture
   */
  exports.prototype['firewallSettingAntiEvasionSecurityPosture'] = undefined;
  /**
   * Interface Patterns
   * @member {module:model/SettingValue} firewallSettingInterfacePatterns
   */
  exports.prototype['firewallSettingInterfacePatterns'] = undefined;
  /**
   * Enable Interface Isolation
   * @member {module:model/SettingValue} firewallSettingInterfaceIsolationEnabled
   */
  exports.prototype['firewallSettingInterfaceIsolationEnabled'] = undefined;
  /**
   * Max Real-Time Malware Scan Cache Entries
   * @member {module:model/SettingValue} antiMalwareSettingVirtualApplianceRealTimeScanCacheEntriesMax
   */
  exports.prototype['antiMalwareSettingVirtualApplianceRealTimeScanCacheEntriesMax'] = undefined;
  /**
   * Generate Firewall Events for packets that are 'Out Of Allowed Policy'
   * @member {module:model/SettingValue} firewallSettingEventsOutOfAllowedPolicyEnabled
   */
  exports.prototype['firewallSettingEventsOutOfAllowedPolicyEnabled'] = undefined;
  /**
   * Evasive Retransmit
   * @member {module:model/SettingValue} firewallSettingAntiEvasionCheckEvasiveRetransmit
   */
  exports.prototype['firewallSettingAntiEvasionCheckEvasiveRetransmit'] = undefined;
  /**
   * ICMP Timeout
   * @member {module:model/SettingValue} firewallSettingEngineOptionIcmpTimeout
   */
  exports.prototype['firewallSettingEngineOptionIcmpTimeout'] = undefined;
  /**
   * Integrity Monitoring Syslog Configuration
   * @member {module:model/SettingValue} integrityMonitoringSettingSyslogConfigId
   */
  exports.prototype['integrityMonitoringSettingSyslogConfigId'] = undefined;
  /**
   * Connection Cleanup Timeout
   * @member {module:model/SettingValue} firewallSettingEngineOptionConnectionCleanupTimeout
   */
  exports.prototype['firewallSettingEngineOptionConnectionCleanupTimeout'] = undefined;
  /**
   * When off domain, connect to global Smart Protection Service. (Windows only)
   * @member {module:model/SettingValue} antiMalwareSettingSmartProtectionLocalServerAllowOffDomainGlobal
   */
  exports.prototype['antiMalwareSettingSmartProtectionLocalServerAllowOffDomainGlobal'] = undefined;
  /**
   * TCP SYNFIN Scan - Notify DSM Immediately
   * @member {module:model/SettingValue} firewallSettingReconnaissanceNotifyTcpSynFinScanEnabled
   */
  exports.prototype['firewallSettingReconnaissanceNotifyTcpSynFinScanEnabled'] = undefined;
  /**
   * ERROR Timeout
   * @member {module:model/SettingValue} firewallSettingEngineOptionErrorTimeout
   */
  exports.prototype['firewallSettingEngineOptionErrorTimeout'] = undefined;
  /**
   * Integrity Monitoring State
   * @member {module:model/SettingValue} integrityMonitoringSettingState
   */
  exports.prototype['integrityMonitoringSettingState'] = undefined;
  /**
   * Allowed Page URLs
   * @member {module:model/SettingValue} webReputationSettingAllowedUrls
   */
  exports.prototype['webReputationSettingAllowedUrls'] = undefined;
  /**
   * Network or Port Scan - Notify DSM Immediately
   * @member {module:model/SettingValue} firewallSettingReconnaissanceNotifyNetworkOrPortScanEnabled
   */
  exports.prototype['firewallSettingReconnaissanceNotifyNetworkOrPortScanEnabled'] = undefined;
  /**
   * FIN_WAIT1 Timeout
   * @member {module:model/SettingValue} firewallSettingEngineOptionFinWait1Timeout
   */
  exports.prototype['firewallSettingEngineOptionFinWait1Timeout'] = undefined;
  /**
   * Generate Connection Events for UDP
   * @member {module:model/SettingValue} firewallSettingEngineOptionGenerateConnectionEventsUdpEnabled
   */
  exports.prototype['firewallSettingEngineOptionGenerateConnectionEventsUdpEnabled'] = undefined;
  /**
   * Activity Monitoring Configuration
   * @member {module:model/SettingValue} activityMonitoringSettingSyslogConfigId
   */
  exports.prototype['activityMonitoringSettingSyslogConfigId'] = undefined;
  /**
   * TCP Syn Rst Flags
   * @member {module:model/SettingValue} firewallSettingAntiEvasionCheckTcpSynRstFlags
   */
  exports.prototype['firewallSettingAntiEvasionCheckTcpSynRstFlags'] = undefined;
  /**
   * Allowed Spyware/Grayware
   * @member {module:model/SettingValue} antiMalwareSettingSpywareApprovedList
   */
  exports.prototype['antiMalwareSettingSpywareApprovedList'] = undefined;
  /**
   * Activity Monitoring State
   * @member {module:model/SettingValue} activityMonitoringSettingState
   */
  exports.prototype['activityMonitoringSettingState'] = undefined;
  /**
   * TCP Urgent Flags
   * @member {module:model/SettingValue} firewallSettingAntiEvasionCheckTcpUrgentFlags
   */
  exports.prototype['firewallSettingAntiEvasionCheckTcpUrgentFlags'] = undefined;
  /**
   * Detect Mode
   * @member {module:model/SettingValue} intrusionPreventionSettingNsxSecurityTaggingDetectModeLevel
   */
  exports.prototype['intrusionPreventionSettingNsxSecurityTaggingDetectModeLevel'] = undefined;
  /**
   * Bypass MAC addresses that don't belong to host
   * @member {module:model/SettingValue} intrusionPreventionSettingEngineOptionFragmentedIpUnconcernedMacAddressBypassEnabled
   */
  exports.prototype['intrusionPreventionSettingEngineOptionFragmentedIpUnconcernedMacAddressBypassEnabled'] = undefined;
  /**
   * Log All Packet Data
   * @member {module:model/SettingValue} firewallSettingEngineOptionLogAllPacketDataEnabled
   */
  exports.prototype['firewallSettingEngineOptionLogAllPacketDataEnabled'] = undefined;
  /**
   * TCP Syn Fin Flags
   * @member {module:model/SettingValue} firewallSettingAntiEvasionCheckTcpSynFinFlags
   */
  exports.prototype['firewallSettingAntiEvasionCheckTcpSynFinFlags'] = undefined;
  /**
   * Heartbeat Interval
   * @member {module:model/SettingValue} platformSettingHeartbeatInterval
   */
  exports.prototype['platformSettingHeartbeatInterval'] = undefined;
  /**
   * Minimum Fragment Size
   * @member {module:model/SettingValue} firewallSettingEngineOptionFragmentSizeMin
   */
  exports.prototype['firewallSettingEngineOptionFragmentSizeMin'] = undefined;
  /**
   * Warn if connection to Smart Protection Server is lost
   * @member {module:model/SettingValue} antiMalwareSettingSmartProtectionServerConnectionLostWarningEnabled
   */
  exports.prototype['antiMalwareSettingSmartProtectionServerConnectionLostWarningEnabled'] = undefined;
  /**
   * Network or Port Scan - Block Traffic
   * @member {module:model/SettingValue} firewallSettingReconnaissanceBlockNetworkOrPortScanDuration
   */
  exports.prototype['firewallSettingReconnaissanceBlockNetworkOrPortScanDuration'] = undefined;
  /**
   * Integrity Monitoring Hash Algorithm
   * @member {module:model/SettingValue} integrityMonitoringSettingContentHashAlgorithm
   */
  exports.prototype['integrityMonitoringSettingContentHashAlgorithm'] = undefined;
  /**
   * Smart Scan State
   * @member {module:model/SettingValue} antiMalwareSettingSmartScanState
   */
  exports.prototype['antiMalwareSettingSmartScanState'] = undefined;
  /**
   * Advanced - Generate an Alert when Agent configuration package exceeds maximum size
   * @member {module:model/SettingValue} firewallSettingConfigPackageExceedsAlertMaxEnabled
   */
  exports.prototype['firewallSettingConfigPackageExceedsAlertMaxEnabled'] = undefined;
  /**
   * Environment Variable Overrides
   * @member {module:model/SettingValue} platformSettingEnvironmentVariableOverrides
   */
  exports.prototype['platformSettingEnvironmentVariableOverrides'] = undefined;
  /**
   * Minimum Fragment Offset
   * @member {module:model/SettingValue} firewallSettingEngineOptionFragmentOffsetMin
   */
  exports.prototype['firewallSettingEngineOptionFragmentOffsetMin'] = undefined;
  /**
   * Local Smart Protection Servers for Smart Scan
   * @member {module:model/SettingValue} antiMalwareSettingSmartProtectionLocalServerUrls
   */
  exports.prototype['antiMalwareSettingSmartProtectionLocalServerUrls'] = undefined;
  /**
   * SYN_RCVD Timeout
   * @member {module:model/SettingValue} firewallSettingEngineOptionSynRcvdTimeout
   */
  exports.prototype['firewallSettingEngineOptionSynRcvdTimeout'] = undefined;
  /**
   * Cache Size
   * @member {module:model/SettingValue} firewallSettingEventLogFileCachedEntriesNum
   */
  exports.prototype['firewallSettingEventLogFileCachedEntriesNum'] = undefined;
  /**
   * Force Allow ICMP type3 code4
   * @member {module:model/SettingValue} firewallSettingEngineOptionForceAllowIcmpType3Code4
   */
  exports.prototype['firewallSettingEngineOptionForceAllowIcmpType3Code4'] = undefined;
  /**
   * TCP Null Scan - Block Traffic
   * @member {module:model/SettingValue} firewallSettingReconnaissanceBlockTcpNullScanDuration
   */
  exports.prototype['firewallSettingReconnaissanceBlockTcpNullScanDuration'] = undefined;
  /**
   * Use Global Service for Census
   * @member {module:model/SettingValue} platformSettingSmartProtectionGlobalServerEnabled
   */
  exports.prototype['platformSettingSmartProtectionGlobalServerEnabled'] = undefined;
  /**
   * Real Time
   * @member {module:model/SettingValue} integrityMonitoringSettingRealtimeEnabled
   */
  exports.prototype['integrityMonitoringSettingRealtimeEnabled'] = undefined;
  /**
   * LAST_ACK Timeout
   * @member {module:model/SettingValue} firewallSettingEngineOptionLastAckTimeout
   */
  exports.prototype['firewallSettingEngineOptionLastAckTimeout'] = undefined;
  /**
   * Reconnaissance Scan Detection - Do not perform detection on traffic coming from
   * @member {module:model/SettingValue} firewallSettingReconnaissanceExcludeIpListId
   */
  exports.prototype['firewallSettingReconnaissanceExcludeIpListId'] = undefined;
  /**
   * Prevent local end-users from uninstalling, stopping, or otherwise modifying the Agent
   * @member {module:model/SettingValue} platformSettingAgentSelfProtectionEnabled
   */
  exports.prototype['platformSettingAgentSelfProtectionEnabled'] = undefined;
  /**
   * Drop IPv6 Reserved Addresses
   * @member {module:model/SettingValue} firewallSettingEngineOptionDropIpv6ReservedAddressesEnabled
   */
  exports.prototype['firewallSettingEngineOptionDropIpv6ReservedAddressesEnabled'] = undefined;
  /**
   * FIN packet out of connection
   * @member {module:model/SettingValue} firewallSettingAntiEvasionCheckFinNoConnection
   */
  exports.prototype['firewallSettingAntiEvasionCheckFinNoConnection'] = undefined;
  /**
   * Number of Packets to retain in Debug Mode
   * @member {module:model/SettingValue} firewallSettingEngineOptionDebugPacketNumMax
   */
  exports.prototype['firewallSettingEngineOptionDebugPacketNumMax'] = undefined;
  /**
   * Intrusion Prevention State
   * @member {module:model/SettingValue} intrusionPreventionSettingState
   */
  exports.prototype['intrusionPreventionSettingState'] = undefined;
  /**
   * Bypass Cisco WAAS Connections
   * @member {module:model/SettingValue} firewallSettingEngineOptionBypassCiscoWaasConnectionsEnabled
   */
  exports.prototype['firewallSettingEngineOptionBypassCiscoWaasConnectionsEnabled'] = undefined;
  /**
   * Reconnaissance Scan Detection - Enabled
   * @member {module:model/SettingValue} firewallSettingReconnaissanceEnabled
   */
  exports.prototype['firewallSettingReconnaissanceEnabled'] = undefined;
  /**
   * Maximum change (in minutes) of the local system time on the computer between heartbeats before an alert is raised
   * @member {module:model/SettingValue} platformSettingHeartbeatLocalTimeShiftAlertThreshold
   */
  exports.prototype['platformSettingHeartbeatLocalTimeShiftAlertThreshold'] = undefined;
  /**
   * MD5
   * @member {module:model/SettingValue} antiMalwareSettingFileHashMd5Enabled
   */
  exports.prototype['antiMalwareSettingFileHashMd5Enabled'] = undefined;
  /**
   * Network or Port Scan - Enabled
   * @member {module:model/SettingValue} firewallSettingReconnaissanceDetectNetworkOrPortScanEnabled
   */
  exports.prototype['firewallSettingReconnaissanceDetectNetworkOrPortScanEnabled'] = undefined;
  /**
   * Silent TCP Connection Drop
   * @member {module:model/SettingValue} firewallSettingEngineOptionSilentTcpConnectionDropEnabled
   */
  exports.prototype['firewallSettingEngineOptionSilentTcpConnectionDropEnabled'] = undefined;
  /**
   * Block Same Src-Dest IP Address
   * @member {module:model/SettingValue} firewallSettingEngineOptionBlockSameSrcDstIpEnabled
   */
  exports.prototype['firewallSettingEngineOptionBlockSameSrcDstIpEnabled'] = undefined;
  /**
   * Force Allow DHCP DNS
   * @member {module:model/SettingValue} firewallSettingEngineOptionForceAllowDhcpDns
   */
  exports.prototype['firewallSettingEngineOptionForceAllowDhcpDns'] = undefined;
  /**
   * Reconnaissance Scan Detection - Computers/Networks on which to perform detection
   * @member {module:model/SettingValue} firewallSettingReconnaissanceIncludeIpListId
   */
  exports.prototype['firewallSettingReconnaissanceIncludeIpListId'] = undefined;
  /**
   * Use custom driver settings
   * @member {module:model/SettingValue} firewallSettingEngineOptionsEnabled
   */
  exports.prototype['firewallSettingEngineOptionsEnabled'] = undefined;
  /**
   * TCP SYNFIN Scan - Block Traffic
   * @member {module:model/SettingValue} firewallSettingReconnaissanceBlockTcpSynFinScanDuration
   */
  exports.prototype['firewallSettingReconnaissanceBlockTcpSynFinScanDuration'] = undefined;
  /**
   * Block Untested Pages
   * @member {module:model/SettingValue} webReputationSettingSecurityBlockUntestedPagesEnabled
   */
  exports.prototype['webReputationSettingSecurityBlockUntestedPagesEnabled'] = undefined;
  /**
   * Allowed Domain URLs
   * @member {module:model/SettingValue} webReputationSettingAllowedUrlDomains
   */
  exports.prototype['webReputationSettingAllowedUrlDomains'] = undefined;
  /**
   * Do not record events with source IP of
   * @member {module:model/SettingValue} firewallSettingEventLogFileIgnoreSourceIpListId
   */
  exports.prototype['firewallSettingEventLogFileIgnoreSourceIpListId'] = undefined;
  /**
   * Drop IPv6 Fragments Lower Than minimum MTU
   * @member {module:model/SettingValue} firewallSettingEngineOptionDropIpv6FragmentsLowerThanMinMtuEnabled
   */
  exports.prototype['firewallSettingEngineOptionDropIpv6FragmentsLowerThanMinMtuEnabled'] = undefined;
  /**
   * Automatically assign new Intrusion Prevention Rules as required by updated  Application Types and Intrusion Prevention Rule dependencies
   * @member {module:model/SettingValue} platformSettingAutoAssignNewIntrusionPreventionRulesEnabled
   */
  exports.prototype['platformSettingAutoAssignNewIntrusionPreventionRulesEnabled'] = undefined;
  /**
   * RST packet out of connection
   * @member {module:model/SettingValue} firewallSettingAntiEvasionCheckRstNoConnection
   */
  exports.prototype['firewallSettingAntiEvasionCheckRstNoConnection'] = undefined;
  /**
   * Blocked Page URLs
   * @member {module:model/SettingValue} webReputationSettingBlockedUrls
   */
  exports.prototype['webReputationSettingBlockedUrls'] = undefined;
  /**
   * Network Combined Mode Affinity
   * @member {module:model/SettingValue} platformSettingCombinedModeNetworkGroupProtectionSource
   */
  exports.prototype['platformSettingCombinedModeNetworkGroupProtectionSource'] = undefined;
  /**
   * Alert
   * @member {module:model/SettingValue} webReputationSettingAlertingEnabled
   */
  exports.prototype['webReputationSettingAlertingEnabled'] = undefined;
  /**
   * Anti-Malware NSX Only Tag on Failure to Remediate
   * @member {module:model/SettingValue} antiMalwareSettingNsxSecurityTaggingOnRemediationFailureEnabled
   */
  exports.prototype['antiMalwareSettingNsxSecurityTaggingOnRemediationFailureEnabled'] = undefined;
  /**
   * Integrity Monitoring CPU Usage Level:
   * @member {module:model/SettingValue} integrityMonitoringSettingCpuUsageLevel
   */
  exports.prototype['integrityMonitoringSettingCpuUsageLevel'] = undefined;
  /**
   * Automatically update anti-malware engine
   * @member {module:model/SettingValue} platformSettingAutoUpdateAntiMalwareEngineEnabled
   */
  exports.prototype['platformSettingAutoUpdateAntiMalwareEngineEnabled'] = undefined;
  /**
   * Intrusion Prevention
   * @member {module:model/SettingValue} intrusionPreventionSettingCombinedModeProtectionSource
   */
  exports.prototype['intrusionPreventionSettingCombinedModeProtectionSource'] = undefined;



  return exports;
}));



