/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/VirtualMachineMetadata', 'model/VirtualMachineSecurityGroup'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./VirtualMachineMetadata'), require('./VirtualMachineSecurityGroup'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.Ec2VirtualMachineSummary = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.VirtualMachineMetadata, root.Deepsecurity.VirtualMachineSecurityGroup);
  }
}(this, function(ApiClient, VirtualMachineMetadata, VirtualMachineSecurityGroup) {
  'use strict';




  /**
   * The Ec2VirtualMachineSummary model module.
   * @module model/Ec2VirtualMachineSummary
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>Ec2VirtualMachineSummary</code>.
   * Details of an AWS EC2 virtual machine.
   * @alias module:model/Ec2VirtualMachineSummary
   * @class
   */
  var exports = function() {
    var _this = this;















  };

  /**
   * Constructs a <code>Ec2VirtualMachineSummary</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Ec2VirtualMachineSummary} obj Optional instance to populate.
   * @return {module:model/Ec2VirtualMachineSummary} The populated <code>Ec2VirtualMachineSummary</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('cloudProvider')) {
        obj['cloudProvider'] = ApiClient.convertToType(data['cloudProvider'], 'String');
      }
      if (data.hasOwnProperty('accountID')) {
        obj['accountID'] = ApiClient.convertToType(data['accountID'], 'String');
      }
      if (data.hasOwnProperty('operatingSystem')) {
        obj['operatingSystem'] = ApiClient.convertToType(data['operatingSystem'], 'String');
      }
      if (data.hasOwnProperty('privateIPAddress')) {
        obj['privateIPAddress'] = ApiClient.convertToType(data['privateIPAddress'], 'String');
      }
      if (data.hasOwnProperty('publicIPAddress')) {
        obj['publicIPAddress'] = ApiClient.convertToType(data['publicIPAddress'], 'String');
      }
      if (data.hasOwnProperty('availabilityZone')) {
        obj['availabilityZone'] = ApiClient.convertToType(data['availabilityZone'], 'String');
      }
      if (data.hasOwnProperty('instanceID')) {
        obj['instanceID'] = ApiClient.convertToType(data['instanceID'], 'String');
      }
      if (data.hasOwnProperty('securityGroups')) {
        obj['securityGroups'] = ApiClient.convertToType(data['securityGroups'], [VirtualMachineSecurityGroup]);
      }
      if (data.hasOwnProperty('type')) {
        obj['type'] = ApiClient.convertToType(data['type'], 'String');
      }
      if (data.hasOwnProperty('virtualizationType')) {
        obj['virtualizationType'] = ApiClient.convertToType(data['virtualizationType'], 'String');
      }
      if (data.hasOwnProperty('state')) {
        obj['state'] = ApiClient.convertToType(data['state'], 'String');
      }
      if (data.hasOwnProperty('metadata')) {
        obj['metadata'] = ApiClient.convertToType(data['metadata'], [VirtualMachineMetadata]);
      }
      if (data.hasOwnProperty('amiID')) {
        obj['amiID'] = ApiClient.convertToType(data['amiID'], 'String');
      }
      if (data.hasOwnProperty('DNSName')) {
        obj['DNSName'] = ApiClient.convertToType(data['DNSName'], 'String');
      }
    }
    return obj;
  }

  /**
   * Cloud provider: \"AWS\".
   * @member {String} cloudProvider
   */
  exports.prototype['cloudProvider'] = undefined;
  /**
   * Account ID. Searchable as String.
   * @member {String} accountID
   */
  exports.prototype['accountID'] = undefined;
  /**
   * Operating system, for example: \"Microsoft Windows (64 bit)\". Searchable as String.
   * @member {String} operatingSystem
   */
  exports.prototype['operatingSystem'] = undefined;
  /**
   * Private IP address. Searchable as String.
   * @member {String} privateIPAddress
   */
  exports.prototype['privateIPAddress'] = undefined;
  /**
   * Public IP address. Searchable as String.
   * @member {String} publicIPAddress
   */
  exports.prototype['publicIPAddress'] = undefined;
  /**
   * Availability Zone, for example: \"us-east-1a\". Searchable as String.
   * @member {String} availabilityZone
   */
  exports.prototype['availabilityZone'] = undefined;
  /**
   * Instance ID, for example: \"i-0e80f75f9532ad1ba\". Searchable as String.
   * @member {String} instanceID
   */
  exports.prototype['instanceID'] = undefined;
  /**
   * List of security groups.
   * @member {Array.<module:model/VirtualMachineSecurityGroup>} securityGroups
   */
  exports.prototype['securityGroups'] = undefined;
  /**
   * Instance type, for example: \"t2.micro\". Searchable as String.
   * @member {String} type
   */
  exports.prototype['type'] = undefined;
  /**
   * Virtualization type, for example: \"hvm\". Searchable as String.
   * @member {String} virtualizationType
   */
  exports.prototype['virtualizationType'] = undefined;
  /**
   * Power state, for example, \"POWER ON\".
   * @member {String} state
   */
  exports.prototype['state'] = undefined;
  /**
   * List of name/value metadata pairs.
   * @member {Array.<module:model/VirtualMachineMetadata>} metadata
   */
  exports.prototype['metadata'] = undefined;
  /**
   * @member {String} amiID
   */
  exports.prototype['amiID'] = undefined;
  /**
   * @member {String} DNSName
   */
  exports.prototype['DNSName'] = undefined;



  return exports;
}));



