/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.EventBasedTaskAction = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The EventBasedTaskAction model module.
   * @module model/EventBasedTaskAction
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>EventBasedTaskAction</code>.
   * Defines an action to perform when an event based task condition is met.
   * @alias module:model/EventBasedTaskAction
   * @class
   */
  var exports = function() {
    var _this = this;



  };

  /**
   * Constructs a <code>EventBasedTaskAction</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/EventBasedTaskAction} obj Optional instance to populate.
   * @return {module:model/EventBasedTaskAction} The populated <code>EventBasedTaskAction</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('type')) {
        obj['type'] = ApiClient.convertToType(data['type'], 'String');
      }
      if (data.hasOwnProperty('parameterValue')) {
        obj['parameterValue'] = ApiClient.convertToType(data['parameterValue'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Type of action taken by the event based task.
   * @member {module:model/EventBasedTaskAction.TypeEnum} type
   */
  exports.prototype['type'] = undefined;
  /**
   * The parameter value for actions that require a parameter.  activate : activation delay in minutes  assign-policy : ID of the policy to assign  assign-relay : ID of the relay group to assign  assign-group : ID of the computer group to assign
   * @member {Number} parameterValue
   */
  exports.prototype['parameterValue'] = undefined;


  /**
   * Allowed values for the <code>type</code> property.
   * @enum {String}
   * @readonly
   */
  exports.TypeEnum = {
    /**
     * value: "activate"
     * @const
     */
    "activate": "activate",
    /**
     * value: "assign-policy"
     * @const
     */
    "assign-policy": "assign-policy",
    /**
     * value: "assign-relay"
     * @const
     */
    "assign-relay": "assign-relay",
    /**
     * value: "assign-group"
     * @const
     */
    "assign-group": "assign-group",
    /**
     * value: "deactivate"
     * @const
     */
    "deactivate": "deactivate"  };


  return exports;
}));



