/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ComputerModuleStatus', 'model/StatefulConfigurationAssignments'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./ComputerModuleStatus'), require('./StatefulConfigurationAssignments'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.FirewallComputerExtension = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.ComputerModuleStatus, root.Deepsecurity.StatefulConfigurationAssignments);
  }
}(this, function(ApiClient, ComputerModuleStatus, StatefulConfigurationAssignments) {
  'use strict';




  /**
   * The FirewallComputerExtension model module.
   * @module model/FirewallComputerExtension
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>FirewallComputerExtension</code>.
   * Computer-level configuration for the Firewall module. Null for tenants for whom Firewall is hidden.
   * @alias module:model/FirewallComputerExtension
   * @class
   */
  var exports = function() {
    var _this = this;






  };

  /**
   * Constructs a <code>FirewallComputerExtension</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/FirewallComputerExtension} obj Optional instance to populate.
   * @return {module:model/FirewallComputerExtension} The populated <code>FirewallComputerExtension</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('state')) {
        obj['state'] = ApiClient.convertToType(data['state'], 'String');
      }
      if (data.hasOwnProperty('moduleStatus')) {
        obj['moduleStatus'] = ComputerModuleStatus.constructFromObject(data['moduleStatus']);
      }
      if (data.hasOwnProperty('globalStatefulConfigurationID')) {
        obj['globalStatefulConfigurationID'] = ApiClient.convertToType(data['globalStatefulConfigurationID'], 'Number');
      }
      if (data.hasOwnProperty('statefulConfigurationAssignments')) {
        obj['statefulConfigurationAssignments'] = StatefulConfigurationAssignments.constructFromObject(data['statefulConfigurationAssignments']);
      }
      if (data.hasOwnProperty('ruleIDs')) {
        obj['ruleIDs'] = ApiClient.convertToType(data['ruleIDs'], ['Number']);
      }
    }
    return obj;
  }

  /**
   * Module state.
   * @member {module:model/FirewallComputerExtension.StateEnum} state
   */
  exports.prototype['state'] = undefined;
  /**
   * @member {module:model/ComputerModuleStatus} moduleStatus
   */
  exports.prototype['moduleStatus'] = undefined;
  /**
   * ID of the Global Stateful Configuration.
   * @member {Number} globalStatefulConfigurationID
   */
  exports.prototype['globalStatefulConfigurationID'] = undefined;
  /**
   * IDs of the interface-specific Stateful Configuration assignments.
   * @member {module:model/StatefulConfigurationAssignments} statefulConfigurationAssignments
   */
  exports.prototype['statefulConfigurationAssignments'] = undefined;
  /**
   * IDs of the assigned firewall rules.
   * @member {Array.<Number>} ruleIDs
   */
  exports.prototype['ruleIDs'] = undefined;


  /**
   * Allowed values for the <code>state</code> property.
   * @enum {String}
   * @readonly
   */
  exports.StateEnum = {
    /**
     * value: "inherited"
     * @const
     */
    "inherited": "inherited",
    /**
     * value: "on"
     * @const
     */
    "on": "on",
    /**
     * value: "off"
     * @const
     */
    "off": "off"  };


  return exports;
}));



