/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/VirtualMachineGCPLabel'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./VirtualMachineGCPLabel'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.GcpVirtualMachineSummary = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.VirtualMachineGCPLabel);
  }
}(this, function(ApiClient, VirtualMachineGCPLabel) {
  'use strict';




  /**
   * The GcpVirtualMachineSummary model module.
   * @module model/GcpVirtualMachineSummary
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>GcpVirtualMachineSummary</code>.
   * Details of a GCP virtual machine.
   * @alias module:model/GcpVirtualMachineSummary
   * @class
   */
  var exports = function() {
    var _this = this;












  };

  /**
   * Constructs a <code>GcpVirtualMachineSummary</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/GcpVirtualMachineSummary} obj Optional instance to populate.
   * @return {module:model/GcpVirtualMachineSummary} The populated <code>GcpVirtualMachineSummary</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('cloudProvider')) {
        obj['cloudProvider'] = ApiClient.convertToType(data['cloudProvider'], 'String');
      }
      if (data.hasOwnProperty('state')) {
        obj['state'] = ApiClient.convertToType(data['state'], 'String');
      }
      if (data.hasOwnProperty('operatingSystem')) {
        obj['operatingSystem'] = ApiClient.convertToType(data['operatingSystem'], 'String');
      }
      if (data.hasOwnProperty('instanceID')) {
        obj['instanceID'] = ApiClient.convertToType(data['instanceID'], 'String');
      }
      if (data.hasOwnProperty('privateIPAddress')) {
        obj['privateIPAddress'] = ApiClient.convertToType(data['privateIPAddress'], 'String');
      }
      if (data.hasOwnProperty('publicIPAddress')) {
        obj['publicIPAddress'] = ApiClient.convertToType(data['publicIPAddress'], 'String');
      }
      if (data.hasOwnProperty('zone')) {
        obj['zone'] = ApiClient.convertToType(data['zone'], 'String');
      }
      if (data.hasOwnProperty('vCPUs')) {
        obj['vCPUs'] = ApiClient.convertToType(data['vCPUs'], 'Number');
      }
      if (data.hasOwnProperty('memory')) {
        obj['memory'] = ApiClient.convertToType(data['memory'], 'Number');
      }
      if (data.hasOwnProperty('labels')) {
        obj['labels'] = ApiClient.convertToType(data['labels'], [VirtualMachineGCPLabel]);
      }
      if (data.hasOwnProperty('networkTags')) {
        obj['networkTags'] = ApiClient.convertToType(data['networkTags'], ['String']);
      }
    }
    return obj;
  }

  /**
   * Cloud provider: \"GCP\".
   * @member {String} cloudProvider
   */
  exports.prototype['cloudProvider'] = undefined;
  /**
   * Power state, for example, \"POWER ON\".
   * @member {String} state
   */
  exports.prototype['state'] = undefined;
  /**
   * Operating system, for example: \"Microsoft Windows (64 bit)\". Searchable as String.
   * @member {String} operatingSystem
   */
  exports.prototype['operatingSystem'] = undefined;
  /**
   * Instance ID, for example: \"1234567890123456789\". Searchable as String.
   * @member {String} instanceID
   */
  exports.prototype['instanceID'] = undefined;
  /**
   * Private IP address. Searchable as String.
   * @member {String} privateIPAddress
   */
  exports.prototype['privateIPAddress'] = undefined;
  /**
   * Public IP address. Searchable as String.
   * @member {String} publicIPAddress
   */
  exports.prototype['publicIPAddress'] = undefined;
  /**
   * Zone is a deployment area, for example: \"us-east1-d\". Searchable as String.
   * @member {String} zone
   */
  exports.prototype['zone'] = undefined;
  /**
   * Number of vCPU. Searchable as Numeric.
   * @member {Number} vCPUs
   */
  exports.prototype['vCPUs'] = undefined;
  /**
   * Memory size in megabyte. Searchable as Numeric.
   * @member {Number} memory
   */
  exports.prototype['memory'] = undefined;
  /**
   * List of key/value labels.
   * @member {Array.<module:model/VirtualMachineGCPLabel>} labels
   */
  exports.prototype['labels'] = undefined;
  /**
   * List of network tags.
   * @member {Array.<String>} networkTags
   */
  exports.prototype['networkTags'] = undefined;



  return exports;
}));



