/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.IdentifiedFileRights = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The IdentifiedFileRights model module.
   * @module model/IdentifiedFileRights
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>IdentifiedFileRights</code>.
   * Identified file right details.
   * @alias module:model/IdentifiedFileRights
   * @class
   */
  var exports = function() {
    var _this = this;





  };

  /**
   * Constructs a <code>IdentifiedFileRights</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/IdentifiedFileRights} obj Optional instance to populate.
   * @return {module:model/IdentifiedFileRights} The populated <code>IdentifiedFileRights</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('canDeleteIdentifiedFiles')) {
        obj['canDeleteIdentifiedFiles'] = ApiClient.convertToType(data['canDeleteIdentifiedFiles'], 'Boolean');
      }
      if (data.hasOwnProperty('canDownloadIdentifiedFiles')) {
        obj['canDownloadIdentifiedFiles'] = ApiClient.convertToType(data['canDownloadIdentifiedFiles'], 'Boolean');
      }
      if (data.hasOwnProperty('canRestoreIdentifiedFiles')) {
        obj['canRestoreIdentifiedFiles'] = ApiClient.convertToType(data['canRestoreIdentifiedFiles'], 'Boolean');
      }
      if (data.hasOwnProperty('canSubmitIdentifiedFiles')) {
        obj['canSubmitIdentifiedFiles'] = ApiClient.convertToType(data['canSubmitIdentifiedFiles'], 'Boolean');
      }
    }
    return obj;
  }

  /**
   * Right to delete identified files.
   * @member {Boolean} canDeleteIdentifiedFiles
   */
  exports.prototype['canDeleteIdentifiedFiles'] = undefined;
  /**
   * Right to download identified files.
   * @member {Boolean} canDownloadIdentifiedFiles
   */
  exports.prototype['canDownloadIdentifiedFiles'] = undefined;
  /**
   * Right to restore identified files.
   * @member {Boolean} canRestoreIdentifiedFiles
   */
  exports.prototype['canRestoreIdentifiedFiles'] = undefined;
  /**
   * Right to submit identified files to Deep Discovery Analyzer.
   * @member {Boolean} canSubmitIdentifiedFiles
   */
  exports.prototype['canSubmitIdentifiedFiles'] = undefined;



  return exports;
}));



