/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.InventoryItem = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The InventoryItem model module.
   * @module model/InventoryItem
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>InventoryItem</code>.
   * Software inventory item details.
   * @alias module:model/InventoryItem
   * @class
   */
  var exports = function() {
    var _this = this;














  };

  /**
   * Constructs a <code>InventoryItem</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/InventoryItem} obj Optional instance to populate.
   * @return {module:model/InventoryItem} The populated <code>InventoryItem</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('vendorName')) {
        obj['vendorName'] = ApiClient.convertToType(data['vendorName'], 'String');
      }
      if (data.hasOwnProperty('productName')) {
        obj['productName'] = ApiClient.convertToType(data['productName'], 'String');
      }
      if (data.hasOwnProperty('productVersion')) {
        obj['productVersion'] = ApiClient.convertToType(data['productVersion'], 'String');
      }
      if (data.hasOwnProperty('fileVersion')) {
        obj['fileVersion'] = ApiClient.convertToType(data['fileVersion'], 'String');
      }
      if (data.hasOwnProperty('fileDescription')) {
        obj['fileDescription'] = ApiClient.convertToType(data['fileDescription'], 'String');
      }
      if (data.hasOwnProperty('category')) {
        obj['category'] = ApiClient.convertToType(data['category'], 'String');
      }
      if (data.hasOwnProperty('sha256')) {
        obj['sha256'] = ApiClient.convertToType(data['sha256'], 'String');
      }
      if (data.hasOwnProperty('sha1')) {
        obj['sha1'] = ApiClient.convertToType(data['sha1'], 'String');
      }
      if (data.hasOwnProperty('md5')) {
        obj['md5'] = ApiClient.convertToType(data['md5'], 'String');
      }
      if (data.hasOwnProperty('fileName')) {
        obj['fileName'] = ApiClient.convertToType(data['fileName'], 'String');
      }
      if (data.hasOwnProperty('path')) {
        obj['path'] = ApiClient.convertToType(data['path'], 'String');
      }
      if (data.hasOwnProperty('size')) {
        obj['size'] = ApiClient.convertToType(data['size'], 'Number');
      }
      if (data.hasOwnProperty('ID')) {
        obj['ID'] = ApiClient.convertToType(data['ID'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Vendor name of the inventory item as reported by the package management system on the computer. Searchable as String.
   * @member {String} vendorName
   */
  exports.prototype['vendorName'] = undefined;
  /**
   * Product name of the inventory item as reported by the package management system on the computer. Searchable as String.
   * @member {String} productName
   */
  exports.prototype['productName'] = undefined;
  /**
   * Product version of the inventory item as reported by the package management system on the computer. Searchable as String.
   * @member {String} productVersion
   */
  exports.prototype['productVersion'] = undefined;
  /**
   * File version of the inventory item as reported by the package management system on the computer. Searchable as String.
   * @member {String} fileVersion
   */
  exports.prototype['fileVersion'] = undefined;
  /**
   * File description of the inventory item as reported by the package management system on the computer. Searchable as String.
   * @member {String} fileDescription
   */
  exports.prototype['fileDescription'] = undefined;
  /**
   * File category of the inventory item as reported by the package management system on the computer. Searchable as String.
   * @member {String} category
   */
  exports.prototype['category'] = undefined;
  /**
   * SHA-256 hash of the inventory item. Searchable as String.
   * @member {String} sha256
   */
  exports.prototype['sha256'] = undefined;
  /**
   * SHA-1 hash of the inventory item. Searchable as String.
   * @member {String} sha1
   */
  exports.prototype['sha1'] = undefined;
  /**
   * MD5 hash of the inventory item. Searchable as String.
   * @member {String} md5
   */
  exports.prototype['md5'] = undefined;
  /**
   * File name of the inventory item. Searchable as String.
   * @member {String} fileName
   */
  exports.prototype['fileName'] = undefined;
  /**
   * File path of the inventory item. Searchable as String.
   * @member {String} path
   */
  exports.prototype['path'] = undefined;
  /**
   * File size of the inventory item in bytes. Searchable as Numeric.
   * @member {Number} size
   */
  exports.prototype['size'] = undefined;
  /**
   * ID of the inventory item. Searchable as ID.
   * @member {Number} ID
   */
  exports.prototype['ID'] = undefined;



  return exports;
}));



