/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.LogInspectionAssignments = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The LogInspectionAssignments model module.
   * @module model/LogInspectionAssignments
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>LogInspectionAssignments</code>.
   * Result of a log inspection recommendation.
   * @alias module:model/LogInspectionAssignments
   * @class
   */
  var exports = function() {
    var _this = this;






  };

  /**
   * Constructs a <code>LogInspectionAssignments</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/LogInspectionAssignments} obj Optional instance to populate.
   * @return {module:model/LogInspectionAssignments} The populated <code>LogInspectionAssignments</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('assignedRuleIDs')) {
        obj['assignedRuleIDs'] = ApiClient.convertToType(data['assignedRuleIDs'], ['Number']);
      }
      if (data.hasOwnProperty('recommendationScanStatus')) {
        obj['recommendationScanStatus'] = ApiClient.convertToType(data['recommendationScanStatus'], 'String');
      }
      if (data.hasOwnProperty('lastRecommendationScanDate')) {
        obj['lastRecommendationScanDate'] = ApiClient.convertToType(data['lastRecommendationScanDate'], 'Number');
      }
      if (data.hasOwnProperty('recommendedToAssignRuleIDs')) {
        obj['recommendedToAssignRuleIDs'] = ApiClient.convertToType(data['recommendedToAssignRuleIDs'], ['Number']);
      }
      if (data.hasOwnProperty('recommendedToUnassignRuleIDs')) {
        obj['recommendedToUnassignRuleIDs'] = ApiClient.convertToType(data['recommendedToUnassignRuleIDs'], ['Number']);
      }
    }
    return obj;
  }

  /**
   * IDs of the log inspection rules currently assigned.
   * @member {Array.<Number>} assignedRuleIDs
   */
  exports.prototype['assignedRuleIDs'] = undefined;
  /**
   * Status of the last recommendation scan.
   * @member {module:model/LogInspectionAssignments.RecommendationScanStatusEnum} recommendationScanStatus
   */
  exports.prototype['recommendationScanStatus'] = undefined;
  /**
   * Timestamp of the last recommendation scan, in milliseconds since epoch.
   * @member {Number} lastRecommendationScanDate
   */
  exports.prototype['lastRecommendationScanDate'] = undefined;
  /**
   * IDs of the log inspection rules recommended for assignment.
   * @member {Array.<Number>} recommendedToAssignRuleIDs
   */
  exports.prototype['recommendedToAssignRuleIDs'] = undefined;
  /**
   * IDs of the log inspection rules recommended for unassignment.
   * @member {Array.<Number>} recommendedToUnassignRuleIDs
   */
  exports.prototype['recommendedToUnassignRuleIDs'] = undefined;


  /**
   * Allowed values for the <code>recommendationScanStatus</code> property.
   * @enum {String}
   * @readonly
   */
  exports.RecommendationScanStatusEnum = {
    /**
     * value: "none"
     * @const
     */
    "none": "none",
    /**
     * value: "valid"
     * @const
     */
    "valid": "valid",
    /**
     * value: "out-of-date"
     * @const
     */
    "out-of-date": "out-of-date",
    /**
     * value: "unknown"
     * @const
     */
    "unknown": "unknown"  };


  return exports;
}));



