/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.MultiTenantRights = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The MultiTenantRights model module.
   * @module model/MultiTenantRights
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>MultiTenantRights</code>.
   * Multi tenant right details.
   * @alias module:model/MultiTenantRights
   * @class
   */
  var exports = function() {
    var _this = this;













  };

  /**
   * Constructs a <code>MultiTenantRights</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/MultiTenantRights} obj Optional instance to populate.
   * @return {module:model/MultiTenantRights} The populated <code>MultiTenantRights</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('canCreateTenants')) {
        obj['canCreateTenants'] = ApiClient.convertToType(data['canCreateTenants'], 'Boolean');
      }
      if (data.hasOwnProperty('canDeleteTenants')) {
        obj['canDeleteTenants'] = ApiClient.convertToType(data['canDeleteTenants'], 'Boolean');
      }
      if (data.hasOwnProperty('canEditTenantGeneralProperties')) {
        obj['canEditTenantGeneralProperties'] = ApiClient.convertToType(data['canEditTenantGeneralProperties'], 'Boolean');
      }
      if (data.hasOwnProperty('canEditTenantModules')) {
        obj['canEditTenantModules'] = ApiClient.convertToType(data['canEditTenantModules'], 'Boolean');
      }
      if (data.hasOwnProperty('canEditTenantAccountDetails')) {
        obj['canEditTenantAccountDetails'] = ApiClient.convertToType(data['canEditTenantAccountDetails'], 'Boolean');
      }
      if (data.hasOwnProperty('canEditTenantFeatures')) {
        obj['canEditTenantFeatures'] = ApiClient.convertToType(data['canEditTenantFeatures'], 'Boolean');
      }
      if (data.hasOwnProperty('canEditTenantSettings')) {
        obj['canEditTenantSettings'] = ApiClient.convertToType(data['canEditTenantSettings'], 'Boolean');
      }
      if (data.hasOwnProperty('canCreateAndEditTenantDatabaseServers')) {
        obj['canCreateAndEditTenantDatabaseServers'] = ApiClient.convertToType(data['canCreateAndEditTenantDatabaseServers'], 'Boolean');
      }
      if (data.hasOwnProperty('canDeleteTenantDatabaseServers')) {
        obj['canDeleteTenantDatabaseServers'] = ApiClient.convertToType(data['canDeleteTenantDatabaseServers'], 'Boolean');
      }
      if (data.hasOwnProperty('canManageTenantAPIKeys')) {
        obj['canManageTenantAPIKeys'] = ApiClient.convertToType(data['canManageTenantAPIKeys'], 'Boolean');
      }
      if (data.hasOwnProperty('canSignInAsTenant')) {
        obj['canSignInAsTenant'] = ApiClient.convertToType(data['canSignInAsTenant'], 'Boolean');
      }
      if (data.hasOwnProperty('canViewTenants')) {
        obj['canViewTenants'] = ApiClient.convertToType(data['canViewTenants'], 'Boolean');
      }
    }
    return obj;
  }

  /**
   * Right to create new tenants.
   * @member {Boolean} canCreateTenants
   */
  exports.prototype['canCreateTenants'] = undefined;
  /**
   * Right to delete tenants.
   * @member {Boolean} canDeleteTenants
   */
  exports.prototype['canDeleteTenants'] = undefined;
  /**
   * Right to edit tenant general properties.
   * @member {Boolean} canEditTenantGeneralProperties
   */
  exports.prototype['canEditTenantGeneralProperties'] = undefined;
  /**
   * Right to edit tenant modules.
   * @member {Boolean} canEditTenantModules
   */
  exports.prototype['canEditTenantModules'] = undefined;
  /**
   * Right to edit tenant account details.
   * @member {Boolean} canEditTenantAccountDetails
   */
  exports.prototype['canEditTenantAccountDetails'] = undefined;
  /**
   * Right to edit tenant features.
   * @member {Boolean} canEditTenantFeatures
   */
  exports.prototype['canEditTenantFeatures'] = undefined;
  /**
   * Right to edit tenant settings.
   * @member {Boolean} canEditTenantSettings
   */
  exports.prototype['canEditTenantSettings'] = undefined;
  /**
   * Right to create and edit tenant database servers.
   * @member {Boolean} canCreateAndEditTenantDatabaseServers
   */
  exports.prototype['canCreateAndEditTenantDatabaseServers'] = undefined;
  /**
   * Right to delete tenant database servers.
   * @member {Boolean} canDeleteTenantDatabaseServers
   */
  exports.prototype['canDeleteTenantDatabaseServers'] = undefined;
  /**
   * Right to manage tenant API keys.
   * @member {Boolean} canManageTenantAPIKeys
   */
  exports.prototype['canManageTenantAPIKeys'] = undefined;
  /**
   * Right to sign in as tenant.
   * @member {Boolean} canSignInAsTenant
   */
  exports.prototype['canSignInAsTenant'] = undefined;
  /**
   * Right to view tenants and multi-tenancy system settings.
   * @member {Boolean} canViewTenants
   */
  exports.prototype['canViewTenants'] = undefined;



  return exports;
}));



