/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ActivityMonitoringPolicyExtension', 'model/AntiMalwarePolicyExtension', 'model/ApplicationControlPolicyExtension', 'model/FirewallPolicyExtension', 'model/IntegrityMonitoringPolicyExtension', 'model/InterfaceTypes', 'model/IntrusionPreventionPolicyExtension', 'model/LogInspectionPolicyExtension', 'model/PolicySettings', 'model/SAPPolicyExtension', 'model/WebReputationPolicyExtension'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./ActivityMonitoringPolicyExtension'), require('./AntiMalwarePolicyExtension'), require('./ApplicationControlPolicyExtension'), require('./FirewallPolicyExtension'), require('./IntegrityMonitoringPolicyExtension'), require('./InterfaceTypes'), require('./IntrusionPreventionPolicyExtension'), require('./LogInspectionPolicyExtension'), require('./PolicySettings'), require('./SAPPolicyExtension'), require('./WebReputationPolicyExtension'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.Policy = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.ActivityMonitoringPolicyExtension, root.Deepsecurity.AntiMalwarePolicyExtension, root.Deepsecurity.ApplicationControlPolicyExtension, root.Deepsecurity.FirewallPolicyExtension, root.Deepsecurity.IntegrityMonitoringPolicyExtension, root.Deepsecurity.InterfaceTypes, root.Deepsecurity.IntrusionPreventionPolicyExtension, root.Deepsecurity.LogInspectionPolicyExtension, root.Deepsecurity.PolicySettings, root.Deepsecurity.SAPPolicyExtension, root.Deepsecurity.WebReputationPolicyExtension);
  }
}(this, function(ApiClient, ActivityMonitoringPolicyExtension, AntiMalwarePolicyExtension, ApplicationControlPolicyExtension, FirewallPolicyExtension, IntegrityMonitoringPolicyExtension, InterfaceTypes, IntrusionPreventionPolicyExtension, LogInspectionPolicyExtension, PolicySettings, SAPPolicyExtension, WebReputationPolicyExtension) {
  'use strict';




  /**
   * The Policy model module.
   * @module model/Policy
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>Policy</code>.
   * Policy details
   * @alias module:model/Policy
   * @class
   */
  var exports = function() {
    var _this = this;


















  };

  /**
   * Constructs a <code>Policy</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Policy} obj Optional instance to populate.
   * @return {module:model/Policy} The populated <code>Policy</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('parentID')) {
        obj['parentID'] = ApiClient.convertToType(data['parentID'], 'Number');
      }
      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('description')) {
        obj['description'] = ApiClient.convertToType(data['description'], 'String');
      }
      if (data.hasOwnProperty('policySettings')) {
        obj['policySettings'] = PolicySettings.constructFromObject(data['policySettings']);
      }
      if (data.hasOwnProperty('recommendationScanMode')) {
        obj['recommendationScanMode'] = ApiClient.convertToType(data['recommendationScanMode'], 'String');
      }
      if (data.hasOwnProperty('autoRequiresUpdate')) {
        obj['autoRequiresUpdate'] = ApiClient.convertToType(data['autoRequiresUpdate'], 'String');
      }
      if (data.hasOwnProperty('interfaceTypes')) {
        obj['interfaceTypes'] = InterfaceTypes.constructFromObject(data['interfaceTypes']);
      }
      if (data.hasOwnProperty('ID')) {
        obj['ID'] = ApiClient.convertToType(data['ID'], 'Number');
      }
      if (data.hasOwnProperty('antiMalware')) {
        obj['antiMalware'] = AntiMalwarePolicyExtension.constructFromObject(data['antiMalware']);
      }
      if (data.hasOwnProperty('webReputation')) {
        obj['webReputation'] = WebReputationPolicyExtension.constructFromObject(data['webReputation']);
      }
      if (data.hasOwnProperty('activityMonitoring')) {
        obj['activityMonitoring'] = ActivityMonitoringPolicyExtension.constructFromObject(data['activityMonitoring']);
      }
      if (data.hasOwnProperty('firewall')) {
        obj['firewall'] = FirewallPolicyExtension.constructFromObject(data['firewall']);
      }
      if (data.hasOwnProperty('intrusionPrevention')) {
        obj['intrusionPrevention'] = IntrusionPreventionPolicyExtension.constructFromObject(data['intrusionPrevention']);
      }
      if (data.hasOwnProperty('integrityMonitoring')) {
        obj['integrityMonitoring'] = IntegrityMonitoringPolicyExtension.constructFromObject(data['integrityMonitoring']);
      }
      if (data.hasOwnProperty('logInspection')) {
        obj['logInspection'] = LogInspectionPolicyExtension.constructFromObject(data['logInspection']);
      }
      if (data.hasOwnProperty('applicationControl')) {
        obj['applicationControl'] = ApplicationControlPolicyExtension.constructFromObject(data['applicationControl']);
      }
      if (data.hasOwnProperty('SAP')) {
        obj['SAP'] = SAPPolicyExtension.constructFromObject(data['SAP']);
      }
    }
    return obj;
  }

  /**
   * ID of the parent policy. Searchable as Numeric.
   * @member {Number} parentID
   */
  exports.prototype['parentID'] = undefined;
  /**
   * Name of the policy. Searchable as String.
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * Description of the policy. Searchable as String.
   * @member {String} description
   */
  exports.prototype['description'] = undefined;
  /**
   * All configurable policy settings.
   * @member {module:model/PolicySettings} policySettings
   */
  exports.prototype['policySettings'] = undefined;
  /**
   * Enable or disable ongoing recommendation scans for computers assigned this policy. Searchable as Choice.
   * @member {module:model/Policy.RecommendationScanModeEnum} recommendationScanMode
   */
  exports.prototype['recommendationScanMode'] = undefined;
  /**
   * Automatically update computers assigned this policy when the configuration changes. Searchable as Choice.
   * @member {module:model/Policy.AutoRequiresUpdateEnum} autoRequiresUpdate
   */
  exports.prototype['autoRequiresUpdate'] = undefined;
  /**
   * When \"Rules can apply to specific interfaces\" is selected, Deep Security will map the network interfaces detected on a computer to the types in this list.
   * @member {module:model/InterfaceTypes} interfaceTypes
   */
  exports.prototype['interfaceTypes'] = undefined;
  /**
   * ID of the policy. Searchable as ID.
   * @member {Number} ID
   */
  exports.prototype['ID'] = undefined;
  /**
   * Configuration for the Anti-Malware module.
   * @member {module:model/AntiMalwarePolicyExtension} antiMalware
   */
  exports.prototype['antiMalware'] = undefined;
  /**
   * Configuration for the Web Reputation module.
   * @member {module:model/WebReputationPolicyExtension} webReputation
   */
  exports.prototype['webReputation'] = undefined;
  /**
   * Configuration for the Activity Monitoring module.
   * @member {module:model/ActivityMonitoringPolicyExtension} activityMonitoring
   */
  exports.prototype['activityMonitoring'] = undefined;
  /**
   * Configuration for the Firewall module.
   * @member {module:model/FirewallPolicyExtension} firewall
   */
  exports.prototype['firewall'] = undefined;
  /**
   * Configuration for the Intrusion Prevention module.
   * @member {module:model/IntrusionPreventionPolicyExtension} intrusionPrevention
   */
  exports.prototype['intrusionPrevention'] = undefined;
  /**
   * Configuration for the Integrity Monitoring module.
   * @member {module:model/IntegrityMonitoringPolicyExtension} integrityMonitoring
   */
  exports.prototype['integrityMonitoring'] = undefined;
  /**
   * Configuration for the Log Inspection module.
   * @member {module:model/LogInspectionPolicyExtension} logInspection
   */
  exports.prototype['logInspection'] = undefined;
  /**
   * Configuration for the Application Control module.
   * @member {module:model/ApplicationControlPolicyExtension} applicationControl
   */
  exports.prototype['applicationControl'] = undefined;
  /**
   * @member {module:model/SAPPolicyExtension} SAP
   */
  exports.prototype['SAP'] = undefined;


  /**
   * Allowed values for the <code>recommendationScanMode</code> property.
   * @enum {String}
   * @readonly
   */
  exports.RecommendationScanModeEnum = {
    /**
     * value: "off"
     * @const
     */
    "off": "off",
    /**
     * value: "ongoing"
     * @const
     */
    "ongoing": "ongoing"  };

  /**
   * Allowed values for the <code>autoRequiresUpdate</code> property.
   * @enum {String}
   * @readonly
   */
  exports.AutoRequiresUpdateEnum = {
    /**
     * value: "off"
     * @const
     */
    "off": "off",
    /**
     * value: "on"
     * @const
     */
    "on": "on"  };


  return exports;
}));



