/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.RegistryScannerSessionInfo = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The RegistryScannerSessionInfo model module.
   * @module model/RegistryScannerSessionInfo
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>RegistryScannerSessionInfo</code>.
   * Details of a session of a registry scanner. Registry scanners, such as Deep Security Smart Check, scan Docker registries.
   * @alias module:model/RegistryScannerSessionInfo
   * @class
   */
  var exports = function() {
    var _this = this;





  };

  /**
   * Constructs a <code>RegistryScannerSessionInfo</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/RegistryScannerSessionInfo} obj Optional instance to populate.
   * @return {module:model/RegistryScannerSessionInfo} The populated <code>RegistryScannerSessionInfo</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('token')) {
        obj['token'] = ApiClient.convertToType(data['token'], 'String');
      }
      if (data.hasOwnProperty('expires')) {
        obj['expires'] = ApiClient.convertToType(data['expires'], 'Number');
      }
      if (data.hasOwnProperty('url')) {
        obj['url'] = ApiClient.convertToType(data['url'], 'String');
      }
      if (data.hasOwnProperty('sessionID')) {
        obj['sessionID'] = ApiClient.convertToType(data['sessionID'], 'String');
      }
    }
    return obj;
  }

  /**
   * Session token of the registry scanner.
   * @member {String} token
   */
  exports.prototype['token'] = undefined;
  /**
   * Timestamp of the expiration date of the session token, in numbers of milliseconds since epoch.
   * @member {Number} expires
   */
  exports.prototype['expires'] = undefined;
  /**
   * URL of the registry scanner.
   * @member {String} url
   */
  exports.prototype['url'] = undefined;
  /**
   * ID of the registry scanner session.
   * @member {String} sessionID
   */
  exports.prototype['sessionID'] = undefined;



  return exports;
}));



