/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AntiMalwareRights', 'model/ApplicationControlRights', 'model/AwsMarketplaceRights', 'model/FirewallRights', 'model/HostedServiceRights', 'model/IntegrityMonitoringRights', 'model/IntrusionPreventionRights', 'model/LogInspectionRights', 'model/PlatformRights', 'model/SensingModeRights', 'model/WebReputationRights'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./AntiMalwareRights'), require('./ApplicationControlRights'), require('./AwsMarketplaceRights'), require('./FirewallRights'), require('./HostedServiceRights'), require('./IntegrityMonitoringRights'), require('./IntrusionPreventionRights'), require('./LogInspectionRights'), require('./PlatformRights'), require('./SensingModeRights'), require('./WebReputationRights'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.Rights = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.AntiMalwareRights, root.Deepsecurity.ApplicationControlRights, root.Deepsecurity.AwsMarketplaceRights, root.Deepsecurity.FirewallRights, root.Deepsecurity.HostedServiceRights, root.Deepsecurity.IntegrityMonitoringRights, root.Deepsecurity.IntrusionPreventionRights, root.Deepsecurity.LogInspectionRights, root.Deepsecurity.PlatformRights, root.Deepsecurity.SensingModeRights, root.Deepsecurity.WebReputationRights);
  }
}(this, function(ApiClient, AntiMalwareRights, ApplicationControlRights, AwsMarketplaceRights, FirewallRights, HostedServiceRights, IntegrityMonitoringRights, IntrusionPreventionRights, LogInspectionRights, PlatformRights, SensingModeRights, WebReputationRights) {
  'use strict';




  /**
   * The Rights model module.
   * @module model/Rights
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>Rights</code>.
   * Administrator rights details.
   * @alias module:model/Rights
   * @class
   */
  var exports = function() {
    var _this = this;












  };

  /**
   * Constructs a <code>Rights</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Rights} obj Optional instance to populate.
   * @return {module:model/Rights} The populated <code>Rights</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('platformRights')) {
        obj['platformRights'] = PlatformRights.constructFromObject(data['platformRights']);
      }
      if (data.hasOwnProperty('antiMalwareRights')) {
        obj['antiMalwareRights'] = AntiMalwareRights.constructFromObject(data['antiMalwareRights']);
      }
      if (data.hasOwnProperty('webReputationRights')) {
        obj['webReputationRights'] = WebReputationRights.constructFromObject(data['webReputationRights']);
      }
      if (data.hasOwnProperty('sensingModeRights')) {
        obj['sensingModeRights'] = SensingModeRights.constructFromObject(data['sensingModeRights']);
      }
      if (data.hasOwnProperty('firewallRights')) {
        obj['firewallRights'] = FirewallRights.constructFromObject(data['firewallRights']);
      }
      if (data.hasOwnProperty('intrusionPreventionRights')) {
        obj['intrusionPreventionRights'] = IntrusionPreventionRights.constructFromObject(data['intrusionPreventionRights']);
      }
      if (data.hasOwnProperty('integrityMonitoringRights')) {
        obj['integrityMonitoringRights'] = IntegrityMonitoringRights.constructFromObject(data['integrityMonitoringRights']);
      }
      if (data.hasOwnProperty('logInspectionRights')) {
        obj['logInspectionRights'] = LogInspectionRights.constructFromObject(data['logInspectionRights']);
      }
      if (data.hasOwnProperty('applicationControlRights')) {
        obj['applicationControlRights'] = ApplicationControlRights.constructFromObject(data['applicationControlRights']);
      }
      if (data.hasOwnProperty('hostedServiceRights')) {
        obj['hostedServiceRights'] = HostedServiceRights.constructFromObject(data['hostedServiceRights']);
      }
      if (data.hasOwnProperty('awsmarketplaceRights')) {
        obj['awsmarketplaceRights'] = AwsMarketplaceRights.constructFromObject(data['awsmarketplaceRights']);
      }
    }
    return obj;
  }

  /**
   * Platform rights.
   * @member {module:model/PlatformRights} platformRights
   */
  exports.prototype['platformRights'] = undefined;
  /**
   * Anti-Malware rights.
   * @member {module:model/AntiMalwareRights} antiMalwareRights
   */
  exports.prototype['antiMalwareRights'] = undefined;
  /**
   * Web Reputation rights.
   * @member {module:model/WebReputationRights} webReputationRights
   */
  exports.prototype['webReputationRights'] = undefined;
  /**
   * Activity Monitoring rights.
   * @member {module:model/SensingModeRights} sensingModeRights
   */
  exports.prototype['sensingModeRights'] = undefined;
  /**
   * Firewall rights.
   * @member {module:model/FirewallRights} firewallRights
   */
  exports.prototype['firewallRights'] = undefined;
  /**
   * Intrusion Prevention rights.
   * @member {module:model/IntrusionPreventionRights} intrusionPreventionRights
   */
  exports.prototype['intrusionPreventionRights'] = undefined;
  /**
   * Integrity Monitoring rights.
   * @member {module:model/IntegrityMonitoringRights} integrityMonitoringRights
   */
  exports.prototype['integrityMonitoringRights'] = undefined;
  /**
   * Log Inspection rights.
   * @member {module:model/LogInspectionRights} logInspectionRights
   */
  exports.prototype['logInspectionRights'] = undefined;
  /**
   * Application Control rights.
   * @member {module:model/ApplicationControlRights} applicationControlRights
   */
  exports.prototype['applicationControlRights'] = undefined;
  /**
   * Hosted Service rights.
   * @member {module:model/HostedServiceRights} hostedServiceRights
   */
  exports.prototype['hostedServiceRights'] = undefined;
  /**
   * @member {module:model/AwsMarketplaceRights} awsmarketplaceRights
   */
  exports.prototype['awsmarketplaceRights'] = undefined;



  return exports;
}));



