/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/CheckForSecurityUpdatesTaskParameters', 'model/DiscoverComputersTaskParameters', 'model/GenerateReportTaskParameters', 'model/RunScriptTaskParameters', 'model/ScanForIntegrityChangesTaskParameters', 'model/ScanForMalwareTaskParameters', 'model/ScanForOpenPortsTaskParameters', 'model/ScanForRecommendationsTaskParameters', 'model/ScheduleDetails', 'model/SendAlertSummaryTaskParameters', 'model/SendPolicyTaskParameters', 'model/SynchronizeCloudAccountTaskParameters', 'model/SynchronizeDirectoryTaskParameters', 'model/SynchronizeVCenterTaskParameters', 'model/UpdateSuspiciousObjectsListTaskParameters'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./CheckForSecurityUpdatesTaskParameters'), require('./DiscoverComputersTaskParameters'), require('./GenerateReportTaskParameters'), require('./RunScriptTaskParameters'), require('./ScanForIntegrityChangesTaskParameters'), require('./ScanForMalwareTaskParameters'), require('./ScanForOpenPortsTaskParameters'), require('./ScanForRecommendationsTaskParameters'), require('./ScheduleDetails'), require('./SendAlertSummaryTaskParameters'), require('./SendPolicyTaskParameters'), require('./SynchronizeCloudAccountTaskParameters'), require('./SynchronizeDirectoryTaskParameters'), require('./SynchronizeVCenterTaskParameters'), require('./UpdateSuspiciousObjectsListTaskParameters'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.ScheduledTask = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.CheckForSecurityUpdatesTaskParameters, root.Deepsecurity.DiscoverComputersTaskParameters, root.Deepsecurity.GenerateReportTaskParameters, root.Deepsecurity.RunScriptTaskParameters, root.Deepsecurity.ScanForIntegrityChangesTaskParameters, root.Deepsecurity.ScanForMalwareTaskParameters, root.Deepsecurity.ScanForOpenPortsTaskParameters, root.Deepsecurity.ScanForRecommendationsTaskParameters, root.Deepsecurity.ScheduleDetails, root.Deepsecurity.SendAlertSummaryTaskParameters, root.Deepsecurity.SendPolicyTaskParameters, root.Deepsecurity.SynchronizeCloudAccountTaskParameters, root.Deepsecurity.SynchronizeDirectoryTaskParameters, root.Deepsecurity.SynchronizeVCenterTaskParameters, root.Deepsecurity.UpdateSuspiciousObjectsListTaskParameters);
  }
}(this, function(ApiClient, CheckForSecurityUpdatesTaskParameters, DiscoverComputersTaskParameters, GenerateReportTaskParameters, RunScriptTaskParameters, ScanForIntegrityChangesTaskParameters, ScanForMalwareTaskParameters, ScanForOpenPortsTaskParameters, ScanForRecommendationsTaskParameters, ScheduleDetails, SendAlertSummaryTaskParameters, SendPolicyTaskParameters, SynchronizeCloudAccountTaskParameters, SynchronizeDirectoryTaskParameters, SynchronizeVCenterTaskParameters, UpdateSuspiciousObjectsListTaskParameters) {
  'use strict';




  /**
   * The ScheduledTask model module.
   * @module model/ScheduledTask
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>ScheduledTask</code>.
   * Defines a scheduled task. Scheduled tasks automatically perform specific Deep Security Manager tasks on a schedule.
   * @alias module:model/ScheduledTask
   * @class
   */
  var exports = function() {
    var _this = this;























  };

  /**
   * Constructs a <code>ScheduledTask</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ScheduledTask} obj Optional instance to populate.
   * @return {module:model/ScheduledTask} The populated <code>ScheduledTask</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('type')) {
        obj['type'] = ApiClient.convertToType(data['type'], 'String');
      }
      if (data.hasOwnProperty('scheduleDetails')) {
        obj['scheduleDetails'] = ScheduleDetails.constructFromObject(data['scheduleDetails']);
      }
      if (data.hasOwnProperty('enabled')) {
        obj['enabled'] = ApiClient.convertToType(data['enabled'], 'Boolean');
      }
      if (data.hasOwnProperty('lastRunTime')) {
        obj['lastRunTime'] = ApiClient.convertToType(data['lastRunTime'], 'Number');
      }
      if (data.hasOwnProperty('nextRunTime')) {
        obj['nextRunTime'] = ApiClient.convertToType(data['nextRunTime'], 'Number');
      }
      if (data.hasOwnProperty('runNow')) {
        obj['runNow'] = ApiClient.convertToType(data['runNow'], 'Boolean');
      }
      if (data.hasOwnProperty('scanForOpenPortsTaskParameters')) {
        obj['scanForOpenPortsTaskParameters'] = ScanForOpenPortsTaskParameters.constructFromObject(data['scanForOpenPortsTaskParameters']);
      }
      if (data.hasOwnProperty('sendAlertSummaryTaskParameters')) {
        obj['sendAlertSummaryTaskParameters'] = SendAlertSummaryTaskParameters.constructFromObject(data['sendAlertSummaryTaskParameters']);
      }
      if (data.hasOwnProperty('discoverComputersTaskParameters')) {
        obj['discoverComputersTaskParameters'] = DiscoverComputersTaskParameters.constructFromObject(data['discoverComputersTaskParameters']);
      }
      if (data.hasOwnProperty('runScriptTaskParameters')) {
        obj['runScriptTaskParameters'] = RunScriptTaskParameters.constructFromObject(data['runScriptTaskParameters']);
      }
      if (data.hasOwnProperty('sendPolicyTaskParameters')) {
        obj['sendPolicyTaskParameters'] = SendPolicyTaskParameters.constructFromObject(data['sendPolicyTaskParameters']);
      }
      if (data.hasOwnProperty('generateReportTaskParameters')) {
        obj['generateReportTaskParameters'] = GenerateReportTaskParameters.constructFromObject(data['generateReportTaskParameters']);
      }
      if (data.hasOwnProperty('synchronizeDirectoryTaskParameters')) {
        obj['synchronizeDirectoryTaskParameters'] = SynchronizeDirectoryTaskParameters.constructFromObject(data['synchronizeDirectoryTaskParameters']);
      }
      if (data.hasOwnProperty('scanForRecommendationsTaskParameters')) {
        obj['scanForRecommendationsTaskParameters'] = ScanForRecommendationsTaskParameters.constructFromObject(data['scanForRecommendationsTaskParameters']);
      }
      if (data.hasOwnProperty('synchronizeVCenterTaskParameters')) {
        obj['synchronizeVCenterTaskParameters'] = SynchronizeVCenterTaskParameters.constructFromObject(data['synchronizeVCenterTaskParameters']);
      }
      if (data.hasOwnProperty('scanForIntegrityChangesTaskParameters')) {
        obj['scanForIntegrityChangesTaskParameters'] = ScanForIntegrityChangesTaskParameters.constructFromObject(data['scanForIntegrityChangesTaskParameters']);
      }
      if (data.hasOwnProperty('scanForMalwareTaskParameters')) {
        obj['scanForMalwareTaskParameters'] = ScanForMalwareTaskParameters.constructFromObject(data['scanForMalwareTaskParameters']);
      }
      if (data.hasOwnProperty('checkForSecurityUpdatesTaskParameters')) {
        obj['checkForSecurityUpdatesTaskParameters'] = CheckForSecurityUpdatesTaskParameters.constructFromObject(data['checkForSecurityUpdatesTaskParameters']);
      }
      if (data.hasOwnProperty('synchronizeCloudAccountTaskParameters')) {
        obj['synchronizeCloudAccountTaskParameters'] = SynchronizeCloudAccountTaskParameters.constructFromObject(data['synchronizeCloudAccountTaskParameters']);
      }
      if (data.hasOwnProperty('updateSuspiciousObjectsListTaskParameters')) {
        obj['updateSuspiciousObjectsListTaskParameters'] = UpdateSuspiciousObjectsListTaskParameters.constructFromObject(data['updateSuspiciousObjectsListTaskParameters']);
      }
      if (data.hasOwnProperty('ID')) {
        obj['ID'] = ApiClient.convertToType(data['ID'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Name of scheduled task. Searchable as String.
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * Type of scheduled task. Searchable as Choice.
   * @member {module:model/ScheduledTask.TypeEnum} type
   */
  exports.prototype['type'] = undefined;
  /**
   * @member {module:model/ScheduleDetails} scheduleDetails
   */
  exports.prototype['scheduleDetails'] = undefined;
  /**
   * Indicates whether or not the scheduled task is enabled. Searchable as Boolean.
   * @member {Boolean} enabled
   */
  exports.prototype['enabled'] = undefined;
  /**
   * The last time this scheduled task was run, or null if never run. Searchable as Date.
   * @member {Number} lastRunTime
   */
  exports.prototype['lastRunTime'] = undefined;
  /**
   * The next time this scheduled task is scheduled to run, or null if it not scheduled to run in the future. Searchable as Date.
   * @member {Number} nextRunTime
   */
  exports.prototype['nextRunTime'] = undefined;
  /**
   * Indicates that the scheduled task should execute immediately.
   * @member {Boolean} runNow
   */
  exports.prototype['runNow'] = undefined;
  /**
   * @member {module:model/ScanForOpenPortsTaskParameters} scanForOpenPortsTaskParameters
   */
  exports.prototype['scanForOpenPortsTaskParameters'] = undefined;
  /**
   * @member {module:model/SendAlertSummaryTaskParameters} sendAlertSummaryTaskParameters
   */
  exports.prototype['sendAlertSummaryTaskParameters'] = undefined;
  /**
   * @member {module:model/DiscoverComputersTaskParameters} discoverComputersTaskParameters
   */
  exports.prototype['discoverComputersTaskParameters'] = undefined;
  /**
   * @member {module:model/RunScriptTaskParameters} runScriptTaskParameters
   */
  exports.prototype['runScriptTaskParameters'] = undefined;
  /**
   * @member {module:model/SendPolicyTaskParameters} sendPolicyTaskParameters
   */
  exports.prototype['sendPolicyTaskParameters'] = undefined;
  /**
   * @member {module:model/GenerateReportTaskParameters} generateReportTaskParameters
   */
  exports.prototype['generateReportTaskParameters'] = undefined;
  /**
   * @member {module:model/SynchronizeDirectoryTaskParameters} synchronizeDirectoryTaskParameters
   */
  exports.prototype['synchronizeDirectoryTaskParameters'] = undefined;
  /**
   * @member {module:model/ScanForRecommendationsTaskParameters} scanForRecommendationsTaskParameters
   */
  exports.prototype['scanForRecommendationsTaskParameters'] = undefined;
  /**
   * @member {module:model/SynchronizeVCenterTaskParameters} synchronizeVCenterTaskParameters
   */
  exports.prototype['synchronizeVCenterTaskParameters'] = undefined;
  /**
   * @member {module:model/ScanForIntegrityChangesTaskParameters} scanForIntegrityChangesTaskParameters
   */
  exports.prototype['scanForIntegrityChangesTaskParameters'] = undefined;
  /**
   * @member {module:model/ScanForMalwareTaskParameters} scanForMalwareTaskParameters
   */
  exports.prototype['scanForMalwareTaskParameters'] = undefined;
  /**
   * @member {module:model/CheckForSecurityUpdatesTaskParameters} checkForSecurityUpdatesTaskParameters
   */
  exports.prototype['checkForSecurityUpdatesTaskParameters'] = undefined;
  /**
   * @member {module:model/SynchronizeCloudAccountTaskParameters} synchronizeCloudAccountTaskParameters
   */
  exports.prototype['synchronizeCloudAccountTaskParameters'] = undefined;
  /**
   * @member {module:model/UpdateSuspiciousObjectsListTaskParameters} updateSuspiciousObjectsListTaskParameters
   */
  exports.prototype['updateSuspiciousObjectsListTaskParameters'] = undefined;
  /**
   * Scheduled task identifier. Searchable as ID.
   * @member {Number} ID
   */
  exports.prototype['ID'] = undefined;


  /**
   * Allowed values for the <code>type</code> property.
   * @enum {String}
   * @readonly
   */
  exports.TypeEnum = {
    /**
     * value: "scan-for-open-ports"
     * @const
     */
    "scan-for-open-ports": "scan-for-open-ports",
    /**
     * value: "send-alert-summary"
     * @const
     */
    "send-alert-summary": "send-alert-summary",
    /**
     * value: "discover-computers"
     * @const
     */
    "discover-computers": "discover-computers",
    /**
     * value: "run-script"
     * @const
     */
    "run-script": "run-script",
    /**
     * value: "send-policy"
     * @const
     */
    "send-policy": "send-policy",
    /**
     * value: "generate-report"
     * @const
     */
    "generate-report": "generate-report",
    /**
     * value: "synchronize-directory"
     * @const
     */
    "synchronize-directory": "synchronize-directory",
    /**
     * value: "synchronize-users"
     * @const
     */
    "synchronize-users": "synchronize-users",
    /**
     * value: "scan-for-recommendations"
     * @const
     */
    "scan-for-recommendations": "scan-for-recommendations",
    /**
     * value: "synchronize-vcenter"
     * @const
     */
    "synchronize-vcenter": "synchronize-vcenter",
    /**
     * value: "scan-for-integrity-changes"
     * @const
     */
    "scan-for-integrity-changes": "scan-for-integrity-changes",
    /**
     * value: "scan-for-malware"
     * @const
     */
    "scan-for-malware": "scan-for-malware",
    /**
     * value: "check-for-security-updates"
     * @const
     */
    "check-for-security-updates": "check-for-security-updates",
    /**
     * value: "synchronize-cloud-account"
     * @const
     */
    "synchronize-cloud-account": "synchronize-cloud-account",
    /**
     * value: "check-for-software-updates"
     * @const
     */
    "check-for-software-updates": "check-for-software-updates",
    /**
     * value: "update-suspicious-objects-list"
     * @const
     */
    "update-suspicious-objects-list": "update-suspicious-objects-list"  };


  return exports;
}));



