/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/SearchCriteria'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./SearchCriteria'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.SearchFilter = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.SearchCriteria);
  }
}(this, function(ApiClient, SearchCriteria) {
  'use strict';




  /**
   * The SearchFilter model module.
   * @module model/SearchFilter
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>SearchFilter</code>.
   * Allows clients to obtain a filtered list of objects based on various search criteria.
   * @alias module:model/SearchFilter
   * @class
   */
  var exports = function() {
    var _this = this;




  };

  /**
   * Constructs a <code>SearchFilter</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/SearchFilter} obj Optional instance to populate.
   * @return {module:model/SearchFilter} The populated <code>SearchFilter</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('maxItems')) {
        obj['maxItems'] = ApiClient.convertToType(data['maxItems'], 'Number');
      }
      if (data.hasOwnProperty('searchCriteria')) {
        obj['searchCriteria'] = ApiClient.convertToType(data['searchCriteria'], [SearchCriteria]);
      }
      if (data.hasOwnProperty('sortByObjectID')) {
        obj['sortByObjectID'] = ApiClient.convertToType(data['sortByObjectID'], 'Boolean');
      }
    }
    return obj;
  }

  /**
   * Limits the number of objects returned. Default 5000.
   * @member {Number} maxItems
   */
  exports.prototype['maxItems'] = undefined;
  /**
   * Array of search critiera used to filter objects. Searching with multiple criteria returns results that satisfy all of the criteria. Searching with no criteria returns all objects.
   * @member {Array.<module:model/SearchCriteria>} searchCriteria
   */
  exports.prototype['searchCriteria'] = undefined;
  /**
   * If true, forces the response objects to be sorted by ID, overriding the default sort order. Default \"false\".
   * @member {Boolean} sortByObjectID
   */
  exports.prototype['sortByObjectID'] = undefined;



  return exports;
}));



