/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.SnsConfiguration = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The SnsConfiguration model module.
   * @module model/SnsConfiguration
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>SnsConfiguration</code>.
   * Details of SNS configuration. The configuration is used by the SNS forwarder to send events to a customer/tenant designated SNS topic.
   * @alias module:model/SnsConfiguration
   * @class
   */
  var exports = function() {
    var _this = this;








  };

  /**
   * Constructs a <code>SnsConfiguration</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/SnsConfiguration} obj Optional instance to populate.
   * @return {module:model/SnsConfiguration} The populated <code>SnsConfiguration</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('accessKey')) {
        obj['accessKey'] = ApiClient.convertToType(data['accessKey'], 'String');
      }
      if (data.hasOwnProperty('secretKey')) {
        obj['secretKey'] = ApiClient.convertToType(data['secretKey'], 'String');
      }
      if (data.hasOwnProperty('topicARN')) {
        obj['topicARN'] = ApiClient.convertToType(data['topicARN'], 'String');
      }
      if (data.hasOwnProperty('advancedConfiguration')) {
        obj['advancedConfiguration'] = ApiClient.convertToType(data['advancedConfiguration'], 'String');
      }
      if (data.hasOwnProperty('forwardingEnabled')) {
        obj['forwardingEnabled'] = ApiClient.convertToType(data['forwardingEnabled'], 'Boolean');
      }
      if (data.hasOwnProperty('forwarderSnsStartSendDate')) {
        obj['forwarderSnsStartSendDate'] = ApiClient.convertToType(data['forwarderSnsStartSendDate'], 'Date');
      }
      if (data.hasOwnProperty('forwarderSnsEndSendDate')) {
        obj['forwarderSnsEndSendDate'] = ApiClient.convertToType(data['forwarderSnsEndSendDate'], 'Date');
      }
    }
    return obj;
  }

  /**
   * AWS access key that has permissions to write to the SNS topic.
   * @member {String} accessKey
   */
  exports.prototype['accessKey'] = undefined;
  /**
   * AWS secret key.
   * @member {String} secretKey
   */
  exports.prototype['secretKey'] = undefined;
  /**
   * SNS topic to forward to. This should be provided by the customer/tenant.
   * @member {String} topicARN
   */
  exports.prototype['topicARN'] = undefined;
  /**
   * JSON Configuration specifying customized forwarding rules.
   * @member {String} advancedConfiguration
   */
  exports.prototype['advancedConfiguration'] = undefined;
  /**
   * Is SNS forwarding enabled for this tenant.
   * @member {Boolean} forwardingEnabled
   */
  exports.prototype['forwardingEnabled'] = undefined;
  /**
   * Feature flag to tell the SNS forwarder service when (event date) it should start event forwarding for the tenant
   * @member {Date} forwarderSnsStartSendDate
   */
  exports.prototype['forwarderSnsStartSendDate'] = undefined;
  /**
   * Feature flag to tell the SNS forwarder service when (event date) it should stop event forwarding for the tenant
   * @member {Date} forwarderSnsEndSendDate
   */
  exports.prototype['forwarderSnsEndSendDate'] = undefined;



  return exports;
}));



