/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.Snsstatus = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The Snsstatus model module.
   * @module model/Snsstatus
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>Snsstatus</code>.
   * Status of a SNS forward attempt. SNS forward attempt is updated by the SNS forwarder in order to return feedback to the user.
   * @alias module:model/Snsstatus
   * @class
   */
  var exports = function() {
    var _this = this;






  };

  /**
   * Constructs a <code>Snsstatus</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Snsstatus} obj Optional instance to populate.
   * @return {module:model/Snsstatus} The populated <code>Snsstatus</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('lastAttemptTime')) {
        obj['lastAttemptTime'] = ApiClient.convertToType(data['lastAttemptTime'], 'Number');
      }
      if (data.hasOwnProperty('message')) {
        obj['message'] = ApiClient.convertToType(data['message'], 'String');
      }
      if (data.hasOwnProperty('status')) {
        obj['status'] = ApiClient.convertToType(data['status'], 'String');
      }
      if (data.hasOwnProperty('failureReason')) {
        obj['failureReason'] = ApiClient.convertToType(data['failureReason'], 'String');
      }
      if (data.hasOwnProperty('topicArn')) {
        obj['topicArn'] = ApiClient.convertToType(data['topicArn'], 'String');
      }
    }
    return obj;
  }

  /**
   * Last time whem an attemp to forward to the tenant designated SNS topic was made.
   * @member {Number} lastAttemptTime
   */
  exports.prototype['lastAttemptTime'] = undefined;
  /**
   * Failed event message to reflect in the DSM alert.
   * @member {String} message
   */
  exports.prototype['message'] = undefined;
  /**
   * Result of last attemp to forward to the tenant designated SNS topic.
   * @member {module:model/Snsstatus.StatusEnum} status
   */
  exports.prototype['status'] = undefined;
  /**
   * Reported reason for forwarding failure.
   * @member {String} failureReason
   */
  exports.prototype['failureReason'] = undefined;
  /**
   * ARN of SNS topic that the event was intended to.
   * @member {String} topicArn
   */
  exports.prototype['topicArn'] = undefined;


  /**
   * Allowed values for the <code>status</code> property.
   * @enum {String}
   * @readonly
   */
  exports.StatusEnum = {
    /**
     * value: "failure"
     * @const
     */
    "failure": "failure",
    /**
     * value: "success"
     * @const
     */
    "success": "success"  };


  return exports;
}));



