/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.TagFilter = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The TagFilter model module.
   * @module model/TagFilter
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>TagFilter</code>.
   * Details for a tag filter. For reports that contain event data, identifies the tags of the events to include in the report.
   * @alias module:model/TagFilter
   * @class
   */
  var exports = function() {
    var _this = this;



  };

  /**
   * Constructs a <code>TagFilter</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/TagFilter} obj Optional instance to populate.
   * @return {module:model/TagFilter} The populated <code>TagFilter</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('type')) {
        obj['type'] = ApiClient.convertToType(data['type'], 'String');
      }
      if (data.hasOwnProperty('tags')) {
        obj['tags'] = ApiClient.convertToType(data['tags'], ['String']);
      }
    }
    return obj;
  }

  /**
   * Type of tag filter.
   * @member {module:model/TagFilter.TypeEnum} type
   */
  exports.prototype['type'] = undefined;
  /**
   * Tags to be used when type is: specific-tags
   * @member {Array.<String>} tags
   */
  exports.prototype['tags'] = undefined;


  /**
   * Allowed values for the <code>type</code> property.
   * @enum {String}
   * @readonly
   */
  exports.TypeEnum = {
    /**
     * value: "all"
     * @const
     */
    "all": "all",
    /**
     * value: "untagged"
     * @const
     */
    "untagged": "untagged",
    /**
     * value: "specific-tags"
     * @const
     */
    "specific-tags": "specific-tags"  };


  return exports;
}));



