/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.VcloudVMVirtualMachineSummary = factory(root.Deepsecurity.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The VcloudVMVirtualMachineSummary model module.
   * @module model/VcloudVMVirtualMachineSummary
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>VcloudVMVirtualMachineSummary</code>.
   * Details of a vCloud virtual machine.
   * @alias module:model/VcloudVMVirtualMachineSummary
   * @class
   */
  var exports = function() {
    var _this = this;








  };

  /**
   * Constructs a <code>VcloudVMVirtualMachineSummary</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/VcloudVMVirtualMachineSummary} obj Optional instance to populate.
   * @return {module:model/VcloudVMVirtualMachineSummary} The populated <code>VcloudVMVirtualMachineSummary</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('cloudProvider')) {
        obj['cloudProvider'] = ApiClient.convertToType(data['cloudProvider'], 'String');
      }
      if (data.hasOwnProperty('operatingSystem')) {
        obj['operatingSystem'] = ApiClient.convertToType(data['operatingSystem'], 'String');
      }
      if (data.hasOwnProperty('instanceID')) {
        obj['instanceID'] = ApiClient.convertToType(data['instanceID'], 'String');
      }
      if (data.hasOwnProperty('type')) {
        obj['type'] = ApiClient.convertToType(data['type'], 'String');
      }
      if (data.hasOwnProperty('state')) {
        obj['state'] = ApiClient.convertToType(data['state'], 'String');
      }
      if (data.hasOwnProperty('IPAddress')) {
        obj['IPAddress'] = ApiClient.convertToType(data['IPAddress'], 'String');
      }
      if (data.hasOwnProperty('DNSName')) {
        obj['DNSName'] = ApiClient.convertToType(data['DNSName'], 'String');
      }
    }
    return obj;
  }

  /**
   * Cloud provider: \"vCloud\".
   * @member {String} cloudProvider
   */
  exports.prototype['cloudProvider'] = undefined;
  /**
   * Operating system, for example: \"Microsoft Windows Server 2012 (64-bit)\". Searchable as String.
   * @member {String} operatingSystem
   */
  exports.prototype['operatingSystem'] = undefined;
  /**
   * Instance ID. Searchable as String.
   * @member {String} instanceID
   */
  exports.prototype['instanceID'] = undefined;
  /**
   * Hardware type. Searchable as String.
   * @member {String} type
   */
  exports.prototype['type'] = undefined;
  /**
   * Power state, for example: \"Powered On\".
   * @member {String} state
   */
  exports.prototype['state'] = undefined;
  /**
   * @member {String} IPAddress
   */
  exports.prototype['IPAddress'] = undefined;
  /**
   * @member {String} DNSName
   */
  exports.prototype['DNSName'] = undefined;



  return exports;
}));



