/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/VirtualMachineMetadata'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./VirtualMachineMetadata'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.WorkspaceVirtualMachineSummary = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.VirtualMachineMetadata);
  }
}(this, function(ApiClient, VirtualMachineMetadata) {
  'use strict';




  /**
   * The WorkspaceVirtualMachineSummary model module.
   * @module model/WorkspaceVirtualMachineSummary
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>WorkspaceVirtualMachineSummary</code>.
   * Details of an AWS Workspace.
   * @alias module:model/WorkspaceVirtualMachineSummary
   * @class
   */
  var exports = function() {
    var _this = this;











  };

  /**
   * Constructs a <code>WorkspaceVirtualMachineSummary</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/WorkspaceVirtualMachineSummary} obj Optional instance to populate.
   * @return {module:model/WorkspaceVirtualMachineSummary} The populated <code>WorkspaceVirtualMachineSummary</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('cloudProvider')) {
        obj['cloudProvider'] = ApiClient.convertToType(data['cloudProvider'], 'String');
      }
      if (data.hasOwnProperty('accountID')) {
        obj['accountID'] = ApiClient.convertToType(data['accountID'], 'String');
      }
      if (data.hasOwnProperty('workspaceDirectory')) {
        obj['workspaceDirectory'] = ApiClient.convertToType(data['workspaceDirectory'], 'String');
      }
      if (data.hasOwnProperty('userName')) {
        obj['userName'] = ApiClient.convertToType(data['userName'], 'String');
      }
      if (data.hasOwnProperty('workspaceID')) {
        obj['workspaceID'] = ApiClient.convertToType(data['workspaceID'], 'String');
      }
      if (data.hasOwnProperty('bundleID')) {
        obj['bundleID'] = ApiClient.convertToType(data['bundleID'], 'String');
      }
      if (data.hasOwnProperty('workspaceHardware')) {
        obj['workspaceHardware'] = ApiClient.convertToType(data['workspaceHardware'], 'String');
      }
      if (data.hasOwnProperty('state')) {
        obj['state'] = ApiClient.convertToType(data['state'], 'String');
      }
      if (data.hasOwnProperty('metadata')) {
        obj['metadata'] = ApiClient.convertToType(data['metadata'], [VirtualMachineMetadata]);
      }
      if (data.hasOwnProperty('IPAddress')) {
        obj['IPAddress'] = ApiClient.convertToType(data['IPAddress'], 'String');
      }
    }
    return obj;
  }

  /**
   * Cloud provider: \"AWS\".
   * @member {String} cloudProvider
   */
  exports.prototype['cloudProvider'] = undefined;
  /**
   * Account ID. Searchable as String.
   * @member {String} accountID
   */
  exports.prototype['accountID'] = undefined;
  /**
   * Name of workspace directory.
   * @member {String} workspaceDirectory
   */
  exports.prototype['workspaceDirectory'] = undefined;
  /**
   * Name of workspace owner. Searchable as String.
   * @member {String} userName
   */
  exports.prototype['userName'] = undefined;
  /**
   * Workspace ID, for example: \"ws-hlt453cld\". Searchable as String.
   * @member {String} workspaceID
   */
  exports.prototype['workspaceID'] = undefined;
  /**
   * Bundle ID, for example: \"wsb-92b9h49ds\". Searchable as String.
   * @member {String} bundleID
   */
  exports.prototype['bundleID'] = undefined;
  /**
   * Hardware description, for example: \"STANDARD\". Searchable as String.
   * @member {String} workspaceHardware
   */
  exports.prototype['workspaceHardware'] = undefined;
  /**
   * Power state, for example, \"POWER ON\".
   * @member {String} state
   */
  exports.prototype['state'] = undefined;
  /**
   * List of name/value metadata pairs.
   * @member {Array.<module:model/VirtualMachineMetadata>} metadata
   */
  exports.prototype['metadata'] = undefined;
  /**
   * @member {String} IPAddress
   */
  exports.prototype['IPAddress'] = undefined;



  return exports;
}));



