/**
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AntiMalwareConfigurationRights', 'model/DirectoryListRights', 'model/FileExtensionListRights', 'model/FileListRights', 'model/IdentifiedFileRights'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./AntiMalwareConfigurationRights'), require('./DirectoryListRights'), require('./FileExtensionListRights'), require('./FileListRights'), require('./IdentifiedFileRights'));
  } else {
    // Browser globals (root is window)
    if (!root.Deepsecurity) {
      root.Deepsecurity = {};
    }
    root.Deepsecurity.AntiMalwareRights = factory(root.Deepsecurity.ApiClient, root.Deepsecurity.AntiMalwareConfigurationRights, root.Deepsecurity.DirectoryListRights, root.Deepsecurity.FileExtensionListRights, root.Deepsecurity.FileListRights, root.Deepsecurity.IdentifiedFileRights);
  }
}(this, function(ApiClient, AntiMalwareConfigurationRights, DirectoryListRights, FileExtensionListRights, FileListRights, IdentifiedFileRights) {
  'use strict';




  /**
   * The AntiMalwareRights model module.
   * @module model/AntiMalwareRights
   * @version 12.5.855
   */

  /**
   * Constructs a new <code>AntiMalwareRights</code>.
   * Anti malware rights details.
   * @alias module:model/AntiMalwareRights
   * @class
   */
  var exports = function() {
    var _this = this;






  };

  /**
   * Constructs a <code>AntiMalwareRights</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/AntiMalwareRights} obj Optional instance to populate.
   * @return {module:model/AntiMalwareRights} The populated <code>AntiMalwareRights</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('antiMalwareConfigurationRights')) {
        obj['antiMalwareConfigurationRights'] = AntiMalwareConfigurationRights.constructFromObject(data['antiMalwareConfigurationRights']);
      }
      if (data.hasOwnProperty('directoryListRights')) {
        obj['directoryListRights'] = DirectoryListRights.constructFromObject(data['directoryListRights']);
      }
      if (data.hasOwnProperty('fileListRights')) {
        obj['fileListRights'] = FileListRights.constructFromObject(data['fileListRights']);
      }
      if (data.hasOwnProperty('fileExtensionListRights')) {
        obj['fileExtensionListRights'] = FileExtensionListRights.constructFromObject(data['fileExtensionListRights']);
      }
      if (data.hasOwnProperty('identifiedFileRights')) {
        obj['identifiedFileRights'] = IdentifiedFileRights.constructFromObject(data['identifiedFileRights']);
      }
    }
    return obj;
  }

  /**
   * Rights related to anti malware configurations.
   * @member {module:model/AntiMalwareConfigurationRights} antiMalwareConfigurationRights
   */
  exports.prototype['antiMalwareConfigurationRights'] = undefined;
  /**
   * Rights related to directory lists.
   * @member {module:model/DirectoryListRights} directoryListRights
   */
  exports.prototype['directoryListRights'] = undefined;
  /**
   * Rights related to file lists.
   * @member {module:model/FileListRights} fileListRights
   */
  exports.prototype['fileListRights'] = undefined;
  /**
   * Rights related to file extension lists.
   * @member {module:model/FileExtensionListRights} fileExtensionListRights
   */
  exports.prototype['fileExtensionListRights'] = undefined;
  /**
   * Rights related to identified files.
   * @member {module:model/IdentifiedFileRights} identifiedFileRights
   */
  exports.prototype['identifiedFileRights'] = undefined;



  return exports;
}));



